
package jp.gr.java_conf.koto.notavacc.fa;

import java.util.*;
import jp.gr.java_conf.koto.util.*;

public abstract class XDFAState extends XNFAState {
    public final Map getMapInputToNextStates() {
        return new AbstractMap() {
            public boolean containsKey(Object key) {
                return getMapInputToNextState().containsKey(key);
            }
            public boolean containsValue(Object value) {
                return getMapInputToNextState().containsValue(Collections.singleton(value));
            }
            public Object get(Object key) {
                return Collections.singleton(getMapInputToNextState().get(key));
            }
            public Set keySet() {
                return getMapInputToNextState().keySet();
            }
            public int hashCode() {
                return getMapInputToNextState().hashCode();
            }
            public Set entrySet() {
                return new AbstractSet() {
                    public boolean contains(Object o) {
                        if (o instanceof Map.Entry)
                            return contains((Map.Entry) o);
                        return false;
                    }
                    public boolean contains(Map.Entry e) {
                        Map.Entry entry = new SimpleMapEntry(e.getKey(), Collections.singleton(e.getValue()));
                        return getMapInputToNextState().entrySet().contains(entry);
                    }
                    public int hashCode() {
                        return getMapInputToNextState().entrySet().hashCode();
                    }
                    public int size() {
                        return getMapInputToNextState().size();
                    }
                    public Iterator iterator() {
                        final Iterator it = getMapInputToNextState().entrySet().iterator();
                        return new AbstractIterator() {
                            public boolean hasNext() {
                                return it.hasNext();
                            }
                            public Object next() {
                                final Map.Entry entry = (Map.Entry) it.next();
                                return new AbstractMapEntry() {
                                    public Object getKey() {
                                        return entry.getKey();
                                    }
                                    public Object getValue() {
                                        return Collections.singleton(entry.getValue());
                                    }
                                };
                            }
                        };
                    }
                };
            }
        };
    }
    public final Set getEpsilonMoveStates() {
        return Collections.EMPTY_SET;
    }
    
    public abstract Map getMapInputToNextState();
    
    public abstract Set getAttributes();
}

