
package jp.gr.java_conf.koto.notavacc.fa;

import java.util.*;
import jp.gr.java_conf.koto.notavacc.util.*;

public class XSimpleFAState implements State {
    public XSimpleFAState() {
    }
    public XSimpleFAState(Object attribute) {
        addAttributes(attribute);
    }
    
    public Map inputToNextStates = new MultiMap();
    public Map getMapInputToNextStates() {
        return inputToNextStates;
    }
    public void link(Object input, XSimpleFAState next) {
        ((MultiMap) inputToNextStates).add(input, next);
    }
    
    public Set epsilonMoveStates = new LinkedHashSet();
    public Set getEpsilonMoveStates() {
        return epsilonMoveStates;
    }
    public void epsilonLink(XNFAState next) {
        epsilonMoveStates.add(next);
    }
    
    public Set attributes = new LinkedHashSet();
    public Set getAttributes() {
        return attributes;
    }
    public void addAttributes(Object attribute) {
        attributes.add(attribute);
    }
    
    private XNFAState lockedNFAState;
    public XNFAState toNFAState() {
        assert lockedDFAState == null;
        
        if (lockedNFAState == null) {
            lockedNFAState = new XNFAState() {
                public Map getMapInputToNextStates() {
                    return inputToNextStates;
                }
                public Set getEpsilonMoveStates() {
                    return epsilonMoveStates;
                }
                public Set getAttributes() {
                    return attributes;
                }
            };
            
            Iterator it1 = inputToNextStates.entrySet().iterator();
            while (it1.hasNext()) {
                Map.Entry entry = (Map.Entry) it1.next();
                Collection nextStates = (Collection) entry.getValue();
                Set newNextStates = new LinkedHashSet();
                Iterator it0 = nextStates.iterator();
                while (it0.hasNext()) {
                    XSimpleFAState next = (XSimpleFAState) it0.next();
                    newNextStates.add(next.toNFAState());
                }
                entry.setValue(newNextStates);
            }
            inputToNextStates = Collections.unmodifiableMap(inputToNextStates);
            
            Set newEpsilonMoveStates = new LinkedHashSet();
            Iterator it0 = epsilonMoveStates.iterator();
            while (it0.hasNext()) {
                Object next = (Object) it0.next();
                if (next instanceof XNFAState) {
                    newEpsilonMoveStates.add((XNFAState) next);
                } else {
                    newEpsilonMoveStates.add(((XSimpleFAState) next).toNFAState());
                }
            }
            epsilonMoveStates = Collections.unmodifiableSet(newEpsilonMoveStates);
            
            attributes = Collections.unmodifiableSet(attributes);
        }
        return lockedNFAState;
    }
    
    private XDFAState lockedDFAState;
    public XDFAState toDFAState() {
        assert lockedNFAState == null;
        
        if (lockedDFAState == null) {
            final Map inputToNextState = new LinkedHashMap();
            lockedDFAState = new XDFAState() {
                public Map getMapInputToNextState() {
                    return inputToNextState;
                }
                public Set getAttributes() {
                    return attributes;
                }
            };
            
            Iterator it1 = inputToNextStates.entrySet().iterator();
            while (it1.hasNext()) {
                Map.Entry entry = (Map.Entry) it1.next();
                Object input = entry.getKey();
                Collection nextStates = (Collection) entry.getValue();
                assert nextStates.size() <= 1;
                if (!nextStates.isEmpty()) {
                    XSimpleFAState next = (XSimpleFAState) nextStates.iterator().next();
                    inputToNextState.put(input, next);
                }
            }
            inputToNextStates = Collections.unmodifiableMap(inputToNextStates);
            
            assert epsilonMoveStates.isEmpty();
            epsilonMoveStates = Collections.unmodifiableSet(epsilonMoveStates);
            
            attributes = Collections.unmodifiableSet(attributes);
        }
        return lockedDFAState;
    }
    
}

