
package jp.gr.java_conf.koto.notavacc.util;

import java.util.*;
import jp.gr.java_conf.koto.util.*;
import jp.gr.java_conf.koto.notavacc.util.*;

public final class TreeStackMap extends AbstractMap {
    public static final TreeStackMap EMPTY_SET = new TreeStackMap();
    
    private final TreeStackMap parent;
    private final TreeStack entryStack;
    private TreeStackMap() {
        this.parent = null;
        this.entryStack = TreeStack.EMPTY_STACK;
    }
    private TreeStackMap(TreeStackMap parent, Object key, Object value) {
        this.parent = parent;
        this.entryStack = TreeStack.push(parent.entryStack, new SimpleMapEntry(key, value));
    }
    
    public static TreeStackMap push(TreeStackMap stack, Object key, Object value) {
        assert !stack.containsKey(key);
        return new TreeStackMap(stack, key, value);
    }
    
    public Set entrySet() {
        return new AbstractSet() {
            public Iterator iterator() {
                return entryStack.iterator();
            }
            public int size() {
                return entryStack.size();
            }
        };
    }
}

