#!/bin/bash

function generate {
    local jdk="$JAVA_HOME"
    case "`uname`" in
    CYGWIN*)
        jdk=`cygpath -u "$JAVA_HOME"`
        ;;
    esac
    
    pushd "$jdk" > /dev/null
    for class in `jar tf src.zip | egrep -e '^java/lang/[^/]+\.java' | sed -e "s:^.*/\([^/]*\)\.java:\1:"` ; do
        echo "$class { \"a\" }"
    done
    popd > /dev/null
}

echo '$parser JavaLangNames;' > JavaLangNames.notavacc
echo 'A { }' >> JavaLangNames.notavacc
echo 'B { }' >> JavaLangNames.notavacc
echo 'C { }' >> JavaLangNames.notavacc
echo 'D { }' >> JavaLangNames.notavacc
echo 'E { a:A b:B+ c:C d:D+ }' >> JavaLangNames.notavacc
echo '$absorber Absorber { e:A | f:B+ | g:C | h:D+ }' >> JavaLangNames.notavacc
echo '$absorber Absorber2 -> E & Absorber { e:A | f:B+ }' >> JavaLangNames.notavacc
echo '$parsable' >> JavaLangNames.notavacc
echo 'Test { ( String | Number ) l0:String* }' >> JavaLangNames.notavacc
generate >> JavaLangNames.notavacc

echo '$parser JavaLangNames2;' > JavaLangNames2.notavacc
echo 'A { }' >> JavaLangNames2.notavacc
echo 'B { }' >> JavaLangNames2.notavacc
echo 'C { }' >> JavaLangNames2.notavacc
echo 'D { }' >> JavaLangNames2.notavacc
echo 'E { a:A b:B+ c:C d:D+ }' >> JavaLangNames2.notavacc
echo '$absorber Absorber { e:A | f:B+ | g:C | h:D+ }' >> JavaLangNames2.notavacc
echo '$absorber Absorber2 -> E & Absorber { e:A | f:B+ }' >> JavaLangNames2.notavacc
echo '$parsable' >> JavaLangNames2.notavacc
echo "Test {" >> JavaLangNames2.notavacc
echo '( String | Number )' >> JavaLangNames2.notavacc
echo 'l0:String*' >> JavaLangNames2.notavacc
for i in `seq 0 32` ; do
    echo "l$i:\"$i\"" >> JavaLangNames2.notavacc
done
echo "}" >> JavaLangNames2.notavacc
generate >> JavaLangNames2.notavacc

