
import java.util.*;
import java.io.*;
import junit.framework.*;
import parser.*;
import parser.WhiteTokenTest.*;

public class White_Test extends TestCase {
    public static void main(String[] args) {
        junit.textui.TestRunner.main(new String[] { White_Test.class.getName() });
    }
    
    public White_Test(String name) {
        super(name);
    }
    
    private StringBuffer input = new StringBuffer("abAcdBefCghDij");
    private Object[] spec = new Object[] { "Test",
        "a",
        "b",
        new Object[] { "P",
            "A",
            "c",
            "d",
            new Object[] { "Q",
                new Object[] { "R",
                },
            },
            "B",
            "e",
            "f",
            new Object[] { "S",
                "C",
            },
            "g",
            "h",
            "D",
        },
        "i",
        "j",
    };
    
    public void test() throws IOException, ParseException {
        Node output = new WhiteTokenTest().parseTest("test", input, 8);
        //System.err.println(output);
        check(output, spec);
    }
    private void check(Node output, Object[] spec) {
        Node[] o = (Node[]) output.getChildNodes().toArray(new Node[0]);
        String nodeType;
        nodeType = output.getClass().getName();
        nodeType = nodeType.substring(nodeType.lastIndexOf('.') + 1);
        nodeType = nodeType.substring(nodeType.lastIndexOf('$') + 1);
        assertEquals(nodeType, spec[0]);
        assertEquals(o.length, spec.length - 1);
        for (int i = 0; i < o.length; i++) {
            assertEquals(o[i] instanceof Token, spec[i + 1] instanceof String);
            if (o[i] instanceof Token) {
                assertEquals(((Token) o[i]).getImage(), (String) spec[i + 1]);
            } else {
                check(o[i], (Object[]) spec[i + 1]);
            }
        }
    }
}
