                                                                                // (JavaCodeGenerator.meta.java:539)
package parser;                                                                 // (JavaCodeGenerator.meta.java:541)
                                                                                // (JavaCodeGenerator.meta.java:542)
/**
 * A syntax representation, generated by &#xAC;&lt;&gt;&lt;&#x222A;&#x222A; (notavaCC) 1.9.0.  Licensed under GPL usually.
 * <p>
 * {@link DanglingElseSyntax#parseRoot}
 * parses a text and generates an abstruct syntax tree.
 * A node of the tree is an instance of sub-types of {@link Node}.
 * <p>
 * This class and any nested classes in this class are <strong>not synchronized</strong>.
 *
 */
public class DanglingElseSyntax extends DanglingElseSyntaxTables {              // (JavaCodeGenerator.meta.java:627)
    /**
     * Constructs a parser.
     * @since    notavaCC 1.0
     */
    public DanglingElseSyntax() {                                               // (JavaCodeGenerator.meta.java:649)
    }                                                                           // (JavaCodeGenerator.meta.java:650)
                                                                                // (JavaCodeGenerator.meta.java:652)
                                                                                // (JavaCodeGenerator.meta.java:653)
    /**
     * Describes the EOF.
     * @see     DanglingElseSyntax.Token#getSymbolID()
     * @since    notavaCC 1.0
     */
    public static final int EOF_TOKEN = 0;                                      // (JavaCodeGenerator.meta.java:679)
    /**
     * Describes the terminal symbol <code>WHITE_SPACES</code>.
     * @see     DanglingElseSyntax.Token#getSymbolID()
     */
    public static final int TOKEN_WHITE_SPACES = 1;                             // (JavaCodeGenerator.meta.java:716)
                                                                                // (JavaCodeGenerator.meta.java:739)
                                                                                // (JavaCodeGenerator.meta.java:740)
                                                                                // (JavaCodeGenerator.meta.java:741)
    /**
     * Creates a node of an abstract syntax tree.
     * <p>
     * <p>
     * The type of the node to create is described by <code>symbolID</code> as follows.
     * <table border=1>
     * <tr><th><code>symbolID</code></th><th>type to create</th></tr>
     * <tr>
     *   <td>{@link Root#ID}</td>
     *   <td>{@link DanglingElseSyntax.Root}</td>
     * </tr>
     * <tr>
     *   <td>{@link SingleLineStatement#ID}</td>
     *   <td>{@link DanglingElseSyntax.SingleLineStatement}</td>
     * </tr>
     * <tr>
     *   <td>{@link LongIf#ID}</td>
     *   <td>{@link DanglingElseSyntax.LongIf}</td>
     * </tr>
     * <tr>
     *   <td>{@link ShortIf#ID}</td>
     *   <td>{@link DanglingElseSyntax.ShortIf}</td>
     * </tr>
     * </table>
     * <p>
     * The default implementation by the <code>DanglingElseSyntax</code> is equivalent to <code>createNode(symbolID, parameters, false)</code>.
     *
     * @param   symbolID
     *      the kind of the node to create.
     * @param   parameters
     *      the parameters to initialize the node.
     * @return
     *      a created node.
     * @throws   ParseException
     *      if the text to parse doesn't satisfy some requirements.
     * @since    notavaCC 1.0
     */
    protected Node createNode(int symbolID, NodeInitializationParameters parameters) throws ParseException {    // (JavaCodeGenerator.meta.java:808)
        return createNode(symbolID, parameters, false);                         // (JavaCodeGenerator.meta.java:809)
    }                                                                           // (JavaCodeGenerator.meta.java:810)
                                                                                // (JavaCodeGenerator.meta.java:811)
    /**
     * Creates a node of an abstract syntax tree.  The created node is a instance of a class in {@link DanglingElseSyntax.Default}.
     *
     * @param   symbolID
     *      the kind of the node to create.  See {@link #createNode(int, DanglingElseSyntax.NodeInitializationParameters)}.
     * @param   parameters
     *      the parameters to initialize the node.
     * @param   compact
     *      if <code>true</code>, the method creates a compact node, which have only labeled children.
     * @return  a created node.
     * @since   notavaCC 1.0
     */
    protected final DanglingElseSyntax.Default.Node createNode(int symbolID, NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:841)
        switch(symbolID) {                                                      // (JavaCodeGenerator.meta.java:842)
        case 9:                                                                 // (JavaCodeGenerator.meta.java:849)
            return new DanglingElseSyntax.Default.Root(parameters, compact);    // (JavaCodeGenerator.meta.java:850)
        case 10:                                                                // (JavaCodeGenerator.meta.java:849)
            return new DanglingElseSyntax.Default.SingleLineStatement(parameters, compact);    // (JavaCodeGenerator.meta.java:850)
        case 11:                                                                // (JavaCodeGenerator.meta.java:849)
            return new DanglingElseSyntax.Default.LongIf(parameters, compact);    // (JavaCodeGenerator.meta.java:850)
        case 12:                                                                // (JavaCodeGenerator.meta.java:849)
            return new DanglingElseSyntax.Default.ShortIf(parameters, compact);    // (JavaCodeGenerator.meta.java:850)
        }                                                                       // (JavaCodeGenerator.meta.java:854)
        throw new java.lang.AssertionError("Node creation failed.");            // (JavaCodeGenerator.meta.java:855)
    }                                                                           // (JavaCodeGenerator.meta.java:856)
                                                                                // (JavaCodeGenerator.meta.java:857)
    protected DanglingElseSyntax.AmbiguityAbsorber createAmbiguityAbsorber(java.util.List nodes) throws ParseException {    // (JavaCodeGenerator.meta.java:860)
        DanglingElseSyntax.AmbiguityAbsorber result;                            // (JavaCodeGenerator.meta.java:861)
        result = Default.DanglingElseAbsorber.tryToCreate(nodes);               // (JavaCodeGenerator.meta.java:866)
        if (result != null)                                                     // (JavaCodeGenerator.meta.java:867)
            return result;                                                      // (JavaCodeGenerator.meta.java:868)
        return null;                                                            // (JavaCodeGenerator.meta.java:871)
    }                                                                           // (JavaCodeGenerator.meta.java:872)
    private void __throwAmbiguousGrammerError__notavacc_reserved(int symbolID, java.util.List nodes) throws ParseException.AmbiguousGrammarError {    // (JavaCodeGenerator.meta.java:874)
        java.lang.String[] symbolIDToName = {                                   // (JavaCodeGenerator.meta.java:875)
            "<EOF>",                                                            // (JavaCodeGenerator.meta.java:877)
            "WHITE_SPACES",                                                     // (JavaCodeGenerator.meta.java:877)
            "\"(\"",                                                            // (JavaCodeGenerator.meta.java:877)
            "\")\"",                                                            // (JavaCodeGenerator.meta.java:877)
            "\";\"",                                                            // (JavaCodeGenerator.meta.java:877)
            "\"else\"",                                                         // (JavaCodeGenerator.meta.java:877)
            "\"expr\"",                                                         // (JavaCodeGenerator.meta.java:877)
            "\"if\"",                                                           // (JavaCodeGenerator.meta.java:877)
            "\"statement\"",                                                    // (JavaCodeGenerator.meta.java:877)
            "Root",                                                             // (JavaCodeGenerator.meta.java:877)
            "SingleLineStatement",                                              // (JavaCodeGenerator.meta.java:877)
            "LongIf",                                                           // (JavaCodeGenerator.meta.java:877)
            "ShortIf",                                                          // (JavaCodeGenerator.meta.java:877)
            "statement",                                                        // (JavaCodeGenerator.meta.java:877)
            "Anony0",                                                           // (JavaCodeGenerator.meta.java:877)
        };                                                                      // (JavaCodeGenerator.meta.java:879)
        java.io.StringWriter buffer = new java.io.StringWriter();               // (JavaCodeGenerator.meta.java:880)
        java.io.PrintWriter writer = new java.io.PrintWriter(buffer);           // (JavaCodeGenerator.meta.java:881)
        writer.println("DETECTED UNABSORBED AMBIGUITY OF " + "DanglingElseSyntax.notavacc");    // (JavaCodeGenerator.meta.java:882)
        writer.println("This message is for the developer of the parser generated by notavaCC.");    // (JavaCodeGenerator.meta.java:883)
        writer.println("If you are not the developer of the program that output this message, contact the developper.");    // (JavaCodeGenerator.meta.java:884)
        writer.println("----");                                                 // (JavaCodeGenerator.meta.java:885)
        writer.println(symbolIDToName[symbolID] + " is ambiguous.  The following are the possible trees of the input, but there is no $absorber that absorbs this ambiguity.");    // (JavaCodeGenerator.meta.java:886)
        nodes = new java.util.ArrayList(nodes);                                 // (JavaCodeGenerator.meta.java:887)
        for (int i = 0; i < nodes.size(); i++) {                                // (JavaCodeGenerator.meta.java:888)
            writer.println("[Tree " + i + "]");                                 // (JavaCodeGenerator.meta.java:889)
            writer.println(nodes.get(i));                                       // (JavaCodeGenerator.meta.java:890)
        }                                                                       // (JavaCodeGenerator.meta.java:891)
        writer.println("----");                                                 // (JavaCodeGenerator.meta.java:892)
        writer.print("Perhaps, an easy way to avoid this error is to add the following line to " + "DanglingElseSyntax.notavacc");    // (JavaCodeGenerator.meta.java:893)
        writer.print(" before " + "`DanglingElseAbsorber\' (line 15, column 11)");    // (JavaCodeGenerator.meta.java:895)
        writer.println(".");                                                    // (JavaCodeGenerator.meta.java:896)
        writer.println();                                                       // (JavaCodeGenerator.meta.java:897)
        writer.print("$absorber AbsorberNameYouLike { ");                       // (JavaCodeGenerator.meta.java:898)
        for (int i = 0; i < nodes.size(); i++) {                                // (JavaCodeGenerator.meta.java:899)
            if (i != 0)                                                         // (JavaCodeGenerator.meta.java:900)
                writer.print(" | ");                                            // (JavaCodeGenerator.meta.java:901)
                                                                                // (JavaCodeGenerator.meta.java:902)
            java.lang.String className = nodes.get(i).getClass().getName();     // (JavaCodeGenerator.meta.java:903)
            className = className.substring(className.lastIndexOf('.') + 1);    // (JavaCodeGenerator.meta.java:904)
            className = className.substring(className.lastIndexOf('$') + 1);    // (JavaCodeGenerator.meta.java:905)
            writer.print("label" + i + ":" + className);                        // (JavaCodeGenerator.meta.java:906)
        }                                                                       // (JavaCodeGenerator.meta.java:907)
        writer.println(" }");                                                   // (JavaCodeGenerator.meta.java:908)
                                                                                // (JavaCodeGenerator.meta.java:909)
        writer.close();                                                         // (JavaCodeGenerator.meta.java:910)
        throw new ParseException.AmbiguousGrammarError(buffer.toString());      // (JavaCodeGenerator.meta.java:911)
    }                                                                           // (JavaCodeGenerator.meta.java:912)
                                                                                // (JavaCodeGenerator.meta.java:914)
    /**
     * This method is called when an whole abstract syntax tree is built.
     * The tree this method returns is regarded as the result of parsing.
     *
     * <p>
     *
     * @param   root
     *      the root of the tree generated by {@link DanglingElseSyntax#createNode}.
     * @return  the result of parsing.
     * @since   notavaCC 1.0
     */
    protected Node modifyWholeTree(Node root) throws ParseException {           // (JavaCodeGenerator.meta.java:939)
        return root;                                                            // (JavaCodeGenerator.meta.java:940)
    }                                                                           // (JavaCodeGenerator.meta.java:941)
                                                                                // (JavaCodeGenerator.meta.java:942)
                                                                                // (JavaCodeGenerator.meta.java:943)
    /**
     * Gets the <code>java.lang.CharSequence</code> that represents the text in the given file.
     * <p>
     *
     * @param   file
     *      a file.
     * @param   charsetName
     *      the charset name of the file, or <code>null</code> for the default charset.
     * @return
     *      the <code>java.lang.CharSequence</code> that represents the text in the <code>file</code>.
     * @throws   java.io.IOException
     *      if some error is occured for the access to the <code>file</code>.
     * @since    notavaCC 1.0
     */
    protected final java.lang.CharSequence toCharSequence(java.io.File file, java.lang.String charsetName) throws java.io.IOException {    // (JavaCodeGenerator.meta.java:977)
        java.io.FileInputStream fis = null;                                     // (JavaCodeGenerator.meta.java:978)
        java.io.InputStreamReader reader = null;                                // (JavaCodeGenerator.meta.java:979)
        java.nio.channels.FileChannel fc = null;                                // (JavaCodeGenerator.meta.java:980)
        try {                                                                   // (JavaCodeGenerator.meta.java:981)
            fis = new java.io.FileInputStream(file);                            // (JavaCodeGenerator.meta.java:982)
            if (charsetName == null)                                            // (JavaCodeGenerator.meta.java:983)
                reader = new java.io.InputStreamReader(fis);                    // (JavaCodeGenerator.meta.java:984)
            else                                                                // (JavaCodeGenerator.meta.java:985)
                reader = new java.io.InputStreamReader(fis, charsetName);       // (JavaCodeGenerator.meta.java:986)
            java.nio.charset.Charset charset;                                   // (JavaCodeGenerator.meta.java:987)
            try {                                                               // (JavaCodeGenerator.meta.java:988)
                charset = java.nio.charset.Charset.forName(reader.getEncoding());    // (JavaCodeGenerator.meta.java:989)
            } catch(java.nio.charset.UnsupportedCharsetException x) {           // (JavaCodeGenerator.meta.java:990)
                charset = null;                                                 // (JavaCodeGenerator.meta.java:991)
            }                                                                   // (JavaCodeGenerator.meta.java:992)
            if (charset != null) {                                              // (JavaCodeGenerator.meta.java:993)
                java.nio.charset.CharsetDecoder decoder = charset.newDecoder();    // (JavaCodeGenerator.meta.java:994)
                fc = fis.getChannel();                                          // (JavaCodeGenerator.meta.java:995)
                int size = (int) fc.size();                                     // (JavaCodeGenerator.meta.java:996)
                java.nio.MappedByteBuffer bb = fc.map(java.nio.channels.FileChannel.MapMode.READ_ONLY, 0, size);    // (JavaCodeGenerator.meta.java:997)
                return decoder.decode(bb);                                      // (JavaCodeGenerator.meta.java:998)
            } else {                                                            // (JavaCodeGenerator.meta.java:999)
                long length = file.length();                                    // (JavaCodeGenerator.meta.java:1000)
                if (length <= 0)                                                // (JavaCodeGenerator.meta.java:1001)
                    length = 1;                                                 // (JavaCodeGenerator.meta.java:1002)
                else if (length > java.lang.Integer.MAX_VALUE)                  // (JavaCodeGenerator.meta.java:1003)
                    length = java.lang.Integer.MAX_VALUE;                       // (JavaCodeGenerator.meta.java:1004)
                java.lang.StringBuffer result = new java.lang.StringBuffer((int) length);    // (JavaCodeGenerator.meta.java:1005)
                char[] buffer = new char[1024];                                 // (JavaCodeGenerator.meta.java:1006)
                for(;;) {                                                       // (JavaCodeGenerator.meta.java:1007)
                    int size = reader.read(buffer);                             // (JavaCodeGenerator.meta.java:1008)
                    if (size < 0)                                               // (JavaCodeGenerator.meta.java:1009)
                        break;                                                  // (JavaCodeGenerator.meta.java:1010)
                    result.append(buffer, 0, size);                             // (JavaCodeGenerator.meta.java:1011)
                }                                                               // (JavaCodeGenerator.meta.java:1012)
                return result;                                                  // (JavaCodeGenerator.meta.java:1013)
            }                                                                   // (JavaCodeGenerator.meta.java:1014)
        } finally {                                                             // (JavaCodeGenerator.meta.java:1015)
            if (fc != null)                                                     // (JavaCodeGenerator.meta.java:1016)
                fc.close();                                                     // (JavaCodeGenerator.meta.java:1017)
            if (reader != null)                                                 // (JavaCodeGenerator.meta.java:1018)
                reader.close();                                                 // (JavaCodeGenerator.meta.java:1019)
            else if (fis != null)                                               // (JavaCodeGenerator.meta.java:1020)
                fis.close();                                                    // (JavaCodeGenerator.meta.java:1021)
        }                                                                       // (JavaCodeGenerator.meta.java:1022)
    }                                                                           // (JavaCodeGenerator.meta.java:1023)
    /**
     * Gets the <code>java.lang.CharSequence</code> that represents the text from the given character stream.
     * <p>
     * This method reads characters from the stream until the end of the stream has been reached, and returns the <code>java.lang.CharSequence</code> that represents the characters.
     *
     * @param   reader
     *      a character stream.  This method will not <code>close</code> it.
     * @return
     *      the <code>java.lang.CharSequence</code> that represents the text from the <code>reader</code>.
     * @throws   java.io.IOException
     *      if some error is occured for the access to the <code>reader</code>.
     * @since    notavaCC 1.0
     */
    protected final java.lang.CharSequence toCharSequence(java.io.Reader reader) throws java.io.IOException {    // (JavaCodeGenerator.meta.java:1085)
        java.lang.StringBuffer result = new java.lang.StringBuffer();           // (JavaCodeGenerator.meta.java:1086)
        char[] buffer = new char[1024];                                         // (JavaCodeGenerator.meta.java:1087)
        for (;;) {                                                              // (JavaCodeGenerator.meta.java:1088)
            int size = reader.read(buffer);                                     // (JavaCodeGenerator.meta.java:1089)
            if (size < 0)                                                       // (JavaCodeGenerator.meta.java:1090)
                break;                                                          // (JavaCodeGenerator.meta.java:1091)
            result.append(buffer, 0, size);                                     // (JavaCodeGenerator.meta.java:1092)
        }                                                                       // (JavaCodeGenerator.meta.java:1093)
        return result;                                                          // (JavaCodeGenerator.meta.java:1094)
    }                                                                           // (JavaCodeGenerator.meta.java:1095)
                                                                                // (JavaCodeGenerator.meta.java:1096)
                                                                                // (JavaCodeGenerator.meta.java:1097)
    /**
     * Creates a lexical analyzer.
     * <p>
     * @param   sourceName
     *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
     * @param   text
     *      the text to analyze.
     * @param   tabStop
     *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
     * @return
     *      the lexical analyzer that analyze the <code>text</code>.
     * @throws   ParseException
     *      if the text to parse doesn't satisfy some requirements.
     * @since    notavaCC 1.0
     */
    protected DanglingElseSyntax.LexicalAnalyzer createLexicalAnalyzer(java.lang.String sourceName, java.lang.CharSequence text, int tabStop) throws ParseException {    // (JavaCodeGenerator.meta.java:1139)
        return new DanglingElseSyntax.Default.LexicalAnalyzer(sourceName, text, tabStop);    // (JavaCodeGenerator.meta.java:1140)
    }                                                                           // (JavaCodeGenerator.meta.java:1141)
                                                                                // (JavaCodeGenerator.meta.java:1142)
                                                                                // (JavaCodeGenerator.meta.java:1143)
    /**
     * Contains <code>private</code> fields that is used in order to create a node.  The constructor is <code>private</code>.
     * <p>
     *
     * @since   notavaCC 1.0
     */
    protected static class NodeInitializationParameters {                       // (JavaCodeGenerator.meta.java:1160)
        private NodeInitializationParameters() {                                // (JavaCodeGenerator.meta.java:1161)
        }                                                                       // (JavaCodeGenerator.meta.java:1162)
        private Node[] childNodes;                                              // (JavaCodeGenerator.meta.java:1163)
        private java.util.List labelBitsList;                                   // (JavaCodeGenerator.meta.java:1164)
    }                                                                           // (JavaCodeGenerator.meta.java:1165)
    /**
     * A visitor.
     * <p>
     *
     * @see     DanglingElseSyntax.Visitor#visitAll(DanglingElseSyntax.Node)
     * @since   notavaCC 1.0
     */
    public static class Visitor {                                               // (JavaCodeGenerator.meta.java:1201)
                                                                                // (JavaCodeGenerator.meta.java:1202)
        /**
         * Traverses a (sub-)tree.
         * <p>
         * The default implementation is as follows.  The user can override the method and change the behavior at will.
         * <pre>
         * visitNode(node);
         *
         * java.util.Iterator it = node.getChildNodes().iterator();
         * while (it.hasNext()) {
         *     DanglingElseSyntax.Node child = (DanglingElseSyntax.Node) it.next();
         *     visitAll(child);
         * }
         * </pre>
         *
         * @param   node
         *      the root of the (sub-)tree to traverse.
         * @since   notavaCC 1.0
         */
        public void visitAll(DanglingElseSyntax.Node node) {                    // (JavaCodeGenerator.meta.java:1242)
            visitNode(node);                                                    // (JavaCodeGenerator.meta.java:1243)
                                                                                // (JavaCodeGenerator.meta.java:1244)
            java.util.Iterator it = node.getChildNodes().iterator();            // (JavaCodeGenerator.meta.java:1245)
            while (it.hasNext()) {                                              // (JavaCodeGenerator.meta.java:1246)
                DanglingElseSyntax.Node child = (DanglingElseSyntax.Node) it.next();    // (JavaCodeGenerator.meta.java:1247)
                visitAll(child);                                                // (JavaCodeGenerator.meta.java:1248)
            }                                                                   // (JavaCodeGenerator.meta.java:1249)
        }                                                                       // (JavaCodeGenerator.meta.java:1250)
        /**
         * Call <code>visit</code>.
         * <p>
         * The default implementation is to call all the method, that is defined in this class, whose name is <code>visit</code>, and that can take <code>node</code> as the argument.  For example, if <code>node instanceof {@link DanglingElseSyntax.Token}</code>, both of {@link #visit(DanglingElseSyntax.Node)} and {@link #visit(DanglingElseSyntax.Token)} is called.  The order of the call is undefined.  The user can override the method and change the behavior at will.
         *
         * @param   node
         *      a node.
         * @since   notavaCC 1.0
         */
        protected void visitNode(DanglingElseSyntax.Node node) {                // (JavaCodeGenerator.meta.java:1272)
            visit((DanglingElseSyntax.Node) node);                              // (JavaCodeGenerator.meta.java:1273)
                                                                                // (JavaCodeGenerator.meta.java:1274)
            if (node instanceof DanglingElseSyntax.Token)                       // (JavaCodeGenerator.meta.java:1275)
                visit((DanglingElseSyntax.Token) node);                         // (JavaCodeGenerator.meta.java:1276)
                                                                                // (JavaCodeGenerator.meta.java:1298)
            if (node instanceof DanglingElseSyntax.Root)                        // (JavaCodeGenerator.meta.java:1306)
                visit((DanglingElseSyntax.Root) node);                          // (JavaCodeGenerator.meta.java:1307)
                                                                                // (JavaCodeGenerator.meta.java:1298)
            if (node instanceof DanglingElseSyntax.SingleLineStatement)         // (JavaCodeGenerator.meta.java:1306)
                visit((DanglingElseSyntax.SingleLineStatement) node);           // (JavaCodeGenerator.meta.java:1307)
                                                                                // (JavaCodeGenerator.meta.java:1298)
            if (node instanceof DanglingElseSyntax.IfThenElseStatement) {       // (JavaCodeGenerator.meta.java:1309)
                visit((DanglingElseSyntax.IfThenElseStatement) node);           // (JavaCodeGenerator.meta.java:1310)
                                                                                // (JavaCodeGenerator.meta.java:1311)
                if (node instanceof DanglingElseSyntax.LongIf)                  // (JavaCodeGenerator.meta.java:1306)
                    visit((DanglingElseSyntax.LongIf) node);                    // (JavaCodeGenerator.meta.java:1307)
                if (node instanceof DanglingElseSyntax.ShortIf)                 // (JavaCodeGenerator.meta.java:1306)
                    visit((DanglingElseSyntax.ShortIf) node);                   // (JavaCodeGenerator.meta.java:1307)
            }                                                                   // (JavaCodeGenerator.meta.java:1317)
        }                                                                       // (JavaCodeGenerator.meta.java:1325)
                                                                                // (JavaCodeGenerator.meta.java:1326)
        /**
         * Called for a visited node.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.Node node) {                    // (JavaCodeGenerator.meta.java:1344)
        }                                                                       // (JavaCodeGenerator.meta.java:1345)
        /**
         * Called for a visited {@link DanglingElseSyntax.Token}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.Token node) {                   // (JavaCodeGenerator.meta.java:1363)
        }                                                                       // (JavaCodeGenerator.meta.java:1364)
        /**
         * Called for a visited {@link DanglingElseSyntax.Root}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.Root node) {                    // (JavaCodeGenerator.meta.java:1393)
        }                                                                       // (JavaCodeGenerator.meta.java:1394)
        /**
         * Called for a visited {@link DanglingElseSyntax.SingleLineStatement}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.SingleLineStatement node) {     // (JavaCodeGenerator.meta.java:1393)
        }                                                                       // (JavaCodeGenerator.meta.java:1394)
        /**
         * Called for a visited {@link DanglingElseSyntax.IfThenElseStatement}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.IfThenElseStatement node) {     // (JavaCodeGenerator.meta.java:1393)
        }                                                                       // (JavaCodeGenerator.meta.java:1394)
        /**
         * Called for a visited {@link DanglingElseSyntax.LongIf}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.LongIf node) {                  // (JavaCodeGenerator.meta.java:1393)
        }                                                                       // (JavaCodeGenerator.meta.java:1394)
        /**
         * Called for a visited {@link DanglingElseSyntax.ShortIf}.
         * <p>
         *
         * @param   node
         *      a visited node.
         * @see      #visitAll
         * @since    notavaCC 1.0
         */
        protected void visit(DanglingElseSyntax.ShortIf node) {                 // (JavaCodeGenerator.meta.java:1393)
        }                                                                       // (JavaCodeGenerator.meta.java:1394)
    }                                                                           // (JavaCodeGenerator.meta.java:1398)
                                                                                // (JavaCodeGenerator.meta.java:1401)
                                                                                // (JavaCodeGenerator.meta.java:1402)
    /**
     * A node of the abstract syntax tree that is the result of parsing.
     * <p>
     *
     * @since   notavaCC 1.0
     */
    public static interface Node {                                              // (JavaCodeGenerator.meta.java:1429)
        /**
         * Returns the list of the child nodes of <code>this</code>.
         *
         * @return  the list of the child nodes of <code>this</code>.
         * @since   notavaCC 1.0
         */
        public java.util.List getChildNodes();                                  // (JavaCodeGenerator.meta.java:1464)
                                                                                // (JavaCodeGenerator.meta.java:1465)
        public AmbiguityAbsorber getWrappedAmbiguityAbsorber();                 // (JavaCodeGenerator.meta.java:1468)
    } // interface Node                                                         // (JavaCodeGenerator.meta.java:1470)
                                                                                // (JavaCodeGenerator.meta.java:1471)
    /**
     * A token, which is a fragment of a parsed text.
     * <p>
     * A token is a fragment of a parsed text (a source).  Tokens are usually constructed by {@link DanglingElseSyntax.LexicalAnalyzer}s.  This class introduces the methods that represent what is the source of the token and where the token is placed in the source ({@link #getSourceName}, {@link #getIndex}, {@link #getLine}, {@link #getColumn}), however, the strict specification of the returned value is defined by the generator of the token, e.g., <code>LexicalAnalyzer</code>s.  Also, these methods may be unsuported and may throw {@link java.lang.UnsupportedOperationException}.
     *
     * @since   notavaCC 1.0
     */
    public static interface Token extends Node {                                // (JavaCodeGenerator.meta.java:1491)
        /**
         * Returns the kind of <code>this</code> token.
         * <p>
         * The result value should be one of the following:</p>
         *
         * <table border=1>
         * <tr><th>value</th><th>described token</th></tr>
         * <tr>
         *   <td>{@link DanglingElseSyntax#EOF_TOKEN}</td>
         *   <td><tt>&lt;EOF&gt;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link DanglingElseSyntax#TOKEN_WHITE_SPACES}</td>
         *   <td><tt>WHITE_SPACES</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 2}</td>
         *   <td><tt>&quot;(&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 3}</td>
         *   <td><tt>&quot;)&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 4}</td>
         *   <td><tt>&quot;;&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 5}</td>
         *   <td><tt>&quot;else&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 6}</td>
         *   <td><tt>&quot;expr&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 7}</td>
         *   <td><tt>&quot;if&quot;</tt></td>
         * </tr>
         * <tr>
         *   <td>{@link 8}</td>
         *   <td><tt>&quot;statement&quot;</tt></td>
         * </tr>
         * </table>
         *
         * @return  the kind of <code>this</code> token.
         * @since   notavaCC 1.0
         */
        public int getSymbolID();                                               // (JavaCodeGenerator.meta.java:1561)
                                                                                // (JavaCodeGenerator.meta.java:1562)
        /**
         * Returnds <code>true</code> if <code>this</code> is a white token.
         * <p>
         * This method returns <code>true</code> if and only if <code>getSymbolID()</code> is one of the following:
         * <ul>
         *   <td>{@link DanglingElseSyntax#TOKEN_WHITE_SPACES}</td>
         * </ul>
         *
         * @return  <code>true</code> if <code>this</code> is a while token.
         * @since   notavaCC 1.0
         */
        public boolean isWhite();                                               // (JavaCodeGenerator.meta.java:1612)
                                                                                // (JavaCodeGenerator.meta.java:1613)
        /**
         * Returns the string <code>this</code> token corresponds to.
         * <p>
         * If the string contains some meta notation like Unicode escapes, the returned value is the represented string (e.g., A) rather than the representation (e.g., \u005Cu0041).  If not, the returned value is the same as {@link #getOriginalImage()}.
         *
         * @return  the string <code>this</code> token corresponds to.
         * @see     DanglingElseSyntax.Token#getOriginalImage()
         * @since   notavaCC 1.0
         */
        public java.lang.String getImage();                                     // (JavaCodeGenerator.meta.java:1635)
                                                                                // (JavaCodeGenerator.meta.java:1636)
        /**
         * Returns the string <code>this</code> token corresponds to.
         * <p>
         * If the string contains some meta notation like Unicode escapes, the returned value is the representation (e.g., \u005Cu0041) rather than the represented string (e.g., A).  If not, the returned value is the same as {@link #getImage()}.
         *
         * @return  the string <code>this</code> token corresponds to.
         * @see     DanglingElseSyntax.Token#getImage()
         * @since   notavaCC 1.0
         */
        public java.lang.String getOriginalImage();                             // (JavaCodeGenerator.meta.java:1658)
                                                                                // (JavaCodeGenerator.meta.java:1659)
        /**
         * Returns the source name <code>this</code> token coressponds to.
         *
         * @return  the source name <code>this</code> token coressponds to.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public java.lang.String getSourceName() throws java.lang.UnsupportedOperationException;    // (JavaCodeGenerator.meta.java:1679)
                                                                                // (JavaCodeGenerator.meta.java:1680)
        /**
         * Returns the zero-based index number in the source where <code>this</code> token begins.
         *
         * @return  the index number in the source where <code>this</code> token begins.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public int getIndex() throws java.lang.UnsupportedOperationException;    // (JavaCodeGenerator.meta.java:1700)
        /**
         * Returns the one-based line number in the source where <code>this</code> token begins.
         *
         * @return  the line number in the source where <code>this</code> token begins.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public int getLine() throws java.lang.UnsupportedOperationException;    // (JavaCodeGenerator.meta.java:1720)
        /**
         * Returns the one-based column number in the source where <code>this</code> token begins.
         *
         * @return  the column number in the source where <code>this</code> token begins.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public int getColumn() throws java.lang.UnsupportedOperationException;    // (JavaCodeGenerator.meta.java:1740)
                                                                                // (JavaCodeGenerator.meta.java:1741)
        /**
         * Returns the {@linkplain #getOriginalImage image} and the position of <code>this</code> token if supported.
         * For instance, <code>`identifier' (line 2, column 3)</code> or <code>`identifier'</code>.
         * The format is not specified strictly.
         *
         * @return  the {@linkplain #getOriginalImage image} and the parenthesized position of <code>this</code> token.
         * @since   notavaCC 1.0
         */
        public java.lang.String toString();                                     // (JavaCodeGenerator.meta.java:1760)
    } // interface Token                                                        // (JavaCodeGenerator.meta.java:1761)
                                                                                // (JavaCodeGenerator.meta.java:1762)
                                                                                // (JavaCodeGenerator.meta.java:1763)
    /**
     * Generator of a sequence of {@link DanglingElseSyntax.Token}s.
     *
     * @since   notavaCC 1.0
     */
    public static abstract class LexicalAnalyzer {                              // (JavaCodeGenerator.meta.java:1778)
        /**
         * Returns the next token in the sequence.
         * <p>
         * If there is no tokens, the {@linkplain DanglingElseSyntax.Token#getSymbolID() symbol ID} of the returned value should be {@link DanglingElseSyntax#EOF_TOKEN}, but the {@linkplain DanglingElseSyntax.Token#getImage() image} or the {@linkplain DanglingElseSyntax.Token#getIndex() index} etc. are not specified (may be {@linkplain java.lang.UnsupportedOperationException unsupported}).
         *
         * @return  the next token in the sequence.
         * @since   notavaCC 1.0
         */
        public abstract Token next() throws ParseException;                     // (JavaCodeGenerator.meta.java:1798)
    } // LexicalAnalyzer                                                        // (JavaCodeGenerator.meta.java:1799)
                                                                                // (JavaCodeGenerator.meta.java:1800)
                                                                                // (JavaCodeGenerator.meta.java:1801)
    public static interface AmbiguityAbsorber extends Node {                    // (JavaCodeGenerator.meta.java:1804)
    }                                                                           // (JavaCodeGenerator.meta.java:1805)
                                                                                // (JavaCodeGenerator.meta.java:1806)
                                                                                // (JavaCodeGenerator.meta.java:1826)
    public static interface DanglingElseAbsorber extends DanglingElseSyntax.AmbiguityAbsorber, DanglingElseSyntax.IfThenElseStatement {    // (JavaCodeGenerator.meta.java:1827)
        public DanglingElseSyntax.ShortIf shortIf();                            // (JavaCodeGenerator.meta.java:1831)
        public DanglingElseSyntax.LongIf longIf();                              // (JavaCodeGenerator.meta.java:1831)
    }                                                                           // (JavaCodeGenerator.meta.java:1833)
                                                                                // (JavaCodeGenerator.meta.java:1836)
    /**
     * Parses a <code>Root</code> in the given file.
     * <p>
     * This is equivalent to <code>parseRoot(file.getPath(), file, charsetName, 8)</code>.
     *
     * @param   file
     *      the file including the text to parse.
     * @param   charsetName
     *      the charset name of the file, or <code>null</code> for the default charset.
     * @return
     *      the abstract syntax tree.
     * @throws   java.io.IOException
     *      if some error is occured for the access to the file.
     * @throws   ParseException
     *      if the text in the file doesn't satisfy some requirements.
     */
    public DanglingElseSyntax.Root parseRoot(java.io.File file, java.lang.String charsetName) throws java.io.IOException, ParseException {    // (JavaCodeGenerator.meta.java:1901)
        return parseRoot(file.getPath(), file, charsetName, 8);                 // (JavaCodeGenerator.meta.java:1902)
    }                                                                           // (JavaCodeGenerator.meta.java:1903)
                                                                                // (JavaCodeGenerator.meta.java:1904)
    /**
     * Parses a <code>Root</code> in the given file.
     *
     * @param   sourceName
     *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
     * @param   file
     *      the file including the text to parse.
     * @param   charsetName
     *      the charset name of the file, or <code>null</code> for the default charset.
     * @param   tabStop
     *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
     * @return
     *      the abstract syntax tree.
     * @throws   java.io.IOException
     *      if some error is occured for the access to the file.
     * @throws   ParseException
     *      if the text in the file doesn't satisfy some requirements.
     */
    public DanglingElseSyntax.Root parseRoot(java.lang.String sourceName, java.io.File file, java.lang.String charsetName, int tabStop) throws java.io.IOException, ParseException {    // (JavaCodeGenerator.meta.java:1960)
        return parseRoot(sourceName, toCharSequence(file, charsetName), tabStop);    // (JavaCodeGenerator.meta.java:1961)
    }                                                                           // (JavaCodeGenerator.meta.java:1962)
                                                                                // (JavaCodeGenerator.meta.java:1963)
    /**
     * Parses a <code>Root</code> in the given character stream.
     *
     * @param   sourceName
     *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
     * @param   reader
     *      a character stream.  This method will not <code>close</code> it.
     * @param   tabStop
     *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
     * @return
     *      the abstract syntax tree.
     * @throws   java.io.IOException
     *      if some error is occured for the access to the file.
     * @throws   ParseException
     *      if the text in the file doesn't satisfy some requirements.
     */
    public DanglingElseSyntax.Root parseRoot(java.lang.String sourceName, java.io.Reader reader, int tabStop) throws java.io.IOException, ParseException {    // (JavaCodeGenerator.meta.java:2016)
        return parseRoot(sourceName, toCharSequence(reader), tabStop);          // (JavaCodeGenerator.meta.java:2017)
    }                                                                           // (JavaCodeGenerator.meta.java:2018)
                                                                                // (JavaCodeGenerator.meta.java:2019)
    /**
     * Parses a <code>Root</code> in the given text.
     *
     * @param   sourceName
     *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
     * @param   text
     *      the text to parse.
     * @param   tabStop
     *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
     * @return
     *      the abstract syntax tree.
     * @throws   ParseException
     *      if the text doesn't satisfy some requirements.
     */
    public DanglingElseSyntax.Root parseRoot(java.lang.String sourceName, java.lang.CharSequence text, int tabStop) throws ParseException {    // (JavaCodeGenerator.meta.java:2067)
        DanglingElseSyntax.LexicalAnalyzer analyzer = createLexicalAnalyzer(sourceName, text, tabStop);    // (JavaCodeGenerator.meta.java:2068)
        return parseRoot(analyzer);                                             // (JavaCodeGenerator.meta.java:2069)
    }                                                                           // (JavaCodeGenerator.meta.java:2070)
                                                                                // (JavaCodeGenerator.meta.java:2071)
    /**
     * Parses the sequence of tokens.
     *
     * @param   analyzer
     *      the lexical analyzer that gives the sequence of tokens to parse.
     * @return
     *      the abstract syntax tree.
     * @throws   ParseException
     *      if the sequence of tokens doesn't satisfy some requirements.
     */
    public DanglingElseSyntax.Root parseRoot(DanglingElseSyntax.LexicalAnalyzer analyzer) throws ParseException {    // (JavaCodeGenerator.meta.java:2111)
        int initialState = 1;                                                   // (JavaCodeGenerator.meta.java:2112)
                                                                                // (JavaCodeGenerator.meta.java:2113)
        DanglingElseSyntax.Root result;                                         // (JavaCodeGenerator.meta.java:2115)
        DanglingElseSyntax.Node node = __parse__notavacc_reserved(analyzer, initialState);    // (JavaCodeGenerator.meta.java:2116)
        if (node instanceof DanglingElseSyntax.Root) {                          // (JavaCodeGenerator.meta.java:2117)
            result = (DanglingElseSyntax.Root) node;                            // (JavaCodeGenerator.meta.java:2118)
        } else {                                                                // (JavaCodeGenerator.meta.java:2119)
            result = (DanglingElseSyntax.Root) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) node, DanglingElseSyntax.Root.class);    // (JavaCodeGenerator.meta.java:2123)
        }                                                                       // (JavaCodeGenerator.meta.java:2126)
                                                                                // (JavaCodeGenerator.meta.java:2130)
        return (DanglingElseSyntax.Root) modifyWholeTree(result);               // (JavaCodeGenerator.meta.java:2131)
    }                                                                           // (JavaCodeGenerator.meta.java:2132)
    /**
     * An abstract-syntax-tree node <code>Root</code>.
     *
     *
     */
    public static interface Root extends DanglingElseSyntax.Node {              // (JavaCodeGenerator.meta.java:2174)
        /**
         * The ID value of the type.
         * @see     DanglingElseSyntax#createNode
         * @since   notavaCC 1.0
         */
        public static final int ID = 9;                                         // (JavaCodeGenerator.meta.java:2196)
    }                                                                           // (JavaCodeGenerator.meta.java:2267)
    /**
     * An abstract-syntax-tree node <code>SingleLineStatement</code>.
     *
     *
     */
    public static interface SingleLineStatement extends DanglingElseSyntax.Node {    // (JavaCodeGenerator.meta.java:2174)
        /**
         * The ID value of the type.
         * @see     DanglingElseSyntax#createNode
         * @since   notavaCC 1.0
         */
        public static final int ID = 10;                                        // (JavaCodeGenerator.meta.java:2196)
    }                                                                           // (JavaCodeGenerator.meta.java:2267)
    /**
     * An abstract-syntax-tree node <code>IfThenElseStatement</code>.
     *
     *
     */
    public static interface IfThenElseStatement extends DanglingElseSyntax.Node {    // (JavaCodeGenerator.meta.java:2174)
        /**
         */
        public DanglingElseSyntax.Node thenPart();                              // (JavaCodeGenerator.meta.java:2265)
        /**
         */
        public DanglingElseSyntax.Node elsePart();                              // (JavaCodeGenerator.meta.java:2265)
    }                                                                           // (JavaCodeGenerator.meta.java:2267)
    /**
     * An abstract-syntax-tree node <code>LongIf</code>.
     *
     *
     */
    public static interface LongIf extends DanglingElseSyntax.IfThenElseStatement {    // (JavaCodeGenerator.meta.java:2174)
        /**
         * The ID value of the type.
         * @see     DanglingElseSyntax#createNode
         * @since   notavaCC 1.0
         */
        public static final int ID = 11;                                        // (JavaCodeGenerator.meta.java:2196)
        /**
         */
        public DanglingElseSyntax.Node thenPart();                              // (JavaCodeGenerator.meta.java:2265)
        /**
         */
        public DanglingElseSyntax.Node elsePart();                              // (JavaCodeGenerator.meta.java:2265)
    }                                                                           // (JavaCodeGenerator.meta.java:2267)
    /**
     * An abstract-syntax-tree node <code>ShortIf</code>.
     *
     *
     */
    public static interface ShortIf extends DanglingElseSyntax.IfThenElseStatement {    // (JavaCodeGenerator.meta.java:2174)
        /**
         * The ID value of the type.
         * @see     DanglingElseSyntax#createNode
         * @since   notavaCC 1.0
         */
        public static final int ID = 12;                                        // (JavaCodeGenerator.meta.java:2196)
        /**
         */
        public DanglingElseSyntax.Node thenPart();                              // (JavaCodeGenerator.meta.java:2265)
    }                                                                           // (JavaCodeGenerator.meta.java:2267)
                                                                                // (JavaCodeGenerator.meta.java:2270)
                                                                                // (JavaCodeGenerator.meta.java:2271)
    /**
     * Describes a error of a text.
     *
     * @since   notavaCC 1.0
     */
    public static class ParseException extends java.lang.Exception {            // (JavaCodeGenerator.meta.java:2294)
        private static final long serialVersionUID = 0;                         // (JavaCodeGenerator.meta.java:2295)
        private final java.lang.String sourceName;                              // (JavaCodeGenerator.meta.java:2296)
        private final int index;                                                // (JavaCodeGenerator.meta.java:2297)
        private final int line;                                                 // (JavaCodeGenerator.meta.java:2298)
        private final int column;                                               // (JavaCodeGenerator.meta.java:2299)
                                                                                // (JavaCodeGenerator.meta.java:2300)
        /**
         * Constructs an exception.
         *
         * @param   msg
         *            a message to describes the error.
         * @param   sourceName
         *            the source name where the exception is occured, or null if not supported.
         * @param   index
         *            the index number where the exception is occured, or -1 if not supported.
         * @param   line
         *            the line number where the exception is occured, or -1 if not supported.
         * @param   column
         *            the column number where the exception is occured, or -1 if not supported.
         * @since   notavaCC 1.0
         */
        public ParseException(java.lang.String msg, java.lang.String sourceName, int index, int line, int column) {    // (JavaCodeGenerator.meta.java:2334)
            super(msg);                                                         // (JavaCodeGenerator.meta.java:2335)
            this.sourceName = sourceName;                                       // (JavaCodeGenerator.meta.java:2336)
            this.index = index;                                                 // (JavaCodeGenerator.meta.java:2337)
            this.line = line;                                                   // (JavaCodeGenerator.meta.java:2338)
            this.column = column;                                               // (JavaCodeGenerator.meta.java:2339)
        }                                                                       // (JavaCodeGenerator.meta.java:2340)
        /**
         * Constructs an exception.
         *
         * @param   msg
         *            a message to describes the error.
         * @param   position
         *            a token that describes the position of the error.
         * @since   notavaCC 1.0
         */
        public ParseException(java.lang.String msg, DanglingElseSyntax.Token position) {    // (JavaCodeGenerator.meta.java:2362)
            super(msg);                                                         // (JavaCodeGenerator.meta.java:2363)
                                                                                // (JavaCodeGenerator.meta.java:2364)
            java.lang.String sourceName = null;                                 // (JavaCodeGenerator.meta.java:2365)
            int index = -1;                                                     // (JavaCodeGenerator.meta.java:2366)
            int line = -1;                                                      // (JavaCodeGenerator.meta.java:2367)
            int column = -1;                                                    // (JavaCodeGenerator.meta.java:2368)
                                                                                // (JavaCodeGenerator.meta.java:2369)
            try {                                                               // (JavaCodeGenerator.meta.java:2370)
                sourceName = position.getSourceName();                          // (JavaCodeGenerator.meta.java:2371)
            } catch (java.lang.UnsupportedOperationException x) {               // (JavaCodeGenerator.meta.java:2372)
            }                                                                   // (JavaCodeGenerator.meta.java:2373)
            try {                                                               // (JavaCodeGenerator.meta.java:2374)
                index = position.getIndex();                                    // (JavaCodeGenerator.meta.java:2375)
            } catch (java.lang.UnsupportedOperationException x) {               // (JavaCodeGenerator.meta.java:2376)
            }                                                                   // (JavaCodeGenerator.meta.java:2377)
            try {                                                               // (JavaCodeGenerator.meta.java:2378)
                line = position.getLine();                                      // (JavaCodeGenerator.meta.java:2379)
            } catch (java.lang.UnsupportedOperationException x) {               // (JavaCodeGenerator.meta.java:2380)
            }                                                                   // (JavaCodeGenerator.meta.java:2381)
            try {                                                               // (JavaCodeGenerator.meta.java:2382)
                column = position.getColumn();                                  // (JavaCodeGenerator.meta.java:2383)
            } catch (java.lang.UnsupportedOperationException x) {               // (JavaCodeGenerator.meta.java:2384)
            }                                                                   // (JavaCodeGenerator.meta.java:2385)
                                                                                // (JavaCodeGenerator.meta.java:2386)
            this.sourceName = sourceName;                                       // (JavaCodeGenerator.meta.java:2387)
            this.index = index;                                                 // (JavaCodeGenerator.meta.java:2388)
            this.line = line;                                                   // (JavaCodeGenerator.meta.java:2389)
            this.column = column;                                               // (JavaCodeGenerator.meta.java:2390)
        }                                                                       // (JavaCodeGenerator.meta.java:2391)
                                                                                // (JavaCodeGenerator.meta.java:2392)
        /**
         * Returns the source name where the exception is occured.
         *
         * @return  the source name where the exception is occured.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public final java.lang.String getSourceName() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2412)
            if (sourceName == null)                                             // (JavaCodeGenerator.meta.java:2413)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:2414)
            return sourceName;                                                  // (JavaCodeGenerator.meta.java:2415)
        }                                                                       // (JavaCodeGenerator.meta.java:2416)
                                                                                // (JavaCodeGenerator.meta.java:2417)
        /**
         * Returns the index number where the exception is occured.
         *
         * @return  the index number where the exception is occured.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public final int getIndex() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2437)
            if (index == -1)                                                    // (JavaCodeGenerator.meta.java:2438)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:2439)
            return index;                                                       // (JavaCodeGenerator.meta.java:2440)
        }                                                                       // (JavaCodeGenerator.meta.java:2441)
                                                                                // (JavaCodeGenerator.meta.java:2442)
        /**
         * Returns the line number where the exception is occured.
         *
         * @return  the line number where the exception is occured.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public final int getLine() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2462)
            if (line == -1)                                                     // (JavaCodeGenerator.meta.java:2463)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:2464)
            return line;                                                        // (JavaCodeGenerator.meta.java:2465)
        }                                                                       // (JavaCodeGenerator.meta.java:2466)
                                                                                // (JavaCodeGenerator.meta.java:2467)
        /**
         * Returns the column number where the exception is occured.
         *
         * @return  the column number where the exception is occured.
         * @throws   java.lang.UnsupportedOperationException
         *      if the method is not suported.
         * @since   notavaCC 1.0
         */
        public final int getColumn() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2487)
            if (column == -1)                                                   // (JavaCodeGenerator.meta.java:2488)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:2489)
            return column;                                                      // (JavaCodeGenerator.meta.java:2490)
        }                                                                       // (JavaCodeGenerator.meta.java:2491)
                                                                                // (JavaCodeGenerator.meta.java:2492)
        /**
         * Returns the GNU-Compiler-Collection-style string that describes the position of the error.
         * <p>
         * This method throws an UnsupportedOperationException if <code>getSourceName()</code> is not supported.
         * Otherwise, it returns <code>getSourceName()</code> if <code>getLine()</code> is not supported.
         * Otherwise, it returns <code>getSourceName() + ":" + getLine()</code> if <code>getColumn()</code> is not supported.
         * Otherwise, it returns <code>getSourceName() + ":" + getLine() + ":" + getColumn()</code>.
         *
         * @return
         *      the GCC-style string describing the position of the error.
         * @throws   UnsupportedOperationException
         *      getSourceName() was not suppoted.
         * @since   notavaCC 1.0
         */
        public final java.lang.String getGCCStylePositionString() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2520)
            if (line == -1) {                                                   // (JavaCodeGenerator.meta.java:2521)
                return getSourceName();                                         // (JavaCodeGenerator.meta.java:2522)
            } else if (column == -1) {                                          // (JavaCodeGenerator.meta.java:2523)
                return getSourceName() + ":" + line;                            // (JavaCodeGenerator.meta.java:2524)
            } else {                                                            // (JavaCodeGenerator.meta.java:2525)
                return getSourceName() + ":" + line + ":" + column;             // (JavaCodeGenerator.meta.java:2526)
            }                                                                   // (JavaCodeGenerator.meta.java:2527)
        }                                                                       // (JavaCodeGenerator.meta.java:2528)
                                                                                // (JavaCodeGenerator.meta.java:2529)
        /**
         * Indicates the source of the notavaCC, which generates this Java program, has ambiguity.
         * @since   notavaCC 1.0
         */
        public static class AmbiguousGrammarError extends java.lang.AssertionError {    // (JavaCodeGenerator.meta.java:2541)
            private static final long serialVersionUID = 0;                     // (JavaCodeGenerator.meta.java:2542)
            public AmbiguousGrammarError(java.lang.String message) {            // (JavaCodeGenerator.meta.java:2543)
                super(message);                                                 // (JavaCodeGenerator.meta.java:2544)
            }                                                                   // (JavaCodeGenerator.meta.java:2545)
        }                                                                       // (JavaCodeGenerator.meta.java:2546)
    } // class ParseException                                                   // (JavaCodeGenerator.meta.java:2547)
                                                                                // (JavaCodeGenerator.meta.java:2548)
                                                                                // (JavaCodeGenerator.meta.java:2549)
    /**
     * A namespace for the default implementations.
     *
     * @since   notavaCC 1.0
     */
    public static interface Default {                                           // (JavaCodeGenerator.meta.java:2564)
        /**
         * Provides a simple implementation of {@link DanglingElseSyntax.Node}.
         *
         * @since   notavaCC 1.0
         */
        public static abstract class Node implements DanglingElseSyntax.Node {    // (JavaCodeGenerator.meta.java:2579)
                                                                                // (JavaCodeGenerator.meta.java:2583)
            private java.util.List childNodes;                                  // (JavaCodeGenerator.meta.java:2584)
            /**
             * Constucts an instance.
             * <p>
             * The returned list of {@link #getChildNodes()} is the <code>childNodes</code> rather than a copy of it.
             *
             * @param   childNodes
             *            a list of child nodes.
             * @since   notavaCC 1.0
             */
            public Node(java.util.List childNodes) {                            // (JavaCodeGenerator.meta.java:2606)
                this.childNodes = childNodes;                                   // (JavaCodeGenerator.meta.java:2607)
            }                                                                   // (JavaCodeGenerator.meta.java:2608)
            public java.util.List getChildNodes() {                             // (JavaCodeGenerator.meta.java:2609)
                return this.childNodes;                                         // (JavaCodeGenerator.meta.java:2610)
            }                                                                   // (JavaCodeGenerator.meta.java:2611)
                                                                                // (JavaCodeGenerator.meta.java:2612)
            public DanglingElseSyntax.AmbiguityAbsorber getWrappedAmbiguityAbsorber() {    // (JavaCodeGenerator.meta.java:2614)
                return null;                                                    // (JavaCodeGenerator.meta.java:2615)
            }                                                                   // (JavaCodeGenerator.meta.java:2616)
                                                                                // (JavaCodeGenerator.meta.java:2618)
            /**
             * Replaces the child node <code>oldChild</code> with <code>newChild</code>.
             * <p>
             * This method
             * replaces <code>oldChild</code> in <code>getChildNodes()</code> with <code>newChild</code>.
             * Also, this method replaces the values returned by the methods that are defined in the subinterfaces of {@link DanglingElseSyntax.Node} and that return particular children.
             *
             * @param   oldChild
             *            a replaced child node.
             * @param   newChild
             *            a child node to replace <code>oldChild</code>.
             * @since   notavaCC 1.0
             */
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:2657)
                __replaceAll__notavacc_reserved(getChildNodes(), oldChild, newChild);    // (JavaCodeGenerator.meta.java:2658)
            }                                                                   // (JavaCodeGenerator.meta.java:2659)
                                                                                // (JavaCodeGenerator.meta.java:2660)
            public java.lang.String toString() {                                // (JavaCodeGenerator.meta.java:2661)
                java.io.StringWriter buffer = new java.io.StringWriter();       // (JavaCodeGenerator.meta.java:2662)
                java.io.PrintWriter writer = new java.io.PrintWriter(buffer);    // (JavaCodeGenerator.meta.java:2663)
                                                                                // (JavaCodeGenerator.meta.java:2664)
                DanglingElseSyntax.Node node = this;                            // (JavaCodeGenerator.meta.java:2665)
                while (!(node instanceof DanglingElseSyntax.Token)) {           // (JavaCodeGenerator.meta.java:2666)
                    if (node.getChildNodes().isEmpty()) {                       // (JavaCodeGenerator.meta.java:2667)
                        node = null;                                            // (JavaCodeGenerator.meta.java:2668)
                        break;                                                  // (JavaCodeGenerator.meta.java:2669)
                    }                                                           // (JavaCodeGenerator.meta.java:2670)
                    node = (DanglingElseSyntax.Node) node.getChildNodes().get(0);    // (JavaCodeGenerator.meta.java:2671)
                }                                                               // (JavaCodeGenerator.meta.java:2672)
                if (node != null) {                                             // (JavaCodeGenerator.meta.java:2673)
                    DanglingElseSyntax.Token token = (DanglingElseSyntax.Token) node;    // (JavaCodeGenerator.meta.java:2674)
                    try {                                                       // (JavaCodeGenerator.meta.java:2675)
                        writer.print(token.getSourceName() + ":");              // (JavaCodeGenerator.meta.java:2676)
                        writer.print(token.getLine() + ":");                    // (JavaCodeGenerator.meta.java:2677)
                        writer.println(token.getOriginalImage());               // (JavaCodeGenerator.meta.java:2678)
                    } catch (java.lang.UnsupportedOperationException x) {       // (JavaCodeGenerator.meta.java:2679)
                    }                                                           // (JavaCodeGenerator.meta.java:2680)
                }                                                               // (JavaCodeGenerator.meta.java:2681)
                                                                                // (JavaCodeGenerator.meta.java:2682)
                toString(this, 0, writer);                                      // (JavaCodeGenerator.meta.java:2683)
                writer.close();                                                 // (JavaCodeGenerator.meta.java:2684)
                if (writer.checkError())                                        // (JavaCodeGenerator.meta.java:2685)
                    throw new java.lang.RuntimeException();                     // (JavaCodeGenerator.meta.java:2686)
                return buffer.toString();                                       // (JavaCodeGenerator.meta.java:2687)
            }                                                                   // (JavaCodeGenerator.meta.java:2688)
            private static void toString(DanglingElseSyntax.Node node, int indent, java.io.PrintWriter writer) {    // (JavaCodeGenerator.meta.java:2689)
                for (int i = 0; i < indent; i++)                                // (JavaCodeGenerator.meta.java:2690)
                    writer.print("  ");                                         // (JavaCodeGenerator.meta.java:2691)
                                                                                // (JavaCodeGenerator.meta.java:2692)
                if (node == null) {                                             // (JavaCodeGenerator.meta.java:2693)
                    writer.println("null");                                     // (JavaCodeGenerator.meta.java:2694)
                } else if (node instanceof Token) {                             // (JavaCodeGenerator.meta.java:2695)
                    Token token = (Token) node;                                 // (JavaCodeGenerator.meta.java:2696)
                    writer.println(token);                                      // (JavaCodeGenerator.meta.java:2697)
                    //writer.println("token: " + token.getOriginalImage());     // (JavaCodeGenerator.meta.java:2698)
                } else {                                                        // (JavaCodeGenerator.meta.java:2699)
                    java.lang.String binaryName = node.getClass().getName();    // (JavaCodeGenerator.meta.java:2700)
                    binaryName = binaryName.substring(binaryName.lastIndexOf(".") + 1);    // (JavaCodeGenerator.meta.java:2701)
                    binaryName = binaryName.substring(binaryName.lastIndexOf("$") + 1);    // (JavaCodeGenerator.meta.java:2702)
                    writer.println(binaryName);                                 // (JavaCodeGenerator.meta.java:2703)
                    indent++;                                                   // (JavaCodeGenerator.meta.java:2704)
                    java.util.Iterator it = node.getChildNodes().iterator();    // (JavaCodeGenerator.meta.java:2705)
                    while (it.hasNext()) {                                      // (JavaCodeGenerator.meta.java:2706)
                        DanglingElseSyntax.Node n = (DanglingElseSyntax.Node) it.next();    // (JavaCodeGenerator.meta.java:2707)
                        toString(n, indent, writer);                            // (JavaCodeGenerator.meta.java:2708)
                    }                                                           // (JavaCodeGenerator.meta.java:2709)
                }                                                               // (JavaCodeGenerator.meta.java:2710)
            }                                                                   // (JavaCodeGenerator.meta.java:2711)
        } // Default.Node                                                       // (JavaCodeGenerator.meta.java:2712)
                                                                                // (JavaCodeGenerator.meta.java:2713)
        /**
         * Provides a simple implementation of {@link DanglingElseSyntax.Token}.
         *
         * @since   notavaCC 1.0
         */
        public static class Token extends Default.Node implements DanglingElseSyntax.Token {    // (JavaCodeGenerator.meta.java:2727)
            private final int symbolID;                                         // (JavaCodeGenerator.meta.java:2728)
            private final java.lang.String image;                               // (JavaCodeGenerator.meta.java:2729)
            private final java.lang.String originalImage;                       // (JavaCodeGenerator.meta.java:2730)
            private final java.lang.String sourceName;                          // (JavaCodeGenerator.meta.java:2731)
            private final int index;                                            // (JavaCodeGenerator.meta.java:2732)
            private final int line;                                             // (JavaCodeGenerator.meta.java:2733)
            private final int column;                                           // (JavaCodeGenerator.meta.java:2734)
            /**
             * Constructs a token.
             * <p>
             *
             * @param   symbolID
             *      the symbol ID of the token, returned by <code>getSymbolID</code>.
             * @param   image
             *      the image string, returned by <code>getImage</code> and <code>getOriginalImage</code>.
             * @since   notavaCC 1.0
             */
            public Token(int symbolID, java.lang.String image) {                // (JavaCodeGenerator.meta.java:2759)
                this(symbolID, image, image, null, -1, -1, -1);                 // (JavaCodeGenerator.meta.java:2760)
            }                                                                   // (JavaCodeGenerator.meta.java:2761)
                                                                                // (JavaCodeGenerator.meta.java:2762)
            /**
             * Constructs a token.
             * <p>
             *
             * @param   symbolID
             *      the symbol ID of the token, returned by <code>getSymbolID</code>.
             * @param   image
             *      the image string, returned by <code>getImage</code>.
             * @param   originalImage
             *      the image string, returned by <code>getOriginalImage</code>.
             * @param   sourceName
             *      the source name returned by <code>getSourceName</code>, or <code>null</code> if not supported.
             * @param   index
             *      the index returned by <code>getIndex</code>, or <code>-1</code> if not supported.
             * @param   line
             *      the line number returned by <code>getLine</code>, or <code>-1</code> if not supported.
             * @param   column
             *      the column number returned by <code>getColumn</code>, or <code>-1</code> if not supported.
             * @since   notavaCC 1.0
             */
            public Token(int symbolID, java.lang.String image, java.lang.String originalImage, java.lang.String sourceName, int index, int line, int column) {    // (JavaCodeGenerator.meta.java:2806)
                super(java.util.Collections.EMPTY_LIST);                        // (JavaCodeGenerator.meta.java:2810)
                this.symbolID = symbolID;                                       // (JavaCodeGenerator.meta.java:2811)
                this.image = image;                                             // (JavaCodeGenerator.meta.java:2812)
                this.originalImage = originalImage;                             // (JavaCodeGenerator.meta.java:2813)
                this.sourceName = sourceName;                                   // (JavaCodeGenerator.meta.java:2814)
                this.index = index;                                             // (JavaCodeGenerator.meta.java:2815)
                this.line = line;                                               // (JavaCodeGenerator.meta.java:2816)
                this.column = column;                                           // (JavaCodeGenerator.meta.java:2817)
            }                                                                   // (JavaCodeGenerator.meta.java:2818)
            /**
             * Constructs a token.
             * <p>
             *
             * @param   symbolID
             *      the symbol ID of the token, returned by <code>getSymbolID</code>.
             * @param   image
             *      the image string, returned by <code>getImage</code>.
             * @param   originalImage
             *      the image string, returned by <code>getOriginalImage</code>.
             * @param   token
             *      a token that gives the returned value of <code>getSourceName</code>, <code>getIndex</code>, <code>getLine</code> and <code>getColumn</code>.
             * @since   notavaCC 1.0
             */
            public Token(int symbolID, java.lang.String image, java.lang.String originalImage, DanglingElseSyntax.Token token) {    // (JavaCodeGenerator.meta.java:2850)
                super(java.util.Collections.EMPTY_LIST);                        // (JavaCodeGenerator.meta.java:2854)
                java.lang.String sourceName = null;                             // (JavaCodeGenerator.meta.java:2855)
                int index = -1;                                                 // (JavaCodeGenerator.meta.java:2856)
                int line = -1;                                                  // (JavaCodeGenerator.meta.java:2857)
                int column = -1;                                                // (JavaCodeGenerator.meta.java:2858)
                try {                                                           // (JavaCodeGenerator.meta.java:2859)
                    sourceName = token.getSourceName();                         // (JavaCodeGenerator.meta.java:2860)
                } catch (java.lang.UnsupportedOperationException x) {           // (JavaCodeGenerator.meta.java:2861)
                }                                                               // (JavaCodeGenerator.meta.java:2862)
                try {                                                           // (JavaCodeGenerator.meta.java:2863)
                    index = token.getIndex();                                   // (JavaCodeGenerator.meta.java:2864)
                } catch (java.lang.UnsupportedOperationException x) {           // (JavaCodeGenerator.meta.java:2865)
                }                                                               // (JavaCodeGenerator.meta.java:2866)
                try {                                                           // (JavaCodeGenerator.meta.java:2867)
                    line = token.getLine();                                     // (JavaCodeGenerator.meta.java:2868)
                } catch (java.lang.UnsupportedOperationException x) {           // (JavaCodeGenerator.meta.java:2869)
                }                                                               // (JavaCodeGenerator.meta.java:2870)
                try {                                                           // (JavaCodeGenerator.meta.java:2871)
                    column = token.getColumn();                                 // (JavaCodeGenerator.meta.java:2872)
                } catch (java.lang.UnsupportedOperationException x) {           // (JavaCodeGenerator.meta.java:2873)
                }                                                               // (JavaCodeGenerator.meta.java:2874)
                                                                                // (JavaCodeGenerator.meta.java:2875)
                this.symbolID = symbolID;                                       // (JavaCodeGenerator.meta.java:2876)
                this.image = image;                                             // (JavaCodeGenerator.meta.java:2877)
                this.originalImage = originalImage;                             // (JavaCodeGenerator.meta.java:2878)
                this.sourceName = sourceName;                                   // (JavaCodeGenerator.meta.java:2879)
                this.index = index;                                             // (JavaCodeGenerator.meta.java:2880)
                this.line = line;                                               // (JavaCodeGenerator.meta.java:2881)
                this.column = column;                                           // (JavaCodeGenerator.meta.java:2882)
            }                                                                   // (JavaCodeGenerator.meta.java:2883)
            public int getSymbolID() {                                          // (JavaCodeGenerator.meta.java:2884)
                return symbolID;                                                // (JavaCodeGenerator.meta.java:2885)
            }                                                                   // (JavaCodeGenerator.meta.java:2886)
            public boolean isWhite() {                                          // (JavaCodeGenerator.meta.java:2887)
                return 1 <= symbolID && symbolID < 2;                           // (JavaCodeGenerator.meta.java:2888)
            }                                                                   // (JavaCodeGenerator.meta.java:2889)
            public java.lang.String getImage() {                                // (JavaCodeGenerator.meta.java:2890)
                return image;                                                   // (JavaCodeGenerator.meta.java:2891)
            }                                                                   // (JavaCodeGenerator.meta.java:2892)
            public java.lang.String getOriginalImage() {                        // (JavaCodeGenerator.meta.java:2893)
                return originalImage;                                           // (JavaCodeGenerator.meta.java:2894)
            }                                                                   // (JavaCodeGenerator.meta.java:2895)
                                                                                // (JavaCodeGenerator.meta.java:2896)
                                                                                // (JavaCodeGenerator.meta.java:2897)
            public java.lang.String getSourceName() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2898)
                if (sourceName == null)                                         // (JavaCodeGenerator.meta.java:2899)
                    throw new java.lang.UnsupportedOperationException();        // (JavaCodeGenerator.meta.java:2900)
                return sourceName;                                              // (JavaCodeGenerator.meta.java:2901)
            }                                                                   // (JavaCodeGenerator.meta.java:2902)
            public int getIndex() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2903)
                if (index == -1)                                                // (JavaCodeGenerator.meta.java:2904)
                    throw new java.lang.UnsupportedOperationException();        // (JavaCodeGenerator.meta.java:2905)
                return index;                                                   // (JavaCodeGenerator.meta.java:2906)
            }                                                                   // (JavaCodeGenerator.meta.java:2907)
            public int getLine() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2908)
                if (line == -1)                                                 // (JavaCodeGenerator.meta.java:2909)
                    throw new java.lang.UnsupportedOperationException();        // (JavaCodeGenerator.meta.java:2910)
                return line;                                                    // (JavaCodeGenerator.meta.java:2911)
            }                                                                   // (JavaCodeGenerator.meta.java:2912)
            public int getColumn() throws java.lang.UnsupportedOperationException {    // (JavaCodeGenerator.meta.java:2913)
                if (column == -1)                                               // (JavaCodeGenerator.meta.java:2914)
                    throw new java.lang.UnsupportedOperationException();        // (JavaCodeGenerator.meta.java:2915)
                return column;                                                  // (JavaCodeGenerator.meta.java:2916)
            }                                                                   // (JavaCodeGenerator.meta.java:2917)
                                                                                // (JavaCodeGenerator.meta.java:2918)
            public java.lang.String toString() {                                // (JavaCodeGenerator.meta.java:2919)
                //java.lang.StringBuffer result = new java.lang.StringBuffer(__quoted__notavacc_reserved(getOriginalImage()));    // (JavaCodeGenerator.meta.java:2920)
                                                                                // (JavaCodeGenerator.meta.java:2921)
                java.lang.StringBuffer result = new java.lang.StringBuffer();    // (JavaCodeGenerator.meta.java:2922)
                result.append("`");                                             // (JavaCodeGenerator.meta.java:2923)
                java.lang.String original = getOriginalImage();                 // (JavaCodeGenerator.meta.java:2924)
                for (int i = 0; i < original.length(); i++) {                   // (JavaCodeGenerator.meta.java:2925)
                    char ch = original.charAt(i);                               // (JavaCodeGenerator.meta.java:2926)
                    switch (ch) {                                               // (JavaCodeGenerator.meta.java:2927)
                    default:                                                    // (JavaCodeGenerator.meta.java:2928)
                        if (ch < ' ' || ch == '\u007F') {                       // (JavaCodeGenerator.meta.java:2929)
                            result.append("\\u").append(__toHexCode__notavacc_reserved(ch));    // (JavaCodeGenerator.meta.java:2930)
                        } else {                                                // (JavaCodeGenerator.meta.java:2931)
                            result.append(ch);                                  // (JavaCodeGenerator.meta.java:2932)
                        }                                                       // (JavaCodeGenerator.meta.java:2933)
                        break;                                                  // (JavaCodeGenerator.meta.java:2934)
                    case '\n':   result.append("\\n");      break;              // (JavaCodeGenerator.meta.java:2935)
                    case '\t':   result.append("\\t");      break;              // (JavaCodeGenerator.meta.java:2936)
                    case '\b':   result.append("\\b");      break;              // (JavaCodeGenerator.meta.java:2937)
                    case '\r':   result.append("\\r");      break;              // (JavaCodeGenerator.meta.java:2938)
                    case '\f':   result.append("\\f");      break;              // (JavaCodeGenerator.meta.java:2939)
                        //case '\\':   result.append("\\\\");     break;        // (JavaCodeGenerator.meta.java:2940)
                        //case '\'':   result.append("\\\'");     break;        // (JavaCodeGenerator.meta.java:2941)
                        //case '\"':   result.append("\\\"");     break;        // (JavaCodeGenerator.meta.java:2942)
                    }                                                           // (JavaCodeGenerator.meta.java:2943)
                }                                                               // (JavaCodeGenerator.meta.java:2944)
                result.append("'");                                             // (JavaCodeGenerator.meta.java:2945)
                                                                                // (JavaCodeGenerator.meta.java:2946)
                if (column != -1 || line != -1) {                               // (JavaCodeGenerator.meta.java:2947)
                    result.append(" (");                                        // (JavaCodeGenerator.meta.java:2948)
                    if (line != -1) {                                           // (JavaCodeGenerator.meta.java:2949)
                        result.append("line ");                                 // (JavaCodeGenerator.meta.java:2950)
                        result.append(getLine());                               // (JavaCodeGenerator.meta.java:2951)
                        if (column != -1)                                       // (JavaCodeGenerator.meta.java:2952)
                            result.append(", ");                                // (JavaCodeGenerator.meta.java:2953)
                    }                                                           // (JavaCodeGenerator.meta.java:2954)
                    if (column != -1) {                                         // (JavaCodeGenerator.meta.java:2955)
                        result.append("column ");                               // (JavaCodeGenerator.meta.java:2956)
                        result.append(getColumn());                             // (JavaCodeGenerator.meta.java:2957)
                    }                                                           // (JavaCodeGenerator.meta.java:2958)
                    result.append(")");                                         // (JavaCodeGenerator.meta.java:2959)
                }                                                               // (JavaCodeGenerator.meta.java:2960)
                return result.toString();                                       // (JavaCodeGenerator.meta.java:2961)
            }                                                                   // (JavaCodeGenerator.meta.java:2962)
        } // class Default.Token                                                // (JavaCodeGenerator.meta.java:2963)
                                                                                // (JavaCodeGenerator.meta.java:2964)
        /**
         * The default {@link DanglingElseSyntax.LexicalAnalyzer}.
         *
         * @since   notavaCC 1.0
         */
        public static class LexicalAnalyzer extends DanglingElseSyntax.LexicalAnalyzer {    // (JavaCodeGenerator.meta.java:2978)
            /**
             * The <code>sourceName</code> given to the constructor.
             *
             * @since   notavaCC 1.0
             */
            protected final java.lang.String sourceName;                        // (JavaCodeGenerator.meta.java:2992)
            /**
             * The <code>text</code> given to the constructor.
             *
             * @since   notavaCC 1.0
             */
            protected final java.lang.CharSequence text;                        // (JavaCodeGenerator.meta.java:3006)
            /**
             * The exclusive end index of the target {@link #text} region.
             *
             * @since   notavaCC 1.0
             */
            protected final int end;                                            // (JavaCodeGenerator.meta.java:3020)
            /**
             * The <code>tabStop</code> given to the constructor.
             *
             * @since   notavaCC 1.0
             */
            protected final int tabStop;                                        // (JavaCodeGenerator.meta.java:3034)
            /**
             * The <code>table</code> given to the constructor.
             *
             * @since   notavaCC 1.0
             */
            private final int[][] table;                                        // (JavaCodeGenerator.meta.java:3048)
            /**
             * The <code>initialState</code> given to the constructor.
             *
             * @since   notavaCC 1.0
             */
            private final int initialState;                                     // (JavaCodeGenerator.meta.java:3062)
            /**
             * The zero-based index the {@linkplain #next() next} token begins at.
             *
             * @since   notavaCC 1.0
             */
            protected int index;                                                // (JavaCodeGenerator.meta.java:3076)
            /**
             * The zero-based line number the {@linkplain #next() next} token begins at.
             *
             * @since   notavaCC 1.0
             */
            protected int line;                                                 // (JavaCodeGenerator.meta.java:3090)
            /**
             * The zero-based column number the {@linkplain #next() next} token begins at.
             *
             * @since   notavaCC 1.0
             */
            protected int column;                                               // (JavaCodeGenerator.meta.java:3104)
            /**
             * Constructs a lexical analyzer.
             * <p>
             *
             * @param   sourceName
             *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
             * @param   text
             *      the text to parse.
             * @param   tabStop
             *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
             * @since    notavaCC 1.0
             */
            public LexicalAnalyzer(java.lang.String sourceName, java.lang.CharSequence text, int tabStop) {    // (JavaCodeGenerator.meta.java:3132)
                this(sourceName, text, tabStop, 0, text.length(), 0, 0);        // (JavaCodeGenerator.meta.java:3133)
            }                                                                   // (JavaCodeGenerator.meta.java:3134)
            /**
             * Constructs a lexical analyzer that analyze a part of a text.
             * <p>
             *
             * @param   sourceName
             *      the name of the source, used only to set the result of {@link DanglingElseSyntax.Token#getSourceName()}.
             * @param   text
             *      the text to parse.
             * @param   tabStop
             *      the number that the tab character advances the cursor to the next column that is a multiple of.  <code>tabStop</code> is used only to set the result of {@link DanglingElseSyntax.Token#getColumn()}.
             * @param   start
             *      the inclusive start index of the text region to analyze.
             * @param   end
             *      the exclusive end index of the text region to analyze.
             * @param   line
             *      the zero-based line number of the <code>start</code> index.
             * @param   column
             *      the zero-based column number of the <code>start</code> index.
             * @since    notavaCC 1.0
             */
            public LexicalAnalyzer(java.lang.String sourceName, java.lang.CharSequence text, int tabStop, int start, int end, int line, int column) {    // (JavaCodeGenerator.meta.java:3178)
                this(sourceName, text, tabStop, start, end, line, column, DanglingElseSyntax.__dfaTable__notavacc_reserved, 0);    // (JavaCodeGenerator.meta.java:3179)
            }                                                                   // (JavaCodeGenerator.meta.java:3180)
            private LexicalAnalyzer(java.lang.String sourceName, java.lang.CharSequence text, int tabStop, int start, int end, int line, int column, int[][] table, int initialState) {    // (JavaCodeGenerator.meta.java:3181)
                this.sourceName = sourceName;                                   // (JavaCodeGenerator.meta.java:3182)
                this.text = text;                                               // (JavaCodeGenerator.meta.java:3183)
                this.end = end;                                                 // (JavaCodeGenerator.meta.java:3184)
                this.tabStop = tabStop;                                         // (JavaCodeGenerator.meta.java:3185)
                this.table = table;                                             // (JavaCodeGenerator.meta.java:3186)
                this.initialState = initialState;                               // (JavaCodeGenerator.meta.java:3187)
                this.index = start;                                             // (JavaCodeGenerator.meta.java:3188)
                this.line = line;                                               // (JavaCodeGenerator.meta.java:3189)
                this.column = column;                                           // (JavaCodeGenerator.meta.java:3190)
            }                                                                   // (JavaCodeGenerator.meta.java:3191)
            public DanglingElseSyntax.Token next() throws ParseException {      // (JavaCodeGenerator.meta.java:3192)
                if (index >= end)                                               // (JavaCodeGenerator.meta.java:3193)
                    return new DanglingElseSyntax.Default.Token(EOF_TOKEN, "", "", sourceName, index, -1, -1);    // (JavaCodeGenerator.meta.java:3194)
                                                                                // (JavaCodeGenerator.meta.java:3195)
                int state = initialState;                                       // (JavaCodeGenerator.meta.java:3196)
                                                                                // (JavaCodeGenerator.meta.java:3197)
                final int startIndex = index;                                   // (JavaCodeGenerator.meta.java:3198)
                final int startLine = line;                                     // (JavaCodeGenerator.meta.java:3199)
                final int startColumn = column;                                 // (JavaCodeGenerator.meta.java:3200)
                int lastHitID = -1;                                             // (JavaCodeGenerator.meta.java:3201)
                int lastHitIndex = -1;                                          // (JavaCodeGenerator.meta.java:3202)
                int lastHitLine = -1;                                           // (JavaCodeGenerator.meta.java:3203)
                int lastHitColumn = -1;                                         // (JavaCodeGenerator.meta.java:3204)
                int lastHitImageLength = 0;                                     // (JavaCodeGenerator.meta.java:3205)
                java.lang.StringBuffer image = new java.lang.StringBuffer();    // (JavaCodeGenerator.meta.java:3206)
                                                                                // (JavaCodeGenerator.meta.java:3207)
                try {                                                           // (JavaCodeGenerator.meta.java:3208)
                    dfa:                                                        // (JavaCodeGenerator.meta.java:3209)
                    while (index < end) {                                       // (JavaCodeGenerator.meta.java:3210)
                        char ch = nextChar();                                   // (JavaCodeGenerator.meta.java:3211)
                        image.append(ch);                                       // (JavaCodeGenerator.meta.java:3212)
                                                                                // (JavaCodeGenerator.meta.java:3213)
                        int[] map = table[state];                               // (JavaCodeGenerator.meta.java:3214)
                        int base = 1;                                           // (JavaCodeGenerator.meta.java:3215)
                        int width = (map.length - 1) / 3;                       // (JavaCodeGenerator.meta.java:3216)
                        while (width > 1) {                                     // (JavaCodeGenerator.meta.java:3218)
                            int halfWidth = width >> 1;                         // (JavaCodeGenerator.meta.java:3219)
                            int mid = base + halfWidth * 3;                     // (JavaCodeGenerator.meta.java:3220)
                            if (ch >= map[mid]) {                               // (JavaCodeGenerator.meta.java:3221)
                                base = mid;                                     // (JavaCodeGenerator.meta.java:3222)
                                width -= halfWidth;                             // (JavaCodeGenerator.meta.java:3223)
                            } else {                                            // (JavaCodeGenerator.meta.java:3224)
                                width = halfWidth;                              // (JavaCodeGenerator.meta.java:3225)
                            }                                                   // (JavaCodeGenerator.meta.java:3226)
                        }                                                       // (JavaCodeGenerator.meta.java:3227)
                        int i = 0;                                              // (JavaCodeGenerator.meta.java:3228)
                        for (;;) {                                              // (JavaCodeGenerator.meta.java:3229)
                            if (i++ >= width)                                   // (JavaCodeGenerator.meta.java:3230)
                                break dfa;                                      // (JavaCodeGenerator.meta.java:3231)
                            if (map[base] <= ch & ch <= map[base + 1]) {        // (JavaCodeGenerator.meta.java:3232)
                                state = map[base + 2];                          // (JavaCodeGenerator.meta.java:3233)
                                break;                                          // (JavaCodeGenerator.meta.java:3234)
                            }                                                   // (JavaCodeGenerator.meta.java:3235)
                            base += 3;                                          // (JavaCodeGenerator.meta.java:3236)
                        }                                                       // (JavaCodeGenerator.meta.java:3237)
                        int hitID = table[state][0];                            // (JavaCodeGenerator.meta.java:3238)
                        if (hitID != -1) {                                      // (JavaCodeGenerator.meta.java:3239)
                            lastHitID = hitID;                                  // (JavaCodeGenerator.meta.java:3240)
                            lastHitIndex = index;                               // (JavaCodeGenerator.meta.java:3241)
                            lastHitLine = line;                                 // (JavaCodeGenerator.meta.java:3242)
                            lastHitColumn = column;                             // (JavaCodeGenerator.meta.java:3243)
                            lastHitImageLength = image.length();                // (JavaCodeGenerator.meta.java:3244)
                        }                                                       // (JavaCodeGenerator.meta.java:3245)
                    }                                                           // (JavaCodeGenerator.meta.java:3246)
                                                                                // (JavaCodeGenerator.meta.java:3247)
                    if (lastHitID == -1) {                                      // (JavaCodeGenerator.meta.java:3248)
                        throw new ParseException("An invalid character sequence starting with '" + text.subSequence(startIndex, index) + "' (line " + (startLine + 1) + ", column " + (startColumn + 1) + ")", sourceName, startIndex, startLine + 1, startColumn + 1);    // (JavaCodeGenerator.meta.java:3249)
                    }                                                           // (JavaCodeGenerator.meta.java:3250)
                } finally {                                                     // (JavaCodeGenerator.meta.java:3251)
                    index = startIndex;                                         // (JavaCodeGenerator.meta.java:3252)
                    line = startLine;                                           // (JavaCodeGenerator.meta.java:3253)
                    column = startColumn;                                       // (JavaCodeGenerator.meta.java:3254)
                }                                                               // (JavaCodeGenerator.meta.java:3255)
                                                                                // (JavaCodeGenerator.meta.java:3256)
                DanglingElseSyntax.Token result = new DanglingElseSyntax.Default.Token(lastHitID, image.substring(0, lastHitImageLength).intern(), text.subSequence(startIndex, lastHitIndex).toString().intern(), sourceName, startIndex, startLine + 1, startColumn + 1);    // (JavaCodeGenerator.meta.java:3257)
                                                                                // (JavaCodeGenerator.meta.java:3258)
                index = lastHitIndex;                                           // (JavaCodeGenerator.meta.java:3259)
                line = lastHitLine;                                             // (JavaCodeGenerator.meta.java:3260)
                column = lastHitColumn;                                         // (JavaCodeGenerator.meta.java:3261)
                                                                                // (JavaCodeGenerator.meta.java:3262)
                return result;                                                  // (JavaCodeGenerator.meta.java:3263)
            } // next()                                                         // (JavaCodeGenerator.meta.java:3264)
            /**
             * Returns the next character in the {@link #text}.
             * <p>
             * This method returns the character starting at {@link #index} in the sequence and updates {@link #index}, {@link #line}, and {@link #column} to point the next character of the returned character.  This method is overridden in order to deal with a string as a character through the input sequence like Unicode escapes of Java.
             *
             * @return  the next character in the sequence.
             * @throws  java.lang.IndexOutOfBoundsException  if <code>index >= end</code>
             * @since   notavaCC 1.0
             */
            protected char nextChar() throws ParseException, java.lang.IndexOutOfBoundsException {    // (JavaCodeGenerator.meta.java:3287)
                return nextExactChar();                                         // (JavaCodeGenerator.meta.java:3288)
            }                                                                   // (JavaCodeGenerator.meta.java:3289)
            /**
             * Returns the next character in the {@link #text} based on the Unicode escapes.
             *
             * @return  the next character in the sequence.
             * @throws  ParseException
             *              for a illegal escape.
             * @throws  java.lang.IndexOutOfBoundsException
             *              if <code>index >= end</code>
             * @since   notavaCC 1.0
             */
            protected final char nextUnicodeEscapedChar() throws ParseException, java.lang.IndexOutOfBoundsException {    // (JavaCodeGenerator.meta.java:3313)
                int startIndex = this.index;                                    // (JavaCodeGenerator.meta.java:3314)
                int startLine = line;                                           // (JavaCodeGenerator.meta.java:3315)
                int startColumn = column;                                       // (JavaCodeGenerator.meta.java:3316)
                {                                                               // (JavaCodeGenerator.meta.java:3317)
                    int index = startIndex;                                     // (JavaCodeGenerator.meta.java:3318)
                    if (text.charAt(index) == '\\' && index + 1 < end && text.charAt(index + 1) == 'u') {    // (JavaCodeGenerator.meta.java:3319)
                        int count = 0;                                          // (JavaCodeGenerator.meta.java:3320)
                        while (index >= 0 && text.charAt(index--) == '\\')      // (JavaCodeGenerator.meta.java:3321)
                            count++;                                            // (JavaCodeGenerator.meta.java:3322)
                        if (count % 2 == 0)                                     // (JavaCodeGenerator.meta.java:3323)
                            return nextExactChar();                             // (JavaCodeGenerator.meta.java:3324)
                    } else {                                                    // (JavaCodeGenerator.meta.java:3325)
                        return nextExactChar();                                 // (JavaCodeGenerator.meta.java:3326)
                    }                                                           // (JavaCodeGenerator.meta.java:3327)
                }                                                               // (JavaCodeGenerator.meta.java:3328)
                                                                                // (JavaCodeGenerator.meta.java:3329)
                char ch = nextExactChar();                                      // (JavaCodeGenerator.meta.java:3330)
                assert (ch =='\\');                                             // (JavaCodeGenerator.meta.java:3331)
                ch = nextExactChar();                                           // (JavaCodeGenerator.meta.java:3332)
                assert (ch == 'u');                                             // (JavaCodeGenerator.meta.java:3333)
                try {                                                           // (JavaCodeGenerator.meta.java:3334)
                    do {                                                        // (JavaCodeGenerator.meta.java:3335)
                        ch = nextExactChar();                                   // (JavaCodeGenerator.meta.java:3336)
                    } while (ch == 'u');                                        // (JavaCodeGenerator.meta.java:3337)
                    java.lang.StringBuffer number = new java.lang.StringBuffer(4);    // (JavaCodeGenerator.meta.java:3338)
                    number.append(ch);                                          // (JavaCodeGenerator.meta.java:3339)
                    number.append(nextExactChar());                             // (JavaCodeGenerator.meta.java:3340)
                    number.append(nextExactChar());                             // (JavaCodeGenerator.meta.java:3341)
                    number.append(nextExactChar());                             // (JavaCodeGenerator.meta.java:3342)
                    int code = java.lang.Integer.parseInt(number.toString(), 16);    // (JavaCodeGenerator.meta.java:3343)
                    return (char) code;                                         // (JavaCodeGenerator.meta.java:3344)
                } catch (java.lang.NumberFormatException x) {                   // (JavaCodeGenerator.meta.java:3345)
                } catch (java.lang.IndexOutOfBoundsException x) {               // (JavaCodeGenerator.meta.java:3346)
                }                                                               // (JavaCodeGenerator.meta.java:3347)
                throw new ParseException("illigal Unicode escape: " + text.subSequence(startIndex, index), sourceName, startIndex, startLine, startColumn);    // (JavaCodeGenerator.meta.java:3348)
            }                                                                   // (JavaCodeGenerator.meta.java:3349)
            private final char nextExactChar() throws ParseException, java.lang.IndexOutOfBoundsException {    // (JavaCodeGenerator.meta.java:3350)
                if (index >= end)                                               // (JavaCodeGenerator.meta.java:3351)
                    throw new java.lang.IndexOutOfBoundsException();            // (JavaCodeGenerator.meta.java:3352)
                char ch = text.charAt(index++);                                 // (JavaCodeGenerator.meta.java:3353)
                switch (ch) {                                                   // (JavaCodeGenerator.meta.java:3354)
                case '\r':                                                      // (JavaCodeGenerator.meta.java:3355)
                case '\n':                                                      // (JavaCodeGenerator.meta.java:3356)
                    if (ch == '\r') {                                           // (JavaCodeGenerator.meta.java:3357)
                        if (index < end && text.charAt(index) == '\n')          // (JavaCodeGenerator.meta.java:3358)
                            break;                                              // (JavaCodeGenerator.meta.java:3359)
                    }                                                           // (JavaCodeGenerator.meta.java:3360)
                    line++;                                                     // (JavaCodeGenerator.meta.java:3361)
                    column = 0;                                                 // (JavaCodeGenerator.meta.java:3362)
                    break;                                                      // (JavaCodeGenerator.meta.java:3363)
                case '\t':                                                      // (JavaCodeGenerator.meta.java:3364)
                    if (tabStop >= 1)                                           // (JavaCodeGenerator.meta.java:3365)
                        column = column - (column % tabStop) + tabStop;         // (JavaCodeGenerator.meta.java:3366)
                    break;                                                      // (JavaCodeGenerator.meta.java:3367)
                default:                                                        // (JavaCodeGenerator.meta.java:3368)
                    column++;                                                   // (JavaCodeGenerator.meta.java:3369)
                    break;                                                      // (JavaCodeGenerator.meta.java:3370)
                }                                                               // (JavaCodeGenerator.meta.java:3371)
                return ch;                                                      // (JavaCodeGenerator.meta.java:3372)
            }                                                                   // (JavaCodeGenerator.meta.java:3373)
        } // class Default.LexicalAnalyzer                                      // (JavaCodeGenerator.meta.java:3374)
                                                                                // (JavaCodeGenerator.meta.java:3375)
                                                                                // (JavaCodeGenerator.meta.java:3376)
        public static class AmbiguityAbsorber extends Default.Node implements DanglingElseSyntax.AmbiguityAbsorber {    // (JavaCodeGenerator.meta.java:3378)
            public AmbiguityAbsorber(java.util.List ambiguityNodes) {           // (JavaCodeGenerator.meta.java:3379)
                super(ambiguityNodes);                                          // (JavaCodeGenerator.meta.java:3380)
            }                                                                   // (JavaCodeGenerator.meta.java:3381)
            public DanglingElseSyntax.AmbiguityAbsorber getWrappedAmbiguityAbsorber() {    // (JavaCodeGenerator.meta.java:3382)
                return this;                                                    // (JavaCodeGenerator.meta.java:3383)
            }                                                                   // (JavaCodeGenerator.meta.java:3384)
        }                                                                       // (JavaCodeGenerator.meta.java:3385)
                                                                                // (JavaCodeGenerator.meta.java:3386)
                                                                                // (JavaCodeGenerator.meta.java:3399)
        public static class DanglingElseAbsorber extends AmbiguityAbsorber implements DanglingElseSyntax.DanglingElseAbsorber {    // (JavaCodeGenerator.meta.java:3408)
            public DanglingElseSyntax.Node thenPart() {                         // (JavaCodeGenerator.meta.java:3416)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:3417)
            }                                                                   // (JavaCodeGenerator.meta.java:3418)
            public DanglingElseSyntax.Node elsePart() {                         // (JavaCodeGenerator.meta.java:3416)
                throw new java.lang.UnsupportedOperationException();            // (JavaCodeGenerator.meta.java:3417)
            }                                                                   // (JavaCodeGenerator.meta.java:3418)
            private DanglingElseSyntax.ShortIf shortIf;                         // (JavaCodeGenerator.meta.java:3422)
            public DanglingElseSyntax.ShortIf shortIf() {                       // (JavaCodeGenerator.meta.java:3423)
                return shortIf;                                                 // (JavaCodeGenerator.meta.java:3424)
            }                                                                   // (JavaCodeGenerator.meta.java:3425)
            private DanglingElseSyntax.LongIf longIf;                           // (JavaCodeGenerator.meta.java:3422)
            public DanglingElseSyntax.LongIf longIf() {                         // (JavaCodeGenerator.meta.java:3423)
                return longIf;                                                  // (JavaCodeGenerator.meta.java:3424)
            }                                                                   // (JavaCodeGenerator.meta.java:3425)
                                                                                // (JavaCodeGenerator.meta.java:3440)
            public DanglingElseAbsorber(java.util.List ambiguityNodes, DanglingElseSyntax.ShortIf shortIfArg, DanglingElseSyntax.LongIf longIfArg) {    // (JavaCodeGenerator.meta.java:3463)
                super(ambiguityNodes);                                          // (JavaCodeGenerator.meta.java:3464)
                                                                                // (JavaCodeGenerator.meta.java:3465)
                this.shortIf = shortIfArg;                                      // (JavaCodeGenerator.meta.java:3472)
                this.longIf = longIfArg;                                        // (JavaCodeGenerator.meta.java:3472)
            }                                                                   // (JavaCodeGenerator.meta.java:3476)
                                                                                // (JavaCodeGenerator.meta.java:3477)
            private static DanglingElseSyntax.AmbiguityAbsorber tryToCreate(java.util.List nodes) {    // (JavaCodeGenerator.meta.java:3478)
                java.util.List uneatenNodes = new java.util.LinkedList(nodes);    // (JavaCodeGenerator.meta.java:3479)
                DanglingElseSyntax.ShortIf shortIfTmp = null;                   // (JavaCodeGenerator.meta.java:3502)
                {                                                               // (JavaCodeGenerator.meta.java:3503)
                    java.util.Iterator it = uneatenNodes.iterator();            // (JavaCodeGenerator.meta.java:3504)
                    while (it.hasNext()) {                                      // (JavaCodeGenerator.meta.java:3505)
                        DanglingElseSyntax.Node node = (DanglingElseSyntax.Node) it.next();    // (JavaCodeGenerator.meta.java:3506)
                        if (node instanceof DanglingElseSyntax.ShortIf) {       // (JavaCodeGenerator.meta.java:3507)
                            shortIfTmp = (DanglingElseSyntax.ShortIf) node;     // (JavaCodeGenerator.meta.java:3508)
                            it.remove();                                        // (JavaCodeGenerator.meta.java:3509)
                            break;                                              // (JavaCodeGenerator.meta.java:3510)
                        }                                                       // (JavaCodeGenerator.meta.java:3511)
                    }                                                           // (JavaCodeGenerator.meta.java:3512)
                }                                                               // (JavaCodeGenerator.meta.java:3513)
                DanglingElseSyntax.LongIf longIfTmp = null;                     // (JavaCodeGenerator.meta.java:3502)
                {                                                               // (JavaCodeGenerator.meta.java:3503)
                    java.util.Iterator it = uneatenNodes.iterator();            // (JavaCodeGenerator.meta.java:3504)
                    while (it.hasNext()) {                                      // (JavaCodeGenerator.meta.java:3505)
                        DanglingElseSyntax.Node node = (DanglingElseSyntax.Node) it.next();    // (JavaCodeGenerator.meta.java:3506)
                        if (node instanceof DanglingElseSyntax.LongIf) {        // (JavaCodeGenerator.meta.java:3507)
                            longIfTmp = (DanglingElseSyntax.LongIf) node;       // (JavaCodeGenerator.meta.java:3508)
                            it.remove();                                        // (JavaCodeGenerator.meta.java:3509)
                            break;                                              // (JavaCodeGenerator.meta.java:3510)
                        }                                                       // (JavaCodeGenerator.meta.java:3511)
                    }                                                           // (JavaCodeGenerator.meta.java:3512)
                }                                                               // (JavaCodeGenerator.meta.java:3513)
                if (!uneatenNodes.isEmpty())                                    // (JavaCodeGenerator.meta.java:3516)
                    return null;                                                // (JavaCodeGenerator.meta.java:3517)
                                                                                // (JavaCodeGenerator.meta.java:3518)
                return new DanglingElseAbsorber(nodes, shortIfTmp, longIfTmp);    // (JavaCodeGenerator.meta.java:3552)
            }                                                                   // (JavaCodeGenerator.meta.java:3553)
        }                                                                       // (JavaCodeGenerator.meta.java:3554)
                                                                                // (JavaCodeGenerator.meta.java:3557)
        /**
         * An implementation of <code>Root</code> node.
         *
         * @since   notavaCC 1.0
         */
        public static class Root extends Default.Node implements DanglingElseSyntax.Root {    // (JavaCodeGenerator.meta.java:3609)
                                                                                // (JavaCodeGenerator.meta.java:3633)
            private Root(java.util.List childNodes) {                           // (JavaCodeGenerator.meta.java:3639)
                super(childNodes);                                              // (JavaCodeGenerator.meta.java:3640)
            }                                                                   // (JavaCodeGenerator.meta.java:3641)
                                                                                // (JavaCodeGenerator.meta.java:3643)
            /**
             * Constructs a instance with the child nodes given by <code>source.getChildNodes()</code> etc.
             * <code>List</code> objects are copied.
             *
             * @param   source
             *            the source.
             */
            public Root(DanglingElseSyntax.Root source) {                       // (JavaCodeGenerator.meta.java:3677)
                this(new java.util.LinkedList(source.getChildNodes()));         // (JavaCodeGenerator.meta.java:3681)
                                                                                // (JavaCodeGenerator.meta.java:3683)
            }                                                                   // (JavaCodeGenerator.meta.java:3706)
                                                                                // (JavaCodeGenerator.meta.java:3707)
            /**
             * Constructs a instance with the child nodes given by <code>parameters</code>.
             *
             * @param   parameters
             *            the parameters for initialization.
             * @param   compact
             *            remove the children that are not labeled.
             */
            public Root(DanglingElseSyntax.NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:3727)
                this(new java.util.LinkedList());                               // (JavaCodeGenerator.meta.java:3731)
                                                                                // (JavaCodeGenerator.meta.java:3733)
                DanglingElseSyntax.Node[] childNodes = parameters.childNodes;    // (JavaCodeGenerator.meta.java:3734)
                java.util.List labelBitsList = parameters.labelBitsList;        // (JavaCodeGenerator.meta.java:3735)
                                                                                // (JavaCodeGenerator.meta.java:3736)
                                                                                // (JavaCodeGenerator.meta.java:3752)
                java.util.Iterator it = labelBitsList.iterator();               // (JavaCodeGenerator.meta.java:3770)
                int size = labelBitsList.size();                                // (JavaCodeGenerator.meta.java:3771)
                for (int i = 0; i < size; i++) {                                // (JavaCodeGenerator.meta.java:3772)
                    java.lang.Integer number = (java.lang.Integer) it.next();    // (JavaCodeGenerator.meta.java:3774)
                    int no = (number == null) ? 0 : number.intValue();          // (JavaCodeGenerator.meta.java:3775)
                    if (!compact || no != 0)                                    // (JavaCodeGenerator.meta.java:3782)
                        getChildNodes().add(childNodes[i]);                     // (JavaCodeGenerator.meta.java:3783)
                }                                                               // (JavaCodeGenerator.meta.java:3840)
                                                                                // (JavaCodeGenerator.meta.java:3843)
            }                                                                   // (JavaCodeGenerator.meta.java:3860)
                                                                                // (JavaCodeGenerator.meta.java:3861)
                                                                                // (JavaCodeGenerator.meta.java:3929)
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:3930)
                if (oldChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3932)
                    oldChild = oldChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3933)
                if (newChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3934)
                    newChild = newChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3935)
                                                                                // (JavaCodeGenerator.meta.java:3936)
                super.replaceChild(oldChild, newChild);                         // (JavaCodeGenerator.meta.java:3939)
                                                                                // (JavaCodeGenerator.meta.java:3943)
                if (newChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:3945)
                                                                                // (JavaCodeGenerator.meta.java:3978)
                    if (oldChild == null) {                                     // (JavaCodeGenerator.meta.java:3979)
                    } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4001)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4023)
                    }                                                           // (JavaCodeGenerator.meta.java:4044)
                    return;                                                     // (JavaCodeGenerator.meta.java:4045)
                }                                                               // (JavaCodeGenerator.meta.java:4046)
                                                                                // (JavaCodeGenerator.meta.java:4048)
                                                                                // (JavaCodeGenerator.meta.java:4049)
                                                                                // (JavaCodeGenerator.meta.java:4080)
                if (oldChild == null) {                                         // (JavaCodeGenerator.meta.java:4081)
                } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4094)
                } else {                                                        // (JavaCodeGenerator.meta.java:4107)
                }                                                               // (JavaCodeGenerator.meta.java:4119)
            }                                                                   // (JavaCodeGenerator.meta.java:4120)
                                                                                // (JavaCodeGenerator.meta.java:4121)
                                                                                // (JavaCodeGenerator.meta.java:4176)
        } // class Root                                                         // (JavaCodeGenerator.meta.java:4177)
        /**
         * An implementation of <code>SingleLineStatement</code> node.
         *
         * @since   notavaCC 1.0
         */
        public static class SingleLineStatement extends Default.Node implements DanglingElseSyntax.SingleLineStatement {    // (JavaCodeGenerator.meta.java:3609)
                                                                                // (JavaCodeGenerator.meta.java:3633)
            private SingleLineStatement(java.util.List childNodes) {            // (JavaCodeGenerator.meta.java:3639)
                super(childNodes);                                              // (JavaCodeGenerator.meta.java:3640)
            }                                                                   // (JavaCodeGenerator.meta.java:3641)
                                                                                // (JavaCodeGenerator.meta.java:3643)
            /**
             * Constructs a instance with the child nodes given by <code>source.getChildNodes()</code> etc.
             * <code>List</code> objects are copied.
             *
             * @param   source
             *            the source.
             */
            public SingleLineStatement(DanglingElseSyntax.SingleLineStatement source) {    // (JavaCodeGenerator.meta.java:3677)
                this(new java.util.LinkedList(source.getChildNodes()));         // (JavaCodeGenerator.meta.java:3681)
                                                                                // (JavaCodeGenerator.meta.java:3683)
            }                                                                   // (JavaCodeGenerator.meta.java:3706)
                                                                                // (JavaCodeGenerator.meta.java:3707)
            /**
             * Constructs a instance with the child nodes given by <code>parameters</code>.
             *
             * @param   parameters
             *            the parameters for initialization.
             * @param   compact
             *            remove the children that are not labeled.
             */
            public SingleLineStatement(DanglingElseSyntax.NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:3727)
                this(new java.util.LinkedList());                               // (JavaCodeGenerator.meta.java:3731)
                                                                                // (JavaCodeGenerator.meta.java:3733)
                DanglingElseSyntax.Node[] childNodes = parameters.childNodes;    // (JavaCodeGenerator.meta.java:3734)
                java.util.List labelBitsList = parameters.labelBitsList;        // (JavaCodeGenerator.meta.java:3735)
                                                                                // (JavaCodeGenerator.meta.java:3736)
                                                                                // (JavaCodeGenerator.meta.java:3752)
                java.util.Iterator it = labelBitsList.iterator();               // (JavaCodeGenerator.meta.java:3770)
                int size = labelBitsList.size();                                // (JavaCodeGenerator.meta.java:3771)
                for (int i = 0; i < size; i++) {                                // (JavaCodeGenerator.meta.java:3772)
                    java.lang.Integer number = (java.lang.Integer) it.next();    // (JavaCodeGenerator.meta.java:3774)
                    int no = (number == null) ? 0 : number.intValue();          // (JavaCodeGenerator.meta.java:3775)
                    if (!compact || no != 0)                                    // (JavaCodeGenerator.meta.java:3782)
                        getChildNodes().add(childNodes[i]);                     // (JavaCodeGenerator.meta.java:3783)
                }                                                               // (JavaCodeGenerator.meta.java:3840)
                                                                                // (JavaCodeGenerator.meta.java:3843)
            }                                                                   // (JavaCodeGenerator.meta.java:3860)
                                                                                // (JavaCodeGenerator.meta.java:3861)
                                                                                // (JavaCodeGenerator.meta.java:3929)
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:3930)
                if (oldChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3932)
                    oldChild = oldChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3933)
                if (newChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3934)
                    newChild = newChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3935)
                                                                                // (JavaCodeGenerator.meta.java:3936)
                super.replaceChild(oldChild, newChild);                         // (JavaCodeGenerator.meta.java:3939)
                                                                                // (JavaCodeGenerator.meta.java:3943)
                if (newChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:3945)
                                                                                // (JavaCodeGenerator.meta.java:3978)
                    if (oldChild == null) {                                     // (JavaCodeGenerator.meta.java:3979)
                    } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4001)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4023)
                    }                                                           // (JavaCodeGenerator.meta.java:4044)
                    return;                                                     // (JavaCodeGenerator.meta.java:4045)
                }                                                               // (JavaCodeGenerator.meta.java:4046)
                                                                                // (JavaCodeGenerator.meta.java:4048)
                                                                                // (JavaCodeGenerator.meta.java:4049)
                                                                                // (JavaCodeGenerator.meta.java:4080)
                if (oldChild == null) {                                         // (JavaCodeGenerator.meta.java:4081)
                } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4094)
                } else {                                                        // (JavaCodeGenerator.meta.java:4107)
                }                                                               // (JavaCodeGenerator.meta.java:4119)
            }                                                                   // (JavaCodeGenerator.meta.java:4120)
                                                                                // (JavaCodeGenerator.meta.java:4121)
                                                                                // (JavaCodeGenerator.meta.java:4176)
        } // class SingleLineStatement                                          // (JavaCodeGenerator.meta.java:4177)
        /**
         * An implementation of <code>IfThenElseStatement</code> node.
         *
         * @since   notavaCC 1.0
         */
        public abstract static class IfThenElseStatement extends Default.Node implements DanglingElseSyntax.IfThenElseStatement {    // (JavaCodeGenerator.meta.java:3609)
            private DanglingElseSyntax.Node thenPart;                           // (JavaCodeGenerator.meta.java:3616)
            public DanglingElseSyntax.Node thenPart() {                         // (JavaCodeGenerator.meta.java:3617)
                return thenPart;                                                // (JavaCodeGenerator.meta.java:3618)
            }                                                                   // (JavaCodeGenerator.meta.java:3619)
            private DanglingElseSyntax.Node elsePart;                           // (JavaCodeGenerator.meta.java:3616)
            public DanglingElseSyntax.Node elsePart() {                         // (JavaCodeGenerator.meta.java:3617)
                return elsePart;                                                // (JavaCodeGenerator.meta.java:3618)
            }                                                                   // (JavaCodeGenerator.meta.java:3619)
                                                                                // (JavaCodeGenerator.meta.java:3633)
            private IfThenElseStatement(java.util.List childNodes) {            // (JavaCodeGenerator.meta.java:3639)
                super(childNodes);                                              // (JavaCodeGenerator.meta.java:3640)
            }                                                                   // (JavaCodeGenerator.meta.java:3641)
                                                                                // (JavaCodeGenerator.meta.java:3643)
            /**
             * Constructs a instance with the child nodes given by <code>source.getChildNodes()</code> etc.
             * <code>List</code> objects are copied.
             *
             * @param   source
             *            the source.
             */
            public IfThenElseStatement(DanglingElseSyntax.IfThenElseStatement source) {    // (JavaCodeGenerator.meta.java:3677)
                this(new java.util.LinkedList(source.getChildNodes()));         // (JavaCodeGenerator.meta.java:3681)
                                                                                // (JavaCodeGenerator.meta.java:3683)
                this.thenPart = source.thenPart();                              // (JavaCodeGenerator.meta.java:3702)
                this.elsePart = source.elsePart();                              // (JavaCodeGenerator.meta.java:3702)
            }                                                                   // (JavaCodeGenerator.meta.java:3706)
                                                                                // (JavaCodeGenerator.meta.java:3707)
            /**
             * Constructs a instance with the child nodes given by <code>parameters</code>.
             *
             * @param   parameters
             *            the parameters for initialization.
             * @param   compact
             *            remove the children that are not labeled.
             */
            public IfThenElseStatement(DanglingElseSyntax.NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:3727)
                this(new java.util.LinkedList());                               // (JavaCodeGenerator.meta.java:3731)
                                                                                // (JavaCodeGenerator.meta.java:3733)
                DanglingElseSyntax.Node[] childNodes = parameters.childNodes;    // (JavaCodeGenerator.meta.java:3734)
                java.util.List labelBitsList = parameters.labelBitsList;        // (JavaCodeGenerator.meta.java:3735)
                                                                                // (JavaCodeGenerator.meta.java:3736)
                                                                                // (JavaCodeGenerator.meta.java:3752)
                java.util.Iterator it = labelBitsList.iterator();               // (JavaCodeGenerator.meta.java:3770)
                int size = labelBitsList.size();                                // (JavaCodeGenerator.meta.java:3771)
                for (int i = 0; i < size; i++) {                                // (JavaCodeGenerator.meta.java:3772)
                    java.lang.Integer number = (java.lang.Integer) it.next();    // (JavaCodeGenerator.meta.java:3774)
                    int no = (number == null) ? 0 : number.intValue();          // (JavaCodeGenerator.meta.java:3775)
                    if (!compact || no != 0)                                    // (JavaCodeGenerator.meta.java:3782)
                        getChildNodes().add(childNodes[i]);                     // (JavaCodeGenerator.meta.java:3783)
                    if ((no & (1 << 2)) != 0) {                                 // (JavaCodeGenerator.meta.java:3802)
                        DanglingElseSyntax.Node node = childNodes[i];           // (JavaCodeGenerator.meta.java:3822)
                        if (!(node instanceof DanglingElseSyntax.Node)) {       // (JavaCodeGenerator.meta.java:3823)
                            node = __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) node, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:3827)
                        }                                                       // (JavaCodeGenerator.meta.java:3830)
                        this.thenPart = (DanglingElseSyntax.Node) node;         // (JavaCodeGenerator.meta.java:3831)
                    }                                                           // (JavaCodeGenerator.meta.java:3836)
                    if ((no & (1 << 1)) != 0) {                                 // (JavaCodeGenerator.meta.java:3802)
                        DanglingElseSyntax.Node node = childNodes[i];           // (JavaCodeGenerator.meta.java:3822)
                        if (!(node instanceof DanglingElseSyntax.Node)) {       // (JavaCodeGenerator.meta.java:3823)
                            node = __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) node, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:3827)
                        }                                                       // (JavaCodeGenerator.meta.java:3830)
                        this.elsePart = (DanglingElseSyntax.Node) node;         // (JavaCodeGenerator.meta.java:3831)
                    }                                                           // (JavaCodeGenerator.meta.java:3836)
                }                                                               // (JavaCodeGenerator.meta.java:3840)
                                                                                // (JavaCodeGenerator.meta.java:3843)
            }                                                                   // (JavaCodeGenerator.meta.java:3860)
                                                                                // (JavaCodeGenerator.meta.java:3861)
            public IfThenElseStatement(java.util.List childNodes, DanglingElseSyntax.Node thenPart, DanglingElseSyntax.Node elsePart) {    // (JavaCodeGenerator.meta.java:3874)
                this(childNodes);                                               // (JavaCodeGenerator.meta.java:3875)
                                                                                // (JavaCodeGenerator.meta.java:3876)
                this.thenPart = thenPart;                                       // (JavaCodeGenerator.meta.java:3893)
                                                                                // (JavaCodeGenerator.meta.java:3895)
                if (thenPart != null)                                           // (JavaCodeGenerator.meta.java:3903)
                    getChildNodes().add(thenPart);                              // (JavaCodeGenerator.meta.java:3904)
                this.elsePart = elsePart;                                       // (JavaCodeGenerator.meta.java:3893)
                                                                                // (JavaCodeGenerator.meta.java:3895)
                if (elsePart != null)                                           // (JavaCodeGenerator.meta.java:3903)
                    getChildNodes().add(elsePart);                              // (JavaCodeGenerator.meta.java:3904)
                                                                                // (JavaCodeGenerator.meta.java:3907)
            }                                                                   // (JavaCodeGenerator.meta.java:3926)
                                                                                // (JavaCodeGenerator.meta.java:3929)
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:3930)
                if (oldChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3932)
                    oldChild = oldChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3933)
                if (newChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3934)
                    newChild = newChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3935)
                                                                                // (JavaCodeGenerator.meta.java:3936)
                super.replaceChild(oldChild, newChild);                         // (JavaCodeGenerator.meta.java:3939)
                                                                                // (JavaCodeGenerator.meta.java:3943)
                if (newChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:3945)
                                                                                // (JavaCodeGenerator.meta.java:3978)
                    if (oldChild == null) {                                     // (JavaCodeGenerator.meta.java:3979)
                        if (this.thenPart == null) {                            // (JavaCodeGenerator.meta.java:3986)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:3987)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:3988)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:3989)
                            else                                                // (JavaCodeGenerator.meta.java:3990)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:3992)
                            this.thenPart = tmp;                                // (JavaCodeGenerator.meta.java:3995)
                        }                                                       // (JavaCodeGenerator.meta.java:3996)
                        if (this.elsePart == null) {                            // (JavaCodeGenerator.meta.java:3986)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:3987)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:3988)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:3989)
                            else                                                // (JavaCodeGenerator.meta.java:3990)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:3992)
                            this.elsePart = tmp;                                // (JavaCodeGenerator.meta.java:3995)
                        }                                                       // (JavaCodeGenerator.meta.java:3996)
                    } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4001)
                        if (oldChild.equals(this.thenPart) || this.thenPart != null && oldChild.equals(this.thenPart.getWrappedAmbiguityAbsorber())) {    // (JavaCodeGenerator.meta.java:4008)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:4009)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:4010)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:4011)
                            else                                                // (JavaCodeGenerator.meta.java:4012)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:4014)
                            this.thenPart = tmp;                                // (JavaCodeGenerator.meta.java:4017)
                        }                                                       // (JavaCodeGenerator.meta.java:4018)
                        if (oldChild.equals(this.elsePart) || this.elsePart != null && oldChild.equals(this.elsePart.getWrappedAmbiguityAbsorber())) {    // (JavaCodeGenerator.meta.java:4008)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:4009)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:4010)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:4011)
                            else                                                // (JavaCodeGenerator.meta.java:4012)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:4014)
                            this.elsePart = tmp;                                // (JavaCodeGenerator.meta.java:4017)
                        }                                                       // (JavaCodeGenerator.meta.java:4018)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4023)
                        if (oldChild.equals(this.thenPart)) {                   // (JavaCodeGenerator.meta.java:4030)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:4031)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:4032)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:4033)
                            else                                                // (JavaCodeGenerator.meta.java:4034)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:4036)
                            this.thenPart = tmp;                                // (JavaCodeGenerator.meta.java:4039)
                        }                                                       // (JavaCodeGenerator.meta.java:4040)
                        if (oldChild.equals(this.elsePart)) {                   // (JavaCodeGenerator.meta.java:4030)
                            DanglingElseSyntax.Node tmp;                        // (JavaCodeGenerator.meta.java:4031)
                            if (newChild instanceof DanglingElseSyntax.Node)    // (JavaCodeGenerator.meta.java:4032)
                                tmp = (DanglingElseSyntax.Node) newChild;       // (JavaCodeGenerator.meta.java:4033)
                            else                                                // (JavaCodeGenerator.meta.java:4034)
                                tmp = (DanglingElseSyntax.Node) __createAmbiguousWrapper__notavacc_reserved((DanglingElseSyntax.AmbiguityAbsorber) newChild, DanglingElseSyntax.Node.class);    // (JavaCodeGenerator.meta.java:4036)
                            this.elsePart = tmp;                                // (JavaCodeGenerator.meta.java:4039)
                        }                                                       // (JavaCodeGenerator.meta.java:4040)
                    }                                                           // (JavaCodeGenerator.meta.java:4044)
                    return;                                                     // (JavaCodeGenerator.meta.java:4045)
                }                                                               // (JavaCodeGenerator.meta.java:4046)
                                                                                // (JavaCodeGenerator.meta.java:4048)
                                                                                // (JavaCodeGenerator.meta.java:4049)
                                                                                // (JavaCodeGenerator.meta.java:4080)
                if (oldChild == null) {                                         // (JavaCodeGenerator.meta.java:4081)
                    if (this.thenPart == null)                                  // (JavaCodeGenerator.meta.java:4088)
                        this.thenPart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4089)
                    if (this.elsePart == null)                                  // (JavaCodeGenerator.meta.java:4088)
                        this.elsePart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4089)
                } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4094)
                    if (oldChild.equals(this.thenPart) || this.thenPart != null && oldChild.equals(this.thenPart.getWrappedAmbiguityAbsorber()))    // (JavaCodeGenerator.meta.java:4101)
                        this.thenPart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4102)
                    if (oldChild.equals(this.elsePart) || this.elsePart != null && oldChild.equals(this.elsePart.getWrappedAmbiguityAbsorber()))    // (JavaCodeGenerator.meta.java:4101)
                        this.elsePart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4102)
                } else {                                                        // (JavaCodeGenerator.meta.java:4107)
                    if (oldChild.equals(this.thenPart))                         // (JavaCodeGenerator.meta.java:4114)
                        this.thenPart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4115)
                    if (oldChild.equals(this.elsePart))                         // (JavaCodeGenerator.meta.java:4114)
                        this.elsePart = (DanglingElseSyntax.Node) newChild;     // (JavaCodeGenerator.meta.java:4115)
                }                                                               // (JavaCodeGenerator.meta.java:4119)
            }                                                                   // (JavaCodeGenerator.meta.java:4120)
                                                                                // (JavaCodeGenerator.meta.java:4121)
                                                                                // (JavaCodeGenerator.meta.java:4176)
        } // class IfThenElseStatement                                          // (JavaCodeGenerator.meta.java:4177)
        /**
         * An implementation of <code>LongIf</code> node.
         *
         * @since   notavaCC 1.0
         */
        public static class LongIf extends Default.IfThenElseStatement implements DanglingElseSyntax.LongIf {    // (JavaCodeGenerator.meta.java:3609)
                                                                                // (JavaCodeGenerator.meta.java:3633)
            private LongIf(java.util.List childNodes) {                         // (JavaCodeGenerator.meta.java:3639)
                super(childNodes);                                              // (JavaCodeGenerator.meta.java:3640)
            }                                                                   // (JavaCodeGenerator.meta.java:3641)
                                                                                // (JavaCodeGenerator.meta.java:3643)
            /**
             * Constructs a instance with the child nodes given by <code>source.getChildNodes()</code> etc.
             * <code>List</code> objects are copied.
             *
             * @param   source
             *            the source.
             */
            public LongIf(DanglingElseSyntax.LongIf source) {                   // (JavaCodeGenerator.meta.java:3677)
                super(source);                                                  // (JavaCodeGenerator.meta.java:3679)
                                                                                // (JavaCodeGenerator.meta.java:3683)
            }                                                                   // (JavaCodeGenerator.meta.java:3706)
                                                                                // (JavaCodeGenerator.meta.java:3707)
            /**
             * Constructs a instance with the child nodes given by <code>parameters</code>.
             *
             * @param   parameters
             *            the parameters for initialization.
             * @param   compact
             *            remove the children that are not labeled.
             */
            public LongIf(DanglingElseSyntax.NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:3727)
                super(parameters, compact);                                     // (JavaCodeGenerator.meta.java:3729)
                                                                                // (JavaCodeGenerator.meta.java:3733)
                DanglingElseSyntax.Node[] childNodes = parameters.childNodes;    // (JavaCodeGenerator.meta.java:3734)
                java.util.List labelBitsList = parameters.labelBitsList;        // (JavaCodeGenerator.meta.java:3735)
                                                                                // (JavaCodeGenerator.meta.java:3736)
                                                                                // (JavaCodeGenerator.meta.java:3752)
                                                                                // (JavaCodeGenerator.meta.java:3843)
            }                                                                   // (JavaCodeGenerator.meta.java:3860)
                                                                                // (JavaCodeGenerator.meta.java:3861)
            public LongIf(java.util.List childNodes, DanglingElseSyntax.Node thenPart, DanglingElseSyntax.Node elsePart) {    // (JavaCodeGenerator.meta.java:3874)
                this(childNodes);                                               // (JavaCodeGenerator.meta.java:3875)
                                                                                // (JavaCodeGenerator.meta.java:3876)
                ((DanglingElseSyntax.Default.IfThenElseStatement) this).thenPart = thenPart;    // (JavaCodeGenerator.meta.java:3893)
                                                                                // (JavaCodeGenerator.meta.java:3895)
                if (thenPart != null)                                           // (JavaCodeGenerator.meta.java:3903)
                    getChildNodes().add(thenPart);                              // (JavaCodeGenerator.meta.java:3904)
                ((DanglingElseSyntax.Default.IfThenElseStatement) this).elsePart = elsePart;    // (JavaCodeGenerator.meta.java:3893)
                                                                                // (JavaCodeGenerator.meta.java:3895)
                if (elsePart != null)                                           // (JavaCodeGenerator.meta.java:3903)
                    getChildNodes().add(elsePart);                              // (JavaCodeGenerator.meta.java:3904)
                                                                                // (JavaCodeGenerator.meta.java:3907)
            }                                                                   // (JavaCodeGenerator.meta.java:3926)
                                                                                // (JavaCodeGenerator.meta.java:3929)
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:3930)
                if (oldChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3932)
                    oldChild = oldChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3933)
                if (newChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3934)
                    newChild = newChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3935)
                                                                                // (JavaCodeGenerator.meta.java:3936)
                super.replaceChild(oldChild, newChild);                         // (JavaCodeGenerator.meta.java:3939)
                                                                                // (JavaCodeGenerator.meta.java:3943)
                if (newChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:3945)
                                                                                // (JavaCodeGenerator.meta.java:3978)
                    if (oldChild == null) {                                     // (JavaCodeGenerator.meta.java:3979)
                    } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4001)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4023)
                    }                                                           // (JavaCodeGenerator.meta.java:4044)
                    return;                                                     // (JavaCodeGenerator.meta.java:4045)
                }                                                               // (JavaCodeGenerator.meta.java:4046)
                                                                                // (JavaCodeGenerator.meta.java:4048)
                                                                                // (JavaCodeGenerator.meta.java:4049)
                                                                                // (JavaCodeGenerator.meta.java:4080)
                if (oldChild == null) {                                         // (JavaCodeGenerator.meta.java:4081)
                } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4094)
                } else {                                                        // (JavaCodeGenerator.meta.java:4107)
                }                                                               // (JavaCodeGenerator.meta.java:4119)
            }                                                                   // (JavaCodeGenerator.meta.java:4120)
                                                                                // (JavaCodeGenerator.meta.java:4121)
                                                                                // (JavaCodeGenerator.meta.java:4176)
        } // class LongIf                                                       // (JavaCodeGenerator.meta.java:4177)
        /**
         * An implementation of <code>ShortIf</code> node.
         *
         * @since   notavaCC 1.0
         */
        public static class ShortIf extends Default.IfThenElseStatement implements DanglingElseSyntax.ShortIf {    // (JavaCodeGenerator.meta.java:3609)
                                                                                // (JavaCodeGenerator.meta.java:3633)
            private ShortIf(java.util.List childNodes) {                        // (JavaCodeGenerator.meta.java:3639)
                super(childNodes);                                              // (JavaCodeGenerator.meta.java:3640)
            }                                                                   // (JavaCodeGenerator.meta.java:3641)
                                                                                // (JavaCodeGenerator.meta.java:3643)
            /**
             * Constructs a instance with the child nodes given by <code>source.getChildNodes()</code> etc.
             * <code>List</code> objects are copied.
             *
             * @param   source
             *            the source.
             */
            public ShortIf(DanglingElseSyntax.ShortIf source) {                 // (JavaCodeGenerator.meta.java:3677)
                super(source);                                                  // (JavaCodeGenerator.meta.java:3679)
                                                                                // (JavaCodeGenerator.meta.java:3683)
            }                                                                   // (JavaCodeGenerator.meta.java:3706)
                                                                                // (JavaCodeGenerator.meta.java:3707)
            /**
             * Constructs a instance with the child nodes given by <code>parameters</code>.
             *
             * @param   parameters
             *            the parameters for initialization.
             * @param   compact
             *            remove the children that are not labeled.
             */
            public ShortIf(DanglingElseSyntax.NodeInitializationParameters parameters, boolean compact) {    // (JavaCodeGenerator.meta.java:3727)
                super(parameters, compact);                                     // (JavaCodeGenerator.meta.java:3729)
                                                                                // (JavaCodeGenerator.meta.java:3733)
                DanglingElseSyntax.Node[] childNodes = parameters.childNodes;    // (JavaCodeGenerator.meta.java:3734)
                java.util.List labelBitsList = parameters.labelBitsList;        // (JavaCodeGenerator.meta.java:3735)
                                                                                // (JavaCodeGenerator.meta.java:3736)
                                                                                // (JavaCodeGenerator.meta.java:3752)
                                                                                // (JavaCodeGenerator.meta.java:3843)
            }                                                                   // (JavaCodeGenerator.meta.java:3860)
                                                                                // (JavaCodeGenerator.meta.java:3861)
            public ShortIf(java.util.List childNodes, DanglingElseSyntax.Node thenPart) {    // (JavaCodeGenerator.meta.java:3874)
                this(childNodes);                                               // (JavaCodeGenerator.meta.java:3875)
                                                                                // (JavaCodeGenerator.meta.java:3876)
                ((DanglingElseSyntax.Default.IfThenElseStatement) this).thenPart = thenPart;    // (JavaCodeGenerator.meta.java:3893)
                                                                                // (JavaCodeGenerator.meta.java:3895)
                if (thenPart != null)                                           // (JavaCodeGenerator.meta.java:3903)
                    getChildNodes().add(thenPart);                              // (JavaCodeGenerator.meta.java:3904)
                                                                                // (JavaCodeGenerator.meta.java:3907)
            }                                                                   // (JavaCodeGenerator.meta.java:3926)
                                                                                // (JavaCodeGenerator.meta.java:3929)
            public void replaceChild(DanglingElseSyntax.Node oldChild, DanglingElseSyntax.Node newChild) {    // (JavaCodeGenerator.meta.java:3930)
                if (oldChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3932)
                    oldChild = oldChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3933)
                if (newChild.getWrappedAmbiguityAbsorber() != null)             // (JavaCodeGenerator.meta.java:3934)
                    newChild = newChild.getWrappedAmbiguityAbsorber();          // (JavaCodeGenerator.meta.java:3935)
                                                                                // (JavaCodeGenerator.meta.java:3936)
                super.replaceChild(oldChild, newChild);                         // (JavaCodeGenerator.meta.java:3939)
                                                                                // (JavaCodeGenerator.meta.java:3943)
                if (newChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:3945)
                                                                                // (JavaCodeGenerator.meta.java:3978)
                    if (oldChild == null) {                                     // (JavaCodeGenerator.meta.java:3979)
                    } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4001)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4023)
                    }                                                           // (JavaCodeGenerator.meta.java:4044)
                    return;                                                     // (JavaCodeGenerator.meta.java:4045)
                }                                                               // (JavaCodeGenerator.meta.java:4046)
                                                                                // (JavaCodeGenerator.meta.java:4048)
                                                                                // (JavaCodeGenerator.meta.java:4049)
                                                                                // (JavaCodeGenerator.meta.java:4080)
                if (oldChild == null) {                                         // (JavaCodeGenerator.meta.java:4081)
                } else if (oldChild instanceof DanglingElseSyntax.AmbiguityAbsorber) {    // (JavaCodeGenerator.meta.java:4094)
                } else {                                                        // (JavaCodeGenerator.meta.java:4107)
                }                                                               // (JavaCodeGenerator.meta.java:4119)
            }                                                                   // (JavaCodeGenerator.meta.java:4120)
                                                                                // (JavaCodeGenerator.meta.java:4121)
                                                                                // (JavaCodeGenerator.meta.java:4176)
        } // class ShortIf                                                      // (JavaCodeGenerator.meta.java:4177)
                                                                                // (JavaCodeGenerator.meta.java:4180)
                                                                                // (JavaCodeGenerator.meta.java:4181)
    } // Default                                                                // (JavaCodeGenerator.meta.java:4183)
                                                                                // (JavaCodeGenerator.meta.java:4184)
    private static Node __createAmbiguousWrapper__notavacc_reserved(final DanglingElseSyntax.AmbiguityAbsorber ambiguousNode, final java.lang.Class interfaceType) {    // (JavaCodeGenerator.meta.java:4188)
        return (Node) java.lang.reflect.Proxy.newProxyInstance(DanglingElseSyntax.class.getClassLoader(), new java.lang.Class[] { interfaceType }, new java.lang.reflect.InvocationHandler() {    // (JavaCodeGenerator.meta.java:4189)
            public java.lang.Object invoke(java.lang.Object proxy, java.lang.reflect.Method method, java.lang.Object[] args) throws java.lang.Throwable {    // (JavaCodeGenerator.meta.java:4190)
                if (method.getName().equals("getWrappedAmbiguityAbsorber") && (args == null || args.length == 0)) {    // (JavaCodeGenerator.meta.java:4191)
                    return ambiguousNode;                                       // (JavaCodeGenerator.meta.java:4192)
                } else if (method.getName().equals("toString") && (args == null || args.length == 0)) {    // (JavaCodeGenerator.meta.java:4193)
                    return "AmbiguousWrapper wrapping " + ambiguousNode.toString();    // (JavaCodeGenerator.meta.java:4194)
                } else {                                                        // (JavaCodeGenerator.meta.java:4201)
                    throw new java.lang.UnsupportedOperationException(interfaceType.getName() + "#" + method.getName() + " by " + ambiguousNode.getClass());    // (JavaCodeGenerator.meta.java:4202)
                }                                                               // (JavaCodeGenerator.meta.java:4203)
            }                                                                   // (JavaCodeGenerator.meta.java:4204)
        });                                                                     // (JavaCodeGenerator.meta.java:4205)
    }                                                                           // (JavaCodeGenerator.meta.java:4206)
                                                                                // (JavaCodeGenerator.meta.java:4261)
                                                                                // (JavaCodeGenerator.meta.java:4272)
    private static class __Link__notavacc_reserved {                            // (JavaCodeGenerator.meta.java:4274)
        public java.lang.Object value;                                          // (JavaCodeGenerator.meta.java:4276)
        public __Link__notavacc_reserved next;                                  // (JavaCodeGenerator.meta.java:4277)
        public __Link__notavacc_reserved(java.lang.Object value, __Link__notavacc_reserved next) {    // (JavaCodeGenerator.meta.java:4278)
            this.value = value;                                                 // (JavaCodeGenerator.meta.java:4279)
            this.next = next;                                                   // (JavaCodeGenerator.meta.java:4280)
        }                                                                       // (JavaCodeGenerator.meta.java:4281)
        public void addLink(java.lang.Object value) {                           // (JavaCodeGenerator.meta.java:4282)
            this.next = new __Link__notavacc_reserved(value, this.next);        // (JavaCodeGenerator.meta.java:4283)
        }                                                                       // (JavaCodeGenerator.meta.java:4284)
        private java.lang.Object[] toArray(__Context__notavacc_reserved context) {    // (JavaCodeGenerator.meta.java:4296)
            __Link__notavacc_reserved cursor = this;                            // (JavaCodeGenerator.meta.java:4297)
            for (; cursor != null; cursor = cursor.next) {                      // (JavaCodeGenerator.meta.java:4298)
                context.tmpList.add(cursor.value);                              // (JavaCodeGenerator.meta.java:4299)
            }                                                                   // (JavaCodeGenerator.meta.java:4300)
            java.lang.Object[] result = context.tmpList.toArray(new java.lang.Object[context.tmpList.size()]);    // (JavaCodeGenerator.meta.java:4301)
            context.tmpList.clear();                                            // (JavaCodeGenerator.meta.java:4302)
            return result;                                                      // (JavaCodeGenerator.meta.java:4303)
        }                                                                       // (JavaCodeGenerator.meta.java:4304)
        public java.lang.String toString() {                                    // (JavaCodeGenerator.meta.java:4306)
            java.lang.StringBuffer result = new java.lang.StringBuffer("{ ");    // (JavaCodeGenerator.meta.java:4307)
            __Link__notavacc_reserved link = this;                              // (JavaCodeGenerator.meta.java:4308)
            for (; link != null; link = link.next) {                            // (JavaCodeGenerator.meta.java:4309)
                if (link != this)                                               // (JavaCodeGenerator.meta.java:4310)
                    result.append(", ");                                        // (JavaCodeGenerator.meta.java:4311)
                result.append(link.value);                                      // (JavaCodeGenerator.meta.java:4312)
            }                                                                   // (JavaCodeGenerator.meta.java:4313)
            result.append(" }");                                                // (JavaCodeGenerator.meta.java:4314)
            return result.toString();                                           // (JavaCodeGenerator.meta.java:4315)
        }                                                                       // (JavaCodeGenerator.meta.java:4316)
        public static __Link__notavacc_reserved toLink(java.lang.Object o) {    // (JavaCodeGenerator.meta.java:4317)
            if (o instanceof __Link__notavacc_reserved)                         // (JavaCodeGenerator.meta.java:4318)
                return (__Link__notavacc_reserved) o;                           // (JavaCodeGenerator.meta.java:4319)
            return new __Link__notavacc_reserved(o, null);                      // (JavaCodeGenerator.meta.java:4320)
        }                                                                       // (JavaCodeGenerator.meta.java:4321)
    }                                                                           // (JavaCodeGenerator.meta.java:4323)
    private static final class __StateVertex__notavacc_reserved extends __Link__notavacc_reserved {    // (JavaCodeGenerator.meta.java:4351)
        public int stateNo;                                                     // (JavaCodeGenerator.meta.java:4352)
        public __Link__notavacc_reserved whiteTokenHolder;                      // (JavaCodeGenerator.meta.java:4353)
        public int generation;                                                  // (JavaCodeGenerator.meta.java:4355)
        public __StateVertex__notavacc_reserved(int stateNo, int generation) {    // (JavaCodeGenerator.meta.java:4357)
            super(null, null);                                                  // (JavaCodeGenerator.meta.java:4358)
            this.stateNo = stateNo;                                             // (JavaCodeGenerator.meta.java:4359)
            assert generation == 0;                                             // (JavaCodeGenerator.meta.java:4360)
            this.generation = generation;                                       // (JavaCodeGenerator.meta.java:4362)
        }                                                                       // (JavaCodeGenerator.meta.java:4364)
        public __StateVertex__notavacc_reserved(__SymbolVertex__notavacc_reserved successor, int stateNo, int generation) {    // (JavaCodeGenerator.meta.java:4365)
            super(successor, null);                                             // (JavaCodeGenerator.meta.java:4366)
            this.stateNo = stateNo;                                             // (JavaCodeGenerator.meta.java:4367)
            this.generation = generation;                                       // (JavaCodeGenerator.meta.java:4369)
        }                                                                       // (JavaCodeGenerator.meta.java:4371)
        public void addSuccessor(__SymbolVertex__notavacc_reserved successor) {    // (JavaCodeGenerator.meta.java:4372)
            super.addLink(successor);                                           // (JavaCodeGenerator.meta.java:4373)
        }                                                                       // (JavaCodeGenerator.meta.java:4374)
        public __Link__notavacc_reserved getSuccessors() {                      // (JavaCodeGenerator.meta.java:4375)
            assert value != null;                                               // (JavaCodeGenerator.meta.java:4376)
            return this;                                                        // (JavaCodeGenerator.meta.java:4377)
        }                                                                       // (JavaCodeGenerator.meta.java:4378)
        public java.lang.String toString() {                                    // (JavaCodeGenerator.meta.java:4380)
            return "(" + __lrStateIDToName__notavacc_reserved[stateNo] + "@" + generation + ")";    // (JavaCodeGenerator.meta.java:4381)
        }                                                                       // (JavaCodeGenerator.meta.java:4382)
    }                                                                           // (JavaCodeGenerator.meta.java:4384)
    private static final class __SymbolVertex__notavacc_reserved extends __Link__notavacc_reserved {    // (JavaCodeGenerator.meta.java:4386)
        public static int numberOfObjects;                                      // (JavaCodeGenerator.meta.java:4388)
        public int idNumber = numberOfObjects++;                                // (JavaCodeGenerator.meta.java:4389)
        public java.lang.Object symbol;     // __ConcreteSyntaxTree__notavacc_reserved, Node, or __Link__notavacc_reserved of __ConcreteSyntaxTree__notavacc_reserved for absorbers.    // (JavaCodeGenerator.meta.java:4391)
        public __SymbolVertex__notavacc_reserved(__StateVertex__notavacc_reserved successor, java.lang.Object symbol) {    // (JavaCodeGenerator.meta.java:4392)
            super(successor, null);                                             // (JavaCodeGenerator.meta.java:4393)
            this.symbol = symbol;                                               // (JavaCodeGenerator.meta.java:4394)
        }                                                                       // (JavaCodeGenerator.meta.java:4395)
        public void addSuccessor(__StateVertex__notavacc_reserved successor) {    // (JavaCodeGenerator.meta.java:4396)
            super.addLink(successor);                                           // (JavaCodeGenerator.meta.java:4397)
        }                                                                       // (JavaCodeGenerator.meta.java:4398)
        public __Link__notavacc_reserved getSuccessors() {                      // (JavaCodeGenerator.meta.java:4399)
            assert value != null;                                               // (JavaCodeGenerator.meta.java:4400)
            return this;                                                        // (JavaCodeGenerator.meta.java:4401)
        }                                                                       // (JavaCodeGenerator.meta.java:4402)
        public java.lang.String toString() {                                    // (JavaCodeGenerator.meta.java:4404)
            java.lang.StringBuffer result = new java.lang.StringBuffer("[#");    // (JavaCodeGenerator.meta.java:4405)
            result.append(idNumber);                                            // (JavaCodeGenerator.meta.java:4406)
            result.append(" ");                                                 // (JavaCodeGenerator.meta.java:4407)
            __Link__notavacc_reserved link = __Link__notavacc_reserved.toLink(symbol);    // (JavaCodeGenerator.meta.java:4408)
            for (; link != null; link = link.next) {                            // (JavaCodeGenerator.meta.java:4409)
                if (link.value instanceof __ConcreteSyntaxTree__notavacc_reserved) {    // (JavaCodeGenerator.meta.java:4410)
                    __ConcreteSyntaxTree__notavacc_reserved cst = (__ConcreteSyntaxTree__notavacc_reserved) link.value;    // (JavaCodeGenerator.meta.java:4411)
                    result.append(cst);                                         // (JavaCodeGenerator.meta.java:4412)
                } else {                                                        // (JavaCodeGenerator.meta.java:4413)
                    Node node = (Node) link.value;                              // (JavaCodeGenerator.meta.java:4414)
                    if (node instanceof Token) {                                // (JavaCodeGenerator.meta.java:4415)
                        result.append(node);                                    // (JavaCodeGenerator.meta.java:4416)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4417)
                        java.lang.String name = node.getClass().getName();      // (JavaCodeGenerator.meta.java:4418)
                        result.append(name.substring(name.lastIndexOf('$') + 1));    // (JavaCodeGenerator.meta.java:4419)
                    }                                                           // (JavaCodeGenerator.meta.java:4420)
                }                                                               // (JavaCodeGenerator.meta.java:4421)
                if (link.next != null)                                          // (JavaCodeGenerator.meta.java:4422)
                    result.append(", ");                                        // (JavaCodeGenerator.meta.java:4423)
            }                                                                   // (JavaCodeGenerator.meta.java:4424)
            result.append("]");                                                 // (JavaCodeGenerator.meta.java:4425)
            return result.toString();                                           // (JavaCodeGenerator.meta.java:4426)
        }                                                                       // (JavaCodeGenerator.meta.java:4427)
    }                                                                           // (JavaCodeGenerator.meta.java:4429)
    private static final class __Chore__notavacc_reserved {                     // (JavaCodeGenerator.meta.java:4431)
        __StateVertex__notavacc_reserved state;                                 // (JavaCodeGenerator.meta.java:4432)
        __SymbolVertex__notavacc_reserved successor;                            // (JavaCodeGenerator.meta.java:4433)
        int reductionID;                                                        // (JavaCodeGenerator.meta.java:4434)
        public __Chore__notavacc_reserved(__StateVertex__notavacc_reserved state, int reductionID) {    // (JavaCodeGenerator.meta.java:4435)
            this(state, null, reductionID);                                     // (JavaCodeGenerator.meta.java:4436)
        }                                                                       // (JavaCodeGenerator.meta.java:4437)
        public __Chore__notavacc_reserved(__StateVertex__notavacc_reserved state, __SymbolVertex__notavacc_reserved successor, int reductionID) {    // (JavaCodeGenerator.meta.java:4438)
            this.state = state;                                                 // (JavaCodeGenerator.meta.java:4439)
            this.successor = successor;                                         // (JavaCodeGenerator.meta.java:4440)
            this.reductionID = reductionID;                                     // (JavaCodeGenerator.meta.java:4441)
                                                                                // (JavaCodeGenerator.meta.java:4442)
            int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4443)
            assert (successor == null) == (reduction.length == 1);              // (JavaCodeGenerator.meta.java:4444)
            // successor == null  <==>  the reduction is an empty reduction.    // (JavaCodeGenerator.meta.java:4445)
        }                                                                       // (JavaCodeGenerator.meta.java:4446)
        public java.lang.String toString() {                                    // (JavaCodeGenerator.meta.java:4448)
            int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4449)
            return __symbolIDToName__notavacc_reserved[reduction[0]] + "<--" + ((reduction.length - 1) / 1) + "--" + successor + "<-" + state;    // (JavaCodeGenerator.meta.java:4450)
        }                                                                       // (JavaCodeGenerator.meta.java:4451)
    }                                                                           // (JavaCodeGenerator.meta.java:4453)
    private static final class __ConcreteSyntaxTree__notavacc_reserved {        // (JavaCodeGenerator.meta.java:4455)
        private DanglingElseSyntax parser;                                      // (JavaCodeGenerator.meta.java:4457)
        public int reductionID;                                                 // (JavaCodeGenerator.meta.java:4459)
        public java.lang.Object[] children;                                     // (JavaCodeGenerator.meta.java:4460)
        // odd: same as __SymbolVertex__notavacc_reserved#symbol. even: __Link__notavacc_reserved of white tokens (maybe null).    // (JavaCodeGenerator.meta.java:4461)
        // or, null if this has an empty reduction.                             // (JavaCodeGenerator.meta.java:4462)
        public Node node;                                                       // (JavaCodeGenerator.meta.java:4463)
        public __ConcreteSyntaxTree__notavacc_reserved(__Context__notavacc_reserved context, int reductionID, java.lang.Object[] children) throws ParseException {    // (JavaCodeGenerator.meta.java:4464)
            this.parser = context.parser;                                       // (JavaCodeGenerator.meta.java:4466)
            this.reductionID = reductionID;                                     // (JavaCodeGenerator.meta.java:4468)
            this.children = children;                                           // (JavaCodeGenerator.meta.java:4469)
        }                                                                       // (JavaCodeGenerator.meta.java:4470)
        public Node createNode(__Context__notavacc_reserved context) throws ParseException {    // (JavaCodeGenerator.meta.java:4471)
            if (node == null) {                                                 // (JavaCodeGenerator.meta.java:4472)
                int[] reduction = context.parser.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4473)
                if (reduction[0] < 13) {                                        // (JavaCodeGenerator.meta.java:4474)
                    node = context.parser.createNode(context, this);            // (JavaCodeGenerator.meta.java:4475)
                }                                                               // (JavaCodeGenerator.meta.java:4479)
            }                                                                   // (JavaCodeGenerator.meta.java:4480)
            return node;                                                        // (JavaCodeGenerator.meta.java:4481)
        }                                                                       // (JavaCodeGenerator.meta.java:4482)
        public java.lang.String toString() {                                    // (JavaCodeGenerator.meta.java:4484)
            int[] reduction = parser.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4485)
            //return "CST(" + __symbolIDToName__notavacc_reserved[reduction[0]] + ")";    // (JavaCodeGenerator.meta.java:4486)
            if (children == null) {                                             // (JavaCodeGenerator.meta.java:4487)
                return "CST(" + __symbolIDToName__notavacc_reserved[reduction[0]] + ")" + null;    // (JavaCodeGenerator.meta.java:4488)
            } else {                                                            // (JavaCodeGenerator.meta.java:4489)
                return "CST(" + __symbolIDToName__notavacc_reserved[reduction[0]] + ")" + java.util.Arrays.asList(children);    // (JavaCodeGenerator.meta.java:4490)
            }                                                                   // (JavaCodeGenerator.meta.java:4491)
        }                                                                       // (JavaCodeGenerator.meta.java:4492)
    }                                                                           // (JavaCodeGenerator.meta.java:4494)
    private static final class __AbsorbKey2__notavacc_reserved {                // (JavaCodeGenerator.meta.java:4496)
        public java.util.Set states;                                            // (JavaCodeGenerator.meta.java:4497)
        public int symbolID;                                                    // (JavaCodeGenerator.meta.java:4498)
        public __AbsorbKey2__notavacc_reserved(java.util.Set states, int symbolID) {    // (JavaCodeGenerator.meta.java:4499)
            this.states = states;                                               // (JavaCodeGenerator.meta.java:4500)
            this.symbolID = symbolID;                                           // (JavaCodeGenerator.meta.java:4501)
        }                                                                       // (JavaCodeGenerator.meta.java:4502)
        public int hashCode() {                                                 // (JavaCodeGenerator.meta.java:4503)
            return states.hashCode() + symbolID;                                // (JavaCodeGenerator.meta.java:4504)
        }                                                                       // (JavaCodeGenerator.meta.java:4505)
        public final boolean equals(java.lang.Object rhs) {                     // (JavaCodeGenerator.meta.java:4506)
            if (rhs instanceof __AbsorbKey2__notavacc_reserved)                 // (JavaCodeGenerator.meta.java:4507)
                return equals((__AbsorbKey2__notavacc_reserved) rhs);           // (JavaCodeGenerator.meta.java:4508)
            return false;                                                       // (JavaCodeGenerator.meta.java:4509)
        }                                                                       // (JavaCodeGenerator.meta.java:4510)
        public final boolean equals(__AbsorbKey2__notavacc_reserved rhs) {      // (JavaCodeGenerator.meta.java:4511)
            return states.equals(rhs.states) && symbolID == rhs.symbolID;       // (JavaCodeGenerator.meta.java:4512)
        }                                                                       // (JavaCodeGenerator.meta.java:4513)
    }                                                                           // (JavaCodeGenerator.meta.java:4514)
                                                                                // (JavaCodeGenerator.meta.java:4515)
    private static int $binarySearchLRTable(int[] table, int key) {             // (JavaCodeGenerator.meta.java:4517)
        // The 'table' is list of key and value, and additional Integer.MAX_VALUE.  Even indexes are keys and odd indexes are values.    // (JavaCodeGenerator.meta.java:4518)
        // The result is the minimum index of the key that is grater or equals to 'key'.    // (JavaCodeGenerator.meta.java:4519)
        int base = 0;                                                           // (JavaCodeGenerator.meta.java:4520)
        int width = (table.length + 1) >> 1;                                    // (JavaCodeGenerator.meta.java:4521)
        while (width > 0) {                                                     // (JavaCodeGenerator.meta.java:4522)
            // The result should be in base..(base+width*2)                     // (JavaCodeGenerator.meta.java:4523)
            int halfWidth = width >> 1;                                         // (JavaCodeGenerator.meta.java:4524)
            int index = base + (width & ~1);    // base + halfWidth * 2         // (JavaCodeGenerator.meta.java:4525)
            if (table[index] < key) {                                           // (JavaCodeGenerator.meta.java:4526)
                // The result should be in index+2..(base+width*2)              // (JavaCodeGenerator.meta.java:4527)
                base = index + 2;                                               // (JavaCodeGenerator.meta.java:4528)
                width = width - halfWidth - 1;                                  // (JavaCodeGenerator.meta.java:4529)
            } else {                                                            // (JavaCodeGenerator.meta.java:4530)
                // The result should be in base..index                          // (JavaCodeGenerator.meta.java:4531)
                width = halfWidth;                                              // (JavaCodeGenerator.meta.java:4532)
            }                                                                   // (JavaCodeGenerator.meta.java:4533)
        }                                                                       // (JavaCodeGenerator.meta.java:4534)
        return base;                                                            // (JavaCodeGenerator.meta.java:4535)
    }                                                                           // (JavaCodeGenerator.meta.java:4536)
    /*#allocate("getDirective", topMethodNamespace);
    private int $getDirective(int[] symbolIDToDirective, int symbolID) {
    int index = __binarySearch__notavacc_reserved(symbolIDToDirective, symbolID);
    if (symbolIDToDirective[index] == symbolID) {
    return symbolIDToDirective[index + 1];
    } else {
    return -1;
    }
    }*/
                                                                                // (JavaCodeGenerator.meta.java:4547)
    private static final class __Context__notavacc_reserved {                   // (JavaCodeGenerator.meta.java:4549)
        public __Context__notavacc_reserved(DanglingElseSyntax parser) {        // (JavaCodeGenerator.meta.java:4550)
            this.parser = parser;                                               // (JavaCodeGenerator.meta.java:4551)
        }                                                                       // (JavaCodeGenerator.meta.java:4552)
        public final DanglingElseSyntax parser;                                 // (JavaCodeGenerator.meta.java:4553)
        public java.util.Map states = new java.util.LinkedHashMap();            // (JavaCodeGenerator.meta.java:4554)
        public final java.util.Set unbrokenStates = new java.util.LinkedHashSet();    // (JavaCodeGenerator.meta.java:4555)
        public final java.util.List chores = new java.util.ArrayList();         // (JavaCodeGenerator.meta.java:4556)
        public final java.util.Map absorbMap2 = new java.util.LinkedHashMap();    // (JavaCodeGenerator.meta.java:4557)
        public int generation;                                                  // (JavaCodeGenerator.meta.java:4558)
        public __Link__notavacc_reserved whiteTokenHolder;                      // (JavaCodeGenerator.meta.java:4559)
        public int nextTokenID;                                                 // (JavaCodeGenerator.meta.java:4560)
        public Token nextToken;                                                 // (JavaCodeGenerator.meta.java:4561)
        public final NodeInitializationParameters parameters = new NodeInitializationParameters();    // (JavaCodeGenerator.meta.java:4562)
        public final java.util.List tmpList = new java.util.ArrayList();        // (JavaCodeGenerator.meta.java:4563)
        public final java.util.Map tmpMap = new java.util.LinkedHashMap();      // (JavaCodeGenerator.meta.java:4564)
    }                                                                           // (JavaCodeGenerator.meta.java:4565)
    private Node __parse__notavacc_reserved(LexicalAnalyzer analyzer, int initialStateNo) throws ParseException {    // (JavaCodeGenerator.meta.java:4567)
        final int labelWordCount = 1;                                           // (JavaCodeGenerator.meta.java:4568)
        final int[][] lrTable = DanglingElseSyntax.__lrTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4569)
        final int[][] reductionTable = DanglingElseSyntax.__reductionTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4570)
                                                                                // (JavaCodeGenerator.meta.java:4571)
        // build subtrees                                                       // (JavaCodeGenerator.meta.java:4572)
        __Context__notavacc_reserved context = new __Context__notavacc_reserved(this);    // (JavaCodeGenerator.meta.java:4573)
        __StateVertex__notavacc_reserved firstStateVertex = new __StateVertex__notavacc_reserved(initialStateNo, 0);    // (JavaCodeGenerator.meta.java:4574)
        {                                                                       // (JavaCodeGenerator.meta.java:4575)
            context.whiteTokenHolder = new __Link__notavacc_reserved(null, null);    // (JavaCodeGenerator.meta.java:4576)
            firstStateVertex.whiteTokenHolder = context.whiteTokenHolder;       // (JavaCodeGenerator.meta.java:4577)
            context.states.put(new java.lang.Integer(firstStateVertex.stateNo), firstStateVertex);    // (JavaCodeGenerator.meta.java:4578)
                                                                                // (JavaCodeGenerator.meta.java:4579)
            java.util.Map nextStates = new java.util.LinkedHashMap();           // (JavaCodeGenerator.meta.java:4580)
                                                                                // (JavaCodeGenerator.meta.java:4581)
            tokenLoop:                                                          // (JavaCodeGenerator.meta.java:4582)
            for (context.generation = 0;; context.generation++) {               // (JavaCodeGenerator.meta.java:4583)
                assert context.unbrokenStates.isEmpty();                        // (JavaCodeGenerator.meta.java:4584)
                context.unbrokenStates.addAll(context.states.values());         // (JavaCodeGenerator.meta.java:4585)
                {                                                               // (JavaCodeGenerator.meta.java:4586)
                    assert context.whiteTokenHolder.next == null;               // (JavaCodeGenerator.meta.java:4587)
                                                                                // (JavaCodeGenerator.meta.java:4588)
                    __Link__notavacc_reserved whiteTokensAppendPosition = context.whiteTokenHolder;    // (JavaCodeGenerator.meta.java:4590)
                    for (;;) {                                                  // (JavaCodeGenerator.meta.java:4591)
                        context.nextToken = analyzer.next();                    // (JavaCodeGenerator.meta.java:4592)
                        context.nextTokenID = context.nextToken.getSymbolID();    // (JavaCodeGenerator.meta.java:4593)
                        if (context.nextToken.isWhite()) {                      // (JavaCodeGenerator.meta.java:4594)
                            whiteTokensAppendPosition.next = new __Link__notavacc_reserved(context.nextToken, null);    // (JavaCodeGenerator.meta.java:4595)
                            whiteTokensAppendPosition = whiteTokensAppendPosition.next;    // (JavaCodeGenerator.meta.java:4596)
                        } else {                                                // (JavaCodeGenerator.meta.java:4597)
                            break;                                              // (JavaCodeGenerator.meta.java:4598)
                        }                                                       // (JavaCodeGenerator.meta.java:4599)
                    }                                                           // (JavaCodeGenerator.meta.java:4600)
                }                                                               // (JavaCodeGenerator.meta.java:4613)
                                                                                // (JavaCodeGenerator.meta.java:4614)
                                                                                // (JavaCodeGenerator.meta.java:4621)
                reduceLoop:                                                     // (JavaCodeGenerator.meta.java:4622)
                while (!context.unbrokenStates.isEmpty() || !context.chores.isEmpty()) {    // (JavaCodeGenerator.meta.java:4623)
                    if (!context.unbrokenStates.isEmpty()) {                    // (JavaCodeGenerator.meta.java:4624)
                        java.util.Iterator it = context.unbrokenStates.iterator();    // (JavaCodeGenerator.meta.java:4625)
                        __StateVertex__notavacc_reserved stateToBreak = (__StateVertex__notavacc_reserved) it.next();    // (JavaCodeGenerator.meta.java:4626)
                        it.remove();                                            // (JavaCodeGenerator.meta.java:4627)
                        it = null;                                              // (JavaCodeGenerator.meta.java:4628)
                        __breakState__notavacc_reserved(context, null, stateToBreak);    // (JavaCodeGenerator.meta.java:4629)
                    } else {                                                    // (JavaCodeGenerator.meta.java:4630)
                        java.util.Iterator it = context.chores.iterator();      // (JavaCodeGenerator.meta.java:4631)
                        __Chore__notavacc_reserved chore = (__Chore__notavacc_reserved) it.next();    // (JavaCodeGenerator.meta.java:4632)
                        it.remove();                                            // (JavaCodeGenerator.meta.java:4633)
                        it = null;                                              // (JavaCodeGenerator.meta.java:4634)
                        __chopChore__notavacc_reserved(context, chore);         // (JavaCodeGenerator.meta.java:4635)
                    }                                                           // (JavaCodeGenerator.meta.java:4636)
                }                                                               // (JavaCodeGenerator.meta.java:4637)
                context.absorbMap2.clear();                                     // (JavaCodeGenerator.meta.java:4638)
                                                                                // (JavaCodeGenerator.meta.java:4639)
                __Link__notavacc_reserved oldWhiteTokenHolder = context.whiteTokenHolder;    // (JavaCodeGenerator.meta.java:4640)
                context.whiteTokenHolder = new __Link__notavacc_reserved(null, null);    // (JavaCodeGenerator.meta.java:4641)
                java.util.Iterator it25 = context.states.values().iterator();    // (JavaCodeGenerator.meta.java:4642)
                shiftLoop:                                                      // (JavaCodeGenerator.meta.java:4643)
                while (it25.hasNext()) {                                        // (JavaCodeGenerator.meta.java:4644)
                    __StateVertex__notavacc_reserved currentState = (__StateVertex__notavacc_reserved) it25.next();    // (JavaCodeGenerator.meta.java:4645)
                                                                                // (JavaCodeGenerator.meta.java:4646)
                    final int[] tokenIDToNextState = lrTable[currentState.stateNo * 3 + 0];    // (JavaCodeGenerator.meta.java:4647)
                    int index = $binarySearchLRTable(tokenIDToNextState, context.nextTokenID);    // (JavaCodeGenerator.meta.java:4648)
                    if (tokenIDToNextState[index] == context.nextTokenID) {     // (JavaCodeGenerator.meta.java:4649)
                        if (context.generation != 0) {                          // (JavaCodeGenerator.meta.java:4650)
                            __Link__notavacc_reserved it = currentState.getSuccessors();    // (JavaCodeGenerator.meta.java:4651)
                            do {                                                // (JavaCodeGenerator.meta.java:4652)
                                __SymbolVertex__notavacc_reserved prevSymbolVertex = (__SymbolVertex__notavacc_reserved) it.value;    // (JavaCodeGenerator.meta.java:4653)
                                if (!(prevSymbolVertex.symbol instanceof Node)) {    // (JavaCodeGenerator.meta.java:4654)
                                    if (prevSymbolVertex.symbol instanceof __ConcreteSyntaxTree__notavacc_reserved) {    // (JavaCodeGenerator.meta.java:4655)
                                        __ConcreteSyntaxTree__notavacc_reserved tree = (__ConcreteSyntaxTree__notavacc_reserved) prevSymbolVertex.symbol;    // (JavaCodeGenerator.meta.java:4656)
                                        Node node = tree.createNode(context);    // (JavaCodeGenerator.meta.java:4657)
                                        if (node != null)                       // (JavaCodeGenerator.meta.java:4658)
                                            prevSymbolVertex.symbol = node;     // (JavaCodeGenerator.meta.java:4659)
                                    } else {                                    // (JavaCodeGenerator.meta.java:4660)
                                        // TODO: 実装                             // (JavaCodeGenerator.meta.java:4661)
                                        //Node node = createNode(context, ($ObjectLint) prevSymbolVertex.symbol);    // (JavaCodeGenerator.meta.java:4662)
                                        //if (node != null)                     // (JavaCodeGenerator.meta.java:4663)
                                        //    prevSymbolVertex.symbol = node;    // (JavaCodeGenerator.meta.java:4664)
                                    }                                           // (JavaCodeGenerator.meta.java:4665)
                                }                                               // (JavaCodeGenerator.meta.java:4666)
                                it = it.next;                                   // (JavaCodeGenerator.meta.java:4667)
                            } while (it != null);                               // (JavaCodeGenerator.meta.java:4668)
                        }                                                       // (JavaCodeGenerator.meta.java:4669)
                                                                                // (JavaCodeGenerator.meta.java:4670)
                        for (; tokenIDToNextState[index] == context.nextTokenID; index += 2) {    // (JavaCodeGenerator.meta.java:4671)
                            int nextStateNo = tokenIDToNextState[index + 1];    // (JavaCodeGenerator.meta.java:4672)
                            java.lang.Integer nextStateNoInteger = new java.lang.Integer(nextStateNo);    // (JavaCodeGenerator.meta.java:4673)
                            __StateVertex__notavacc_reserved nextState = (__StateVertex__notavacc_reserved) nextStates.get(nextStateNoInteger);    // (JavaCodeGenerator.meta.java:4674)
                            if (nextState == null) {                            // (JavaCodeGenerator.meta.java:4675)
                                __SymbolVertex__notavacc_reserved symbolVertex = new __SymbolVertex__notavacc_reserved(currentState, context.nextToken);    // (JavaCodeGenerator.meta.java:4676)
                                nextState = new __StateVertex__notavacc_reserved(symbolVertex, nextStateNo, context.generation + 1);    // (JavaCodeGenerator.meta.java:4677)
                                nextState.whiteTokenHolder = context.whiteTokenHolder;    // (JavaCodeGenerator.meta.java:4678)
                                nextStates.put(nextStateNoInteger, nextState);    // (JavaCodeGenerator.meta.java:4679)
                            } else {                                            // (JavaCodeGenerator.meta.java:4683)
                                assert nextState.getSuccessors().next == null; // i.e. size == 1    // (JavaCodeGenerator.meta.java:4684)
                                __SymbolVertex__notavacc_reserved symbolVertex = (__SymbolVertex__notavacc_reserved) nextState.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4685)
                                symbolVertex.addSuccessor(currentState);        // (JavaCodeGenerator.meta.java:4686)
                            }                                                   // (JavaCodeGenerator.meta.java:4690)
                            break;                                              // (JavaCodeGenerator.meta.java:4692)
                        }                                                       // (JavaCodeGenerator.meta.java:4693)
                    }                                                           // (JavaCodeGenerator.meta.java:4694)
                }                                                               // (JavaCodeGenerator.meta.java:4695)
                                                                                // (JavaCodeGenerator.meta.java:4696)
                if (nextStates.isEmpty()) {                                     // (JavaCodeGenerator.meta.java:4697)
                    context.whiteTokenHolder = oldWhiteTokenHolder;             // (JavaCodeGenerator.meta.java:4698)
                    __error__notavacc_reserved(context, analyzer);              // (JavaCodeGenerator.meta.java:4702)
                    continue tokenLoop;                                         // (JavaCodeGenerator.meta.java:4703)
                }                                                               // (JavaCodeGenerator.meta.java:4704)
                                                                                // (JavaCodeGenerator.meta.java:4705)
                if (context.nextTokenID == EOF_TOKEN) {                         // (JavaCodeGenerator.meta.java:4706)
                    context.states = nextStates;                                // (JavaCodeGenerator.meta.java:4707)
                    break tokenLoop;                                            // (JavaCodeGenerator.meta.java:4708)
                }                                                               // (JavaCodeGenerator.meta.java:4709)
                                                                                // (JavaCodeGenerator.meta.java:4710)
                context.states.clear();                                         // (JavaCodeGenerator.meta.java:4711)
                java.util.Map oldStates = context.states;                       // (JavaCodeGenerator.meta.java:4712)
                java.util.Map oldNextStates = nextStates;                       // (JavaCodeGenerator.meta.java:4713)
                context.states = oldNextStates;                                 // (JavaCodeGenerator.meta.java:4714)
                nextStates = oldStates;                                         // (JavaCodeGenerator.meta.java:4715)
                //java.lang.System.gc();                                        // (JavaCodeGenerator.meta.java:4716)
            }                                                                   // (JavaCodeGenerator.meta.java:4717)
        }                                                                       // (JavaCodeGenerator.meta.java:4718)
                                                                                // (JavaCodeGenerator.meta.java:4719)
        assert context.states.size() == 1;                                      // (JavaCodeGenerator.meta.java:4720)
        __StateVertex__notavacc_reserved sinkVertex = (__StateVertex__notavacc_reserved) context.states.values().iterator().next();    // (JavaCodeGenerator.meta.java:4721)
                                                                                // (JavaCodeGenerator.meta.java:4722)
        assert sinkVertex.getSuccessors().next == null;                         // (JavaCodeGenerator.meta.java:4723)
        __SymbolVertex__notavacc_reserved eofVertex = (__SymbolVertex__notavacc_reserved) sinkVertex.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4724)
                                                                                // (JavaCodeGenerator.meta.java:4725)
        assert eofVertex.getSuccessors().next == null;                          // (JavaCodeGenerator.meta.java:4726)
        __StateVertex__notavacc_reserved lastStateVertex = (__StateVertex__notavacc_reserved) eofVertex.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4727)
                                                                                // (JavaCodeGenerator.meta.java:4728)
        if (lastStateVertex.getSuccessors().next != null) {                     // (JavaCodeGenerator.meta.java:4729)
            throw new ParseException.AmbiguousGrammarError("DanglingElseSyntax.notavacc" + " is ambiguous.  Use --debug option to build a verbose parser.");    // (JavaCodeGenerator.meta.java:4730)
        }                                                                       // (JavaCodeGenerator.meta.java:4731)
        __SymbolVertex__notavacc_reserved rootSymbolVertex = (__SymbolVertex__notavacc_reserved) lastStateVertex.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4732)
                                                                                // (JavaCodeGenerator.meta.java:4733)
        assert rootSymbolVertex.getSuccessors().next == null;                   // (JavaCodeGenerator.meta.java:4734)
        assert firstStateVertex == (__StateVertex__notavacc_reserved) rootSymbolVertex.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4735)
                                                                                // (JavaCodeGenerator.meta.java:4736)
        __Link__notavacc_reserved rootLink = (__Link__notavacc_reserved) rootSymbolVertex.symbol;    // (JavaCodeGenerator.meta.java:4737)
        __ConcreteSyntaxTree__notavacc_reserved rootCST = (__ConcreteSyntaxTree__notavacc_reserved) rootLink.value;    // (JavaCodeGenerator.meta.java:4738)
                                                                                // (JavaCodeGenerator.meta.java:4739)
        return createNode(context, firstStateVertex.whiteTokenHolder.next, rootCST, lastStateVertex.whiteTokenHolder.next);    // (JavaCodeGenerator.meta.java:4740)
    }                                                                           // (JavaCodeGenerator.meta.java:4741)
    private final static int $ERROR_REPORT_MODE = -1;                           // (JavaCodeGenerator.meta.java:4743)
    private void __error__notavacc_reserved(__Context__notavacc_reserved context, LexicalAnalyzer analyzer) throws ParseException {    // (JavaCodeGenerator.meta.java:4745)
        final int[][] lrTable = DanglingElseSyntax.__lrTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4746)
                                                                                // (JavaCodeGenerator.meta.java:4747)
        assert context.unbrokenStates.isEmpty();                                // (JavaCodeGenerator.meta.java:4748)
        context.unbrokenStates.addAll(context.states.values());                 // (JavaCodeGenerator.meta.java:4749)
                                                                                // (JavaCodeGenerator.meta.java:4750)
        Token errorNextToken = context.nextToken;                               // (JavaCodeGenerator.meta.java:4751)
        context.nextTokenID = $ERROR_REPORT_MODE;                               // (JavaCodeGenerator.meta.java:4752)
        context.nextToken = null;                                               // (JavaCodeGenerator.meta.java:4753)
                                                                                // (JavaCodeGenerator.meta.java:4754)
        tokenLoop:                                                              // (JavaCodeGenerator.meta.java:4755)
        while (!context.unbrokenStates.isEmpty() || !context.chores.isEmpty()) {    // (JavaCodeGenerator.meta.java:4756)
            if (!context.unbrokenStates.isEmpty()) {                            // (JavaCodeGenerator.meta.java:4757)
                java.util.Iterator it = context.unbrokenStates.iterator();      // (JavaCodeGenerator.meta.java:4758)
                __StateVertex__notavacc_reserved stateToBreak = (__StateVertex__notavacc_reserved) it.next();    // (JavaCodeGenerator.meta.java:4759)
                it.remove();                                                    // (JavaCodeGenerator.meta.java:4760)
                it = null;                                                      // (JavaCodeGenerator.meta.java:4761)
                __breakState__notavacc_reserved(context, null, stateToBreak);    // (JavaCodeGenerator.meta.java:4762)
            } else {                                                            // (JavaCodeGenerator.meta.java:4763)
                java.util.Iterator it = context.chores.iterator();              // (JavaCodeGenerator.meta.java:4764)
                __Chore__notavacc_reserved chore = (__Chore__notavacc_reserved) it.next();    // (JavaCodeGenerator.meta.java:4765)
                it.remove();                                                    // (JavaCodeGenerator.meta.java:4766)
                it = null;                                                      // (JavaCodeGenerator.meta.java:4767)
                __chopChore__notavacc_reserved(context, chore);                 // (JavaCodeGenerator.meta.java:4768)
            }                                                                   // (JavaCodeGenerator.meta.java:4769)
        }                                                                       // (JavaCodeGenerator.meta.java:4770)
        context.absorbMap2.clear();                                             // (JavaCodeGenerator.meta.java:4771)
                                                                                // (JavaCodeGenerator.meta.java:4772)
        final java.util.Set nextTokens = new java.util.LinkedHashSet();         // (JavaCodeGenerator.meta.java:4773)
                                                                                // (JavaCodeGenerator.meta.java:4774)
        java.util.Iterator it25 = context.states.values().iterator();           // (JavaCodeGenerator.meta.java:4775)
        shiftLoop:                                                              // (JavaCodeGenerator.meta.java:4776)
        while (it25.hasNext()) {                                                // (JavaCodeGenerator.meta.java:4777)
            __StateVertex__notavacc_reserved currentState = (__StateVertex__notavacc_reserved) it25.next();    // (JavaCodeGenerator.meta.java:4778)
                                                                                // (JavaCodeGenerator.meta.java:4779)
            final int[] tokenIDToNextState = lrTable[currentState.stateNo * 3 + 0];    // (JavaCodeGenerator.meta.java:4780)
            int index = 0;                                                      // (JavaCodeGenerator.meta.java:4781)
            for (; tokenIDToNextState[index] != __TABLE_SENTINEL__notavacc_reserved; index += 2) {    // (JavaCodeGenerator.meta.java:4782)
                nextTokens.add(new java.lang.Integer(tokenIDToNextState[index]));    // (JavaCodeGenerator.meta.java:4783)
            }                                                                   // (JavaCodeGenerator.meta.java:4784)
        }                                                                       // (JavaCodeGenerator.meta.java:4785)
                                                                                // (JavaCodeGenerator.meta.java:4786)
        int[] selectableTokens = new int[nextTokens.size()];                    // (JavaCodeGenerator.meta.java:4787)
        int index = 0;                                                          // (JavaCodeGenerator.meta.java:4788)
        java.util.Iterator it11 = nextTokens.iterator();                        // (JavaCodeGenerator.meta.java:4789)
        while (it11.hasNext()) {                                                // (JavaCodeGenerator.meta.java:4790)
            java.lang.Integer i = (java.lang.Integer) it11.next();              // (JavaCodeGenerator.meta.java:4791)
            selectableTokens[index++] = i.intValue();                           // (JavaCodeGenerator.meta.java:4792)
        }                                                                       // (JavaCodeGenerator.meta.java:4793)
        __error__notavacc_reserved(analyzer, errorNextToken, selectableTokens);    // (JavaCodeGenerator.meta.java:4794)
    }                                                                           // (JavaCodeGenerator.meta.java:4795)
    private static void __error__notavacc_reserved(LexicalAnalyzer analyzer, Token errorNextToken, int[] selectableNextTokens) throws ParseException {    // (JavaCodeGenerator.meta.java:4796)
        java.io.StringWriter buffer = new java.io.StringWriter();               // (JavaCodeGenerator.meta.java:4797)
        java.io.PrintWriter writer = new java.io.PrintWriter(buffer);           // (JavaCodeGenerator.meta.java:4798)
                                                                                // (JavaCodeGenerator.meta.java:4799)
        if (errorNextToken.getSymbolID() != EOF_TOKEN) {                        // (JavaCodeGenerator.meta.java:4800)
            writer.println("The token " + errorNextToken + " should be one of the following.");    // (JavaCodeGenerator.meta.java:4801)
        } else {                                                                // (JavaCodeGenerator.meta.java:4802)
            writer.println("The EOF should be one of the following.");          // (JavaCodeGenerator.meta.java:4803)
        }                                                                       // (JavaCodeGenerator.meta.java:4804)
                                                                                // (JavaCodeGenerator.meta.java:4805)
        final java.lang.String[] tokenStrings = {                               // (JavaCodeGenerator.meta.java:4806)
            "<EOF>",                                                            // (JavaCodeGenerator.meta.java:4811)
            "WHITE_SPACES",                                                     // (JavaCodeGenerator.meta.java:4811)
            "\"(\"",                                                            // (JavaCodeGenerator.meta.java:4811)
            "\")\"",                                                            // (JavaCodeGenerator.meta.java:4811)
            "\";\"",                                                            // (JavaCodeGenerator.meta.java:4811)
            "\"else\"",                                                         // (JavaCodeGenerator.meta.java:4811)
            "\"expr\"",                                                         // (JavaCodeGenerator.meta.java:4811)
            "\"if\"",                                                           // (JavaCodeGenerator.meta.java:4811)
            "\"statement\"",                                                    // (JavaCodeGenerator.meta.java:4811)
        };                                                                      // (JavaCodeGenerator.meta.java:4814)
                                                                                // (JavaCodeGenerator.meta.java:4815)
        for (int i = 0; i < selectableNextTokens.length; i++) {                 // (JavaCodeGenerator.meta.java:4816)
            int selectableNextToken = selectableNextTokens[i];                  // (JavaCodeGenerator.meta.java:4817)
            writer.print("        ");                                           // (JavaCodeGenerator.meta.java:4818)
            writer.println(tokenStrings[selectableNextToken]);                  // (JavaCodeGenerator.meta.java:4819)
        }                                                                       // (JavaCodeGenerator.meta.java:4820)
                                                                                // (JavaCodeGenerator.meta.java:4821)
        writer.close();                                                         // (JavaCodeGenerator.meta.java:4822)
        if (writer.checkError())                                                // (JavaCodeGenerator.meta.java:4823)
            throw new java.lang.RuntimeException();                             // (JavaCodeGenerator.meta.java:4824)
        throw new ParseException(buffer.toString(), errorNextToken);            // (JavaCodeGenerator.meta.java:4825)
    }                                                                           // (JavaCodeGenerator.meta.java:4826)
                                                                                // (JavaCodeGenerator.meta.java:4827)
    private void __breakState__notavacc_reserved(__Context__notavacc_reserved context, __SymbolVertex__notavacc_reserved successorRestriction, __StateVertex__notavacc_reserved state) {    // (JavaCodeGenerator.meta.java:4829)
        final int[][] lrTable = DanglingElseSyntax.__lrTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4830)
                                                                                // (JavaCodeGenerator.meta.java:4831)
                                                                                // (JavaCodeGenerator.meta.java:4835)
        int[] tokenIDToReductionID = lrTable[state.stateNo * 3 + 2];            // (JavaCodeGenerator.meta.java:4836)
        if (context.nextTokenID != $ERROR_REPORT_MODE) {                        // (JavaCodeGenerator.meta.java:4837)
            int index = $binarySearchLRTable(tokenIDToReductionID, context.nextTokenID);    // (JavaCodeGenerator.meta.java:4838)
            for (; tokenIDToReductionID[index] == context.nextTokenID; index += 2) {    // (JavaCodeGenerator.meta.java:4839)
                final int reductionID = tokenIDToReductionID[index + 1];        // (JavaCodeGenerator.meta.java:4840)
                __breakState__notavacc_reserved(context, successorRestriction, state, reductionID);    // (JavaCodeGenerator.meta.java:4841)
            }                                                                   // (JavaCodeGenerator.meta.java:4842)
        } else {                                                                // (JavaCodeGenerator.meta.java:4843)
            java.util.Set reductionIDs = new java.util.TreeSet();               // (JavaCodeGenerator.meta.java:4844)
            int index = 0;                                                      // (JavaCodeGenerator.meta.java:4845)
            for (; tokenIDToReductionID[index] != __TABLE_SENTINEL__notavacc_reserved; index += 2) {    // (JavaCodeGenerator.meta.java:4846)
                final int reductionID = tokenIDToReductionID[index + 1];        // (JavaCodeGenerator.meta.java:4847)
                reductionIDs.add(new java.lang.Integer(reductionID));           // (JavaCodeGenerator.meta.java:4848)
            }                                                                   // (JavaCodeGenerator.meta.java:4849)
            java.util.Iterator it31 = reductionIDs.iterator();                  // (JavaCodeGenerator.meta.java:4850)
            while (it31.hasNext()) {                                            // (JavaCodeGenerator.meta.java:4851)
                java.lang.Integer reductionID = (java.lang.Integer) it31.next();    // (JavaCodeGenerator.meta.java:4852)
                __breakState__notavacc_reserved(context, successorRestriction, state, reductionID.intValue());    // (JavaCodeGenerator.meta.java:4853)
            }                                                                   // (JavaCodeGenerator.meta.java:4854)
        }                                                                       // (JavaCodeGenerator.meta.java:4855)
    }                                                                           // (JavaCodeGenerator.meta.java:4859)
    private void __breakState__notavacc_reserved(__Context__notavacc_reserved context, __SymbolVertex__notavacc_reserved successorRestriction, __StateVertex__notavacc_reserved state, int reductionID) {    // (JavaCodeGenerator.meta.java:4860)
        final int[][] reductionTable = DanglingElseSyntax.__reductionTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4861)
        final int[] reduction = reductionTable[reductionID];                    // (JavaCodeGenerator.meta.java:4862)
                                                                                // (JavaCodeGenerator.meta.java:4863)
        if (reduction.length == 1) {                                            // (JavaCodeGenerator.meta.java:4867)
            if (successorRestriction == null) {                                 // (JavaCodeGenerator.meta.java:4868)
                __Chore__notavacc_reserved chore = new __Chore__notavacc_reserved(state, reductionID);    // (JavaCodeGenerator.meta.java:4869)
                context.chores.add(chore);                                      // (JavaCodeGenerator.meta.java:4870)
            }                                                                   // (JavaCodeGenerator.meta.java:4874)
        } else {                                                                // (JavaCodeGenerator.meta.java:4875)
            if (successorRestriction == null) {                                 // (JavaCodeGenerator.meta.java:4876)
                __Link__notavacc_reserved it1 = state.getSuccessors();          // (JavaCodeGenerator.meta.java:4877)
                do {                                                            // (JavaCodeGenerator.meta.java:4878)
                    __SymbolVertex__notavacc_reserved successor = (__SymbolVertex__notavacc_reserved) it1.value;    // (JavaCodeGenerator.meta.java:4879)
                    __Chore__notavacc_reserved chore = new __Chore__notavacc_reserved(state, successor, reductionID);    // (JavaCodeGenerator.meta.java:4880)
                    context.chores.add(chore);                                  // (JavaCodeGenerator.meta.java:4881)
                } while ((it1 = it1.next) != null);                             // (JavaCodeGenerator.meta.java:4885)
            } else {                                                            // (JavaCodeGenerator.meta.java:4886)
                __SymbolVertex__notavacc_reserved successor = successorRestriction;    // (JavaCodeGenerator.meta.java:4887)
                __Chore__notavacc_reserved chore = new __Chore__notavacc_reserved(state, successor, reductionID);    // (JavaCodeGenerator.meta.java:4888)
                context.chores.add(chore);                                      // (JavaCodeGenerator.meta.java:4889)
            }                                                                   // (JavaCodeGenerator.meta.java:4893)
        }                                                                       // (JavaCodeGenerator.meta.java:4894)
    }                                                                           // (JavaCodeGenerator.meta.java:4895)
    private void __chopChore__notavacc_reserved(__Context__notavacc_reserved context, __Chore__notavacc_reserved chore) throws ParseException {    // (JavaCodeGenerator.meta.java:4897)
        final int labelWordCount = 1;                                           // (JavaCodeGenerator.meta.java:4898)
        assert chore.state.whiteTokenHolder == context.whiteTokenHolder;        // (JavaCodeGenerator.meta.java:4899)
                                                                                // (JavaCodeGenerator.meta.java:4900)
                                                                                // (JavaCodeGenerator.meta.java:4904)
        int reductionID = chore.reductionID;                                    // (JavaCodeGenerator.meta.java:4905)
        if (chore.successor == null) {                                          // (JavaCodeGenerator.meta.java:4906)
            __StateVertex__notavacc_reserved turningPoint = chore.state;        // (JavaCodeGenerator.meta.java:4907)
            __addLink__notavacc_reserved(context, turningPoint, reductionID, null);    // (JavaCodeGenerator.meta.java:4908)
        } else {                                                                // (JavaCodeGenerator.meta.java:4909)
            __StateVertex__notavacc_reserved state = chore.state;               // (JavaCodeGenerator.meta.java:4910)
            int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4911)
            int reductionSize = (reduction.length - 1) / labelWordCount;        // (JavaCodeGenerator.meta.java:4912)
            assert reductionSize > 0;                                           // (JavaCodeGenerator.meta.java:4913)
            __backChoreOdd__notavacc_reserved(context, reductionID, reductionSize * 2 - 1, chore.successor, new __Link__notavacc_reserved(state.whiteTokenHolder, null), false);    // (JavaCodeGenerator.meta.java:4914)
        }                                                                       // (JavaCodeGenerator.meta.java:4915)
                                                                                // (JavaCodeGenerator.meta.java:4916)
    }                                                                           // (JavaCodeGenerator.meta.java:4920)
    private void __backChoreOdd__notavacc_reserved(__Context__notavacc_reserved context, int reductionID, int countOfSuccessorsToReduce, __SymbolVertex__notavacc_reserved symbolVertex, __Link__notavacc_reserved children, boolean nodeCreatable) throws ParseException {    // (JavaCodeGenerator.meta.java:4922)
        assert countOfSuccessorsToReduce % 2 == 1;                              // (JavaCodeGenerator.meta.java:4923)
                                                                                // (JavaCodeGenerator.meta.java:4934)
        java.lang.Object child = symbolVertex.symbol;                           // (JavaCodeGenerator.meta.java:4935)
        if (child instanceof __ConcreteSyntaxTree__notavacc_reserved && (context.nextTokenID != $ERROR_REPORT_MODE)) {    // (JavaCodeGenerator.meta.java:4936)
            __ConcreteSyntaxTree__notavacc_reserved cst = (__ConcreteSyntaxTree__notavacc_reserved) child;    // (JavaCodeGenerator.meta.java:4937)
            if (false && cst.reductionID < 1) {                                 // (JavaCodeGenerator.meta.java:4938)
                // TODO: skip の判定が間違っているので直す。                                   // (JavaCodeGenerator.meta.java:4939)
                child = cst.children[1];                                        // (JavaCodeGenerator.meta.java:4940)
            } else if (false && nodeCreatable) {    // TODO: nodeCreatable をなくす。    // (JavaCodeGenerator.meta.java:4941)
            Node node = cst.createNode(context);                                // (JavaCodeGenerator.meta.java:4942)
            if (node != null)                                                   // (JavaCodeGenerator.meta.java:4943)
                child = node;                                                   // (JavaCodeGenerator.meta.java:4944)
        }                                                                       // (JavaCodeGenerator.meta.java:4945)
    }                                                                           // (JavaCodeGenerator.meta.java:4946)
    children = new __Link__notavacc_reserved(child, children);                  // (JavaCodeGenerator.meta.java:4947)
                                                                                // (JavaCodeGenerator.meta.java:4948)
    if (countOfSuccessorsToReduce > 1) {                                        // (JavaCodeGenerator.meta.java:4949)
        countOfSuccessorsToReduce--;                                            // (JavaCodeGenerator.meta.java:4950)
        __Link__notavacc_reserved it2 = symbolVertex.getSuccessors();           // (JavaCodeGenerator.meta.java:4951)
        do {                                                                    // (JavaCodeGenerator.meta.java:4952)
            __StateVertex__notavacc_reserved state = (__StateVertex__notavacc_reserved) it2.value;    // (JavaCodeGenerator.meta.java:4953)
            __backChoreEven__notavacc_reserved(context, reductionID, countOfSuccessorsToReduce, state, children);    // (JavaCodeGenerator.meta.java:4954)
        } while ((it2 = it2.next) != null);                                     // (JavaCodeGenerator.meta.java:4955)
    } else {                                                                    // (JavaCodeGenerator.meta.java:4956)
        __StateVertex__notavacc_reserved state = (__StateVertex__notavacc_reserved) symbolVertex.getSuccessors().value;    // (JavaCodeGenerator.meta.java:4957)
        children = new __Link__notavacc_reserved(state.whiteTokenHolder.next, children);    // (JavaCodeGenerator.meta.java:4958)
        {                                                                       // (JavaCodeGenerator.meta.java:4959)
            __Link__notavacc_reserved it2 = symbolVertex.getSuccessors();       // (JavaCodeGenerator.meta.java:4960)
            do {                                                                // (JavaCodeGenerator.meta.java:4961)
                __StateVertex__notavacc_reserved s = (__StateVertex__notavacc_reserved) it2.value;    // (JavaCodeGenerator.meta.java:4962)
                assert s.whiteTokenHolder.next == state.whiteTokenHolder.next;    // (JavaCodeGenerator.meta.java:4963)
            } while ((it2 = it2.next) != null);                                 // (JavaCodeGenerator.meta.java:4964)
        }                                                                       // (JavaCodeGenerator.meta.java:4965)
        __addLinks__notavacc_reserved(context, reductionID, symbolVertex, children);    // (JavaCodeGenerator.meta.java:4966)
    }                                                                           // (JavaCodeGenerator.meta.java:4967)
}                                                                               // (JavaCodeGenerator.meta.java:4968)
private void __backChoreEven__notavacc_reserved(__Context__notavacc_reserved context, int reductionID, int countOfSuccessorsToReduce, __StateVertex__notavacc_reserved state, __Link__notavacc_reserved children) throws ParseException {    // (JavaCodeGenerator.meta.java:4970)
    assert countOfSuccessorsToReduce % 2 == 0;                                  // (JavaCodeGenerator.meta.java:4971)
    children = new __Link__notavacc_reserved(state.whiteTokenHolder.next, children);    // (JavaCodeGenerator.meta.java:4982)
    assert countOfSuccessorsToReduce > 0;                                       // (JavaCodeGenerator.meta.java:4983)
    countOfSuccessorsToReduce--;                                                // (JavaCodeGenerator.meta.java:4984)
    __Link__notavacc_reserved it1 = state.getSuccessors();                      // (JavaCodeGenerator.meta.java:4985)
    do {                                                                        // (JavaCodeGenerator.meta.java:4986)
        __SymbolVertex__notavacc_reserved symbolVertex = (__SymbolVertex__notavacc_reserved) it1.value;    // (JavaCodeGenerator.meta.java:4987)
        __backChoreOdd__notavacc_reserved(context, reductionID, countOfSuccessorsToReduce, symbolVertex, children, state.whiteTokenHolder != context.whiteTokenHolder);    // (JavaCodeGenerator.meta.java:4988)
    } while ((it1 = it1.next) != null);                                         // (JavaCodeGenerator.meta.java:4989)
}                                                                               // (JavaCodeGenerator.meta.java:4990)
private void __addLinks__notavacc_reserved(__Context__notavacc_reserved context, int reductionID, __SymbolVertex__notavacc_reserved symbolVertex, __Link__notavacc_reserved children) throws ParseException {    // (JavaCodeGenerator.meta.java:4992)
    final int[][] lrTable = DanglingElseSyntax.__lrTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:4993)
    final int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:4994)
    final int nextSymbolID = reduction[0];                                      // (JavaCodeGenerator.meta.java:4995)
    final boolean absorberSymbol = (nextSymbolID < 14);                         // (JavaCodeGenerator.meta.java:4997)
    assert children != null;                                                    // (JavaCodeGenerator.meta.java:4998)
    __ConcreteSyntaxTree__notavacc_reserved tree = new __ConcreteSyntaxTree__notavacc_reserved(context, reductionID, children == null ? null : children.toArray(context));    // (JavaCodeGenerator.meta.java:4999)
                                                                                // (JavaCodeGenerator.meta.java:5000)
    final boolean aho = false;                                                  // (JavaCodeGenerator.meta.java:5001)
    if (!aho) {                                                                 // (JavaCodeGenerator.meta.java:5002)
        if (!absorberSymbol) {                                                  // (JavaCodeGenerator.meta.java:5003)
            __Link__notavacc_reserved it2 = symbolVertex.getSuccessors();       // (JavaCodeGenerator.meta.java:5004)
            do {                                                                // (JavaCodeGenerator.meta.java:5005)
                __StateVertex__notavacc_reserved turningPoint = (__StateVertex__notavacc_reserved) it2.value;    // (JavaCodeGenerator.meta.java:5006)
                final int[] symbolIDToNextState = lrTable[turningPoint.stateNo * 3 + 1];    // (JavaCodeGenerator.meta.java:5007)
                int index = $binarySearchLRTable(symbolIDToNextState, nextSymbolID);    // (JavaCodeGenerator.meta.java:5008)
                if (symbolIDToNextState[index] == nextSymbolID) {               // (JavaCodeGenerator.meta.java:5010)
                    int nextStateNo = symbolIDToNextState[index + 1];           // (JavaCodeGenerator.meta.java:5011)
                    __addLink__notavacc_reserved(context, java.util.Collections.singleton(turningPoint), reductionID, tree, new java.lang.Integer(nextStateNo));    // (JavaCodeGenerator.meta.java:5012)
                }                                                               // (JavaCodeGenerator.meta.java:5013)
            } while ((it2 = it2.next) != null);                                 // (JavaCodeGenerator.meta.java:5014)
            return;                                                             // (JavaCodeGenerator.meta.java:5015)
        }                                                                       // (JavaCodeGenerator.meta.java:5016)
    }                                                                           // (JavaCodeGenerator.meta.java:5017)
                                                                                // (JavaCodeGenerator.meta.java:5018)
    __Link__notavacc_reserved it2 = symbolVertex.getSuccessors();               // (JavaCodeGenerator.meta.java:5019)
    do {                                                                        // (JavaCodeGenerator.meta.java:5020)
        __StateVertex__notavacc_reserved turningPoint = (__StateVertex__notavacc_reserved) it2.value;    // (JavaCodeGenerator.meta.java:5021)
        final int[] symbolIDToNextState = lrTable[turningPoint.stateNo * 3 + 1];    // (JavaCodeGenerator.meta.java:5022)
        int index = $binarySearchLRTable(symbolIDToNextState, nextSymbolID);    // (JavaCodeGenerator.meta.java:5023)
        if (symbolIDToNextState[index] == nextSymbolID) {                       // (JavaCodeGenerator.meta.java:5025)
            int nextStateNo = symbolIDToNextState[index + 1];                   // (JavaCodeGenerator.meta.java:5026)
            java.lang.Integer key = new java.lang.Integer(nextStateNo);         // (JavaCodeGenerator.meta.java:5027)
            java.util.LinkedHashSet set = (java.util.LinkedHashSet) context.tmpMap.get(key);    // (JavaCodeGenerator.meta.java:5028)
            if (set == null) {                                                  // (JavaCodeGenerator.meta.java:5029)
                set = new java.util.LinkedHashSet();                            // (JavaCodeGenerator.meta.java:5030)
                context.tmpMap.put(key, set);                                   // (JavaCodeGenerator.meta.java:5031)
            }                                                                   // (JavaCodeGenerator.meta.java:5032)
            set.add(turningPoint);                                              // (JavaCodeGenerator.meta.java:5033)
        }                                                                       // (JavaCodeGenerator.meta.java:5034)
    } while ((it2 = it2.next) != null);                                         // (JavaCodeGenerator.meta.java:5035)
                                                                                // (JavaCodeGenerator.meta.java:5036)
    java.util.Iterator it26 = context.tmpMap.entrySet().iterator();             // (JavaCodeGenerator.meta.java:5037)
    while (it26.hasNext()) {                                                    // (JavaCodeGenerator.meta.java:5038)
        java.util.Map.Entry entry = (java.util.Map.Entry) it26.next();          // (JavaCodeGenerator.meta.java:5039)
        java.lang.Integer nextStateNo = (java.lang.Integer) entry.getKey();     // (JavaCodeGenerator.meta.java:5040)
        java.util.LinkedHashSet turningPoints = (java.util.LinkedHashSet) entry.getValue();    // (JavaCodeGenerator.meta.java:5041)
                                                                                // (JavaCodeGenerator.meta.java:5042)
        __addLink__notavacc_reserved(context, turningPoints, reductionID, tree, nextStateNo);    // (JavaCodeGenerator.meta.java:5043)
    }                                                                           // (JavaCodeGenerator.meta.java:5044)
    context.tmpMap.clear();                                                     // (JavaCodeGenerator.meta.java:5045)
}                                                                               // (JavaCodeGenerator.meta.java:5046)
private void __addLink__notavacc_reserved(__Context__notavacc_reserved context, __StateVertex__notavacc_reserved turningPoint, int reductionID, __Link__notavacc_reserved children) throws ParseException {    // (JavaCodeGenerator.meta.java:5048)
    final int[][] lrTable = DanglingElseSyntax.__lrTable__notavacc_reserved;    // (JavaCodeGenerator.meta.java:5049)
    final int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:5050)
    final int nextSymbolID = reduction[0];                                      // (JavaCodeGenerator.meta.java:5051)
    assert children == null;                                                    // (JavaCodeGenerator.meta.java:5052)
    __ConcreteSyntaxTree__notavacc_reserved tree = new __ConcreteSyntaxTree__notavacc_reserved(context, reductionID, children == null ? null : children.toArray(context));    // (JavaCodeGenerator.meta.java:5053)
                                                                                // (JavaCodeGenerator.meta.java:5054)
    final int[] symbolIDToNextState = lrTable[turningPoint.stateNo * 3 + 1];    // (JavaCodeGenerator.meta.java:5055)
    int index = $binarySearchLRTable(symbolIDToNextState, nextSymbolID);        // (JavaCodeGenerator.meta.java:5056)
    if (symbolIDToNextState[index] == nextSymbolID) {                           // (JavaCodeGenerator.meta.java:5058)
        int nextStateNo = symbolIDToNextState[index + 1];                       // (JavaCodeGenerator.meta.java:5059)
        __addLink__notavacc_reserved(context, java.util.Collections.singleton(turningPoint), reductionID, tree, new java.lang.Integer(nextStateNo));    // (JavaCodeGenerator.meta.java:5060)
    }                                                                           // (JavaCodeGenerator.meta.java:5061)
}                                                                               // (JavaCodeGenerator.meta.java:5062)
private void __addLink__notavacc_reserved(__Context__notavacc_reserved context, java.util.Set turningPoints, int reductionID, __ConcreteSyntaxTree__notavacc_reserved tree, java.lang.Integer nextStateNoInteger) {    // (JavaCodeGenerator.meta.java:5063)
    final int[] reduction = DanglingElseSyntax.__reductionTable__notavacc_reserved[reductionID];    // (JavaCodeGenerator.meta.java:5064)
    final int nextSymbolID = reduction[0];                                      // (JavaCodeGenerator.meta.java:5065)
    final boolean absorberSymbol = (nextSymbolID < 14);                         // (JavaCodeGenerator.meta.java:5067)
                                                                                // (JavaCodeGenerator.meta.java:5068)
                                                                                // (JavaCodeGenerator.meta.java:5072)
    __StateVertex__notavacc_reserved stateVertex = (__StateVertex__notavacc_reserved) context.states.get(nextStateNoInteger);    // (JavaCodeGenerator.meta.java:5073)
    __SymbolVertex__notavacc_reserved symbolVertex = null;  // if null, create a new sumbol vertex.    // (JavaCodeGenerator.meta.java:5074)
    __AbsorbKey2__notavacc_reserved key = null;             // if not null, maintain the dictionary.    // (JavaCodeGenerator.meta.java:5075)
    final boolean debugCheck = false;                                           // (JavaCodeGenerator.meta.java:5078)
    final boolean aho = false;                                                  // (JavaCodeGenerator.meta.java:5082)
    if (aho) {                                                                  // (JavaCodeGenerator.meta.java:5083)
        key = new __AbsorbKey2__notavacc_reserved(turningPoints, nextSymbolID);    // (JavaCodeGenerator.meta.java:5084)
        if (stateVertex == null) {                                              // (JavaCodeGenerator.meta.java:5085)
            assert (__SymbolVertex__notavacc_reserved) context.absorbMap2.get(key) == null;    // (JavaCodeGenerator.meta.java:5086)
        } else {                                                                // (JavaCodeGenerator.meta.java:5087)
            symbolVertex = (__SymbolVertex__notavacc_reserved) context.absorbMap2.get(key);    // (JavaCodeGenerator.meta.java:5088)
        }                                                                       // (JavaCodeGenerator.meta.java:5089)
        if (debugCheck || absorberSymbol) {                                     // (JavaCodeGenerator.meta.java:5090)
            if (symbolVertex != null && !absorberSymbol) {                      // (JavaCodeGenerator.meta.java:5091)
                // TODO: report                                                 // (JavaCodeGenerator.meta.java:5092)
                throw new ParseException.AmbiguousGrammarError("DanglingElseSyntax.notavacc" + " is ambiguous.  Use --debug option to build a verbose parser.");    // (JavaCodeGenerator.meta.java:5093)
                //key = null;                                                   // (JavaCodeGenerator.meta.java:5094)
                //symbolVertex = null;                                          // (JavaCodeGenerator.meta.java:5095)
            }                                                                   // (JavaCodeGenerator.meta.java:5096)
        }                                                                       // (JavaCodeGenerator.meta.java:5097)
        if (debugCheck || absorberSymbol) {                                     // (JavaCodeGenerator.meta.java:5098)
        } else {                                                                // (JavaCodeGenerator.meta.java:5099)
            symbolVertex = null;                                                // (JavaCodeGenerator.meta.java:5100)
        }                                                                       // (JavaCodeGenerator.meta.java:5101)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5102)
        if (debugCheck || absorberSymbol || context.nextTokenID == $ERROR_REPORT_MODE) {    // (JavaCodeGenerator.meta.java:5103)
            key = new __AbsorbKey2__notavacc_reserved(turningPoints, nextSymbolID);    // (JavaCodeGenerator.meta.java:5104)
            if (stateVertex == null) {                                          // (JavaCodeGenerator.meta.java:5105)
                assert (__SymbolVertex__notavacc_reserved) context.absorbMap2.get(key) == null;    // (JavaCodeGenerator.meta.java:5106)
            } else {                                                            // (JavaCodeGenerator.meta.java:5107)
                symbolVertex = (__SymbolVertex__notavacc_reserved) context.absorbMap2.get(key);    // (JavaCodeGenerator.meta.java:5108)
            }                                                                   // (JavaCodeGenerator.meta.java:5109)
        }                                                                       // (JavaCodeGenerator.meta.java:5129)
    }                                                                           // (JavaCodeGenerator.meta.java:5130)
    if (symbolVertex != null) {                                                 // (JavaCodeGenerator.meta.java:5131)
        if (context.nextTokenID != $ERROR_REPORT_MODE) {                        // (JavaCodeGenerator.meta.java:5135)
            ((__Link__notavacc_reserved) symbolVertex.symbol).addLink(tree);    // (JavaCodeGenerator.meta.java:5136)
        }                                                                       // (JavaCodeGenerator.meta.java:5137)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5141)
        java.util.Iterator it = turningPoints.iterator();                       // (JavaCodeGenerator.meta.java:5142)
        symbolVertex = new __SymbolVertex__notavacc_reserved((__StateVertex__notavacc_reserved) it.next(), new __Link__notavacc_reserved(tree, null));    // (JavaCodeGenerator.meta.java:5143)
        // 注意：上の__SymbolVertex__notavacc_reserved で、第二引数を tree にして、あとで addLink が必要になってから __Link__notavacc_reserved を作ってはいけない。    // (JavaCodeGenerator.meta.java:5144)
        // addLink されるより前に flatNode の対象になる可能性がある。                               // (JavaCodeGenerator.meta.java:5145)
        // TODO: シフト時に flatNode する仕様にしたので、そうではなくなった。                            // (JavaCodeGenerator.meta.java:5146)
        while (it.hasNext()) {                                                  // (JavaCodeGenerator.meta.java:5147)
            __StateVertex__notavacc_reserved turningPoint = (__StateVertex__notavacc_reserved) it.next();    // (JavaCodeGenerator.meta.java:5148)
            symbolVertex.addSuccessor(turningPoint);                            // (JavaCodeGenerator.meta.java:5149)
        }                                                                       // (JavaCodeGenerator.meta.java:5150)
        if (key != null)                                                        // (JavaCodeGenerator.meta.java:5151)
            context.absorbMap2.put(key, symbolVertex);                          // (JavaCodeGenerator.meta.java:5152)
        if (stateVertex == null) {                                              // (JavaCodeGenerator.meta.java:5153)
            stateVertex = new __StateVertex__notavacc_reserved(symbolVertex, nextStateNoInteger.intValue(), context.generation);    // (JavaCodeGenerator.meta.java:5154)
            context.states.put(nextStateNoInteger, stateVertex);                // (JavaCodeGenerator.meta.java:5155)
            stateVertex.whiteTokenHolder = context.whiteTokenHolder;            // (JavaCodeGenerator.meta.java:5156)
            context.unbrokenStates.add(stateVertex);                            // (JavaCodeGenerator.meta.java:5160)
        } else {                                                                // (JavaCodeGenerator.meta.java:5161)
            assert stateVertex.whiteTokenHolder == context.whiteTokenHolder;    // (JavaCodeGenerator.meta.java:5162)
            stateVertex.addSuccessor(symbolVertex);                             // (JavaCodeGenerator.meta.java:5163)
            if (!context.unbrokenStates.contains(stateVertex))                  // (JavaCodeGenerator.meta.java:5167)
                __breakState__notavacc_reserved(context, symbolVertex, stateVertex);    // (JavaCodeGenerator.meta.java:5168)
        }                                                                       // (JavaCodeGenerator.meta.java:5169)
    }                                                                           // (JavaCodeGenerator.meta.java:5170)
}                                                                               // (JavaCodeGenerator.meta.java:5174)
                                                                                // (JavaCodeGenerator.meta.java:5175)
private static class __LabeledNode__notavacc_reserved {                         // (JavaCodeGenerator.meta.java:5177)
    public int labels;                                                          // (JavaCodeGenerator.meta.java:5178)
    public Node node;                                                           // (JavaCodeGenerator.meta.java:5179)
    public __LabeledNode__notavacc_reserved(int labels, Node node) {            // (JavaCodeGenerator.meta.java:5180)
        this.labels = labels;                                                   // (JavaCodeGenerator.meta.java:5181)
        this.node = node;                                                       // (JavaCodeGenerator.meta.java:5182)
    }                                                                           // (JavaCodeGenerator.meta.java:5183)
}                                                                               // (JavaCodeGenerator.meta.java:5184)
                                                                                // (JavaCodeGenerator.meta.java:5185)
private Node createNode(__Context__notavacc_reserved context, __ConcreteSyntaxTree__notavacc_reserved cst) throws ParseException {    // (JavaCodeGenerator.meta.java:5186)
    return createNode(context, null, cst, null);                                // (JavaCodeGenerator.meta.java:5187)
}                                                                               // (JavaCodeGenerator.meta.java:5188)
private Node createNode(__Context__notavacc_reserved context, __Link__notavacc_reserved headWhiteToken, __ConcreteSyntaxTree__notavacc_reserved cst, __Link__notavacc_reserved tailWhiteToken) throws ParseException {    // (JavaCodeGenerator.meta.java:5189)
    int[] reduction = context.parser.__reductionTable__notavacc_reserved[cst.reductionID];    // (JavaCodeGenerator.meta.java:5190)
    assert reduction[0] < 13;                                                   // (JavaCodeGenerator.meta.java:5191)
                                                                                // (JavaCodeGenerator.meta.java:5192)
    __Link__notavacc_reserved nodeLists = new __Link__notavacc_reserved(null, null);    // (JavaCodeGenerator.meta.java:5193)
    nodeLists = $flatWhiteTokens(headWhiteToken, nodeLists);                    // (JavaCodeGenerator.meta.java:5195)
    nodeLists = $flatNodes(context, 0, cst, nodeLists);                         // (JavaCodeGenerator.meta.java:5196)
    if (headWhiteToken != tailWhiteToken)                                       // (JavaCodeGenerator.meta.java:5197)
        nodeLists = $flatWhiteTokens(tailWhiteToken, nodeLists);                // (JavaCodeGenerator.meta.java:5198)
                                                                                // (JavaCodeGenerator.meta.java:5205)
    if (nodeLists.next == null) {                                               // (JavaCodeGenerator.meta.java:5206)
        return createNode(context, reduction[0], (__Link__notavacc_reserved) nodeLists.value);    // (JavaCodeGenerator.meta.java:5207)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5208)
        java.util.List nodes = new java.util.LinkedList();                      // (JavaCodeGenerator.meta.java:5212)
        do {                                                                    // (JavaCodeGenerator.meta.java:5213)
            nodes.add(createNode(context, reduction[0], (__Link__notavacc_reserved) nodeLists.value));    // (JavaCodeGenerator.meta.java:5214)
            nodeLists = nodeLists.next;                                         // (JavaCodeGenerator.meta.java:5215)
        } while (nodeLists != null);                                            // (JavaCodeGenerator.meta.java:5216)
        DanglingElseSyntax.AmbiguityAbsorber result = createAmbiguityAbsorber(nodes);    // (JavaCodeGenerator.meta.java:5217)
        if (result == null)                                                     // (JavaCodeGenerator.meta.java:5218)
            __throwAmbiguousGrammerError__notavacc_reserved(reduction[0], nodes);    // (JavaCodeGenerator.meta.java:5219)
        return result;                                                          // (JavaCodeGenerator.meta.java:5220)
    }                                                                           // (JavaCodeGenerator.meta.java:5222)
}                                                                               // (JavaCodeGenerator.meta.java:5223)
private Node createNode(__Context__notavacc_reserved context, int symbolID, __Link__notavacc_reserved nodeList) throws ParseException {    // (JavaCodeGenerator.meta.java:5224)
    // TODO: createNode(symbolID, parameters) をダイレクトに nodeList を受け取るように修正する。    // (JavaCodeGenerator.meta.java:5225)
                                                                                // (JavaCodeGenerator.meta.java:5226)
    java.util.List labelBitsList = new java.util.LinkedList();                  // (JavaCodeGenerator.meta.java:5227)
    java.util.List nodes = new java.util.LinkedList();                          // (JavaCodeGenerator.meta.java:5228)
    for (; nodeList != null; nodeList = nodeList.next) {                        // (JavaCodeGenerator.meta.java:5229)
        __LabeledNode__notavacc_reserved n = (__LabeledNode__notavacc_reserved) nodeList.value;    // (JavaCodeGenerator.meta.java:5230)
        labelBitsList.add(0, new java.lang.Integer(n.labels));                  // (JavaCodeGenerator.meta.java:5232)
        nodes.add(0, n.node);                                                   // (JavaCodeGenerator.meta.java:5236)
    }                                                                           // (JavaCodeGenerator.meta.java:5237)
    Node[] childNodes = (Node[]) nodes.toArray(new Node[nodes.size()]);         // (JavaCodeGenerator.meta.java:5238)
    context.parameters.childNodes = childNodes;                                 // (JavaCodeGenerator.meta.java:5239)
    context.parameters.labelBitsList = labelBitsList;                           // (JavaCodeGenerator.meta.java:5240)
    Node result = createNode(symbolID, context.parameters);                     // (JavaCodeGenerator.meta.java:5241)
    context.parameters.childNodes = null;                                       // (JavaCodeGenerator.meta.java:5242)
    context.parameters.labelBitsList = null;                                    // (JavaCodeGenerator.meta.java:5243)
    return result;                                                              // (JavaCodeGenerator.meta.java:5244)
}                                                                               // (JavaCodeGenerator.meta.java:5245)
                                                                                // (JavaCodeGenerator.meta.java:5246)
private __Link__notavacc_reserved $flatNodes(__Context__notavacc_reserved context, int labels, __ConcreteSyntaxTree__notavacc_reserved cst) throws ParseException {    // (JavaCodeGenerator.meta.java:5247)
    return $flatNodes(context, labels, cst, new __Link__notavacc_reserved(null, null));    // (JavaCodeGenerator.meta.java:5248)
}                                                                               // (JavaCodeGenerator.meta.java:5249)
private __Link__notavacc_reserved $flatNodes(__Context__notavacc_reserved context, int labels, __ConcreteSyntaxTree__notavacc_reserved cst, __Link__notavacc_reserved nodeLists) throws ParseException {    // (JavaCodeGenerator.meta.java:5250)
    tailRecursion:                                                              // (JavaCodeGenerator.meta.java:5251)
    for (;;) {                                                                  // (JavaCodeGenerator.meta.java:5252)
        if (cst.children == null)                                               // (JavaCodeGenerator.meta.java:5253)
            return nodeLists;                                                   // (JavaCodeGenerator.meta.java:5254)
                                                                                // (JavaCodeGenerator.meta.java:5255)
        int[] reduction = context.parser.__reductionTable__notavacc_reserved[cst.reductionID];    // (JavaCodeGenerator.meta.java:5256)
        java.lang.Object tailWhiteToken = cst.children[cst.children.length - 1];    // (JavaCodeGenerator.meta.java:5258)
        int reductionIndex = 1;                                                 // (JavaCodeGenerator.meta.java:5262)
                                                                                // (JavaCodeGenerator.meta.java:5263)
        for (int index = 1; index < cst.children.length; index += 2) {          // (JavaCodeGenerator.meta.java:5264)
            __Link__notavacc_reserved whiteToken1 = (__Link__notavacc_reserved) cst.children[index - 1];    // (JavaCodeGenerator.meta.java:5265)
            __Link__notavacc_reserved whiteToken2 = (__Link__notavacc_reserved) cst.children[index + 1];    // (JavaCodeGenerator.meta.java:5266)
            java.lang.Object symbol = cst.children[index];                      // (JavaCodeGenerator.meta.java:5267)
            __Link__notavacc_reserved symbols = null;                           // (JavaCodeGenerator.meta.java:5268)
            if (symbol instanceof __Link__notavacc_reserved) {                  // (JavaCodeGenerator.meta.java:5269)
                symbols = (__Link__notavacc_reserved) symbol;                   // (JavaCodeGenerator.meta.java:5270)
                if (symbols.next == null) {                                     // (JavaCodeGenerator.meta.java:5271)
                    symbol = symbols.value;                                     // (JavaCodeGenerator.meta.java:5272)
                    symbols = null;                                             // (JavaCodeGenerator.meta.java:5273)
                }                                                               // (JavaCodeGenerator.meta.java:5274)
            }                                                                   // (JavaCodeGenerator.meta.java:5275)
                                                                                // (JavaCodeGenerator.meta.java:5276)
                                                                                // (JavaCodeGenerator.meta.java:5281)
            int mergedlabelBits = reduction[reductionIndex++];                  // (JavaCodeGenerator.meta.java:5283)
            if ((mergedlabelBits & 1) != 0) {                                   // (JavaCodeGenerator.meta.java:5284)
                mergedlabelBits &= ~1;                                          // (JavaCodeGenerator.meta.java:5285)
                mergedlabelBits |= labels;                                      // (JavaCodeGenerator.meta.java:5286)
            }                                                                   // (JavaCodeGenerator.meta.java:5287)
                                                                                // (JavaCodeGenerator.meta.java:5298)
            Node node;                                                          // (JavaCodeGenerator.meta.java:5299)
            if (symbols != null) {                                              // (JavaCodeGenerator.meta.java:5300)
                java.util.List childLinkList = new java.util.LinkedList();      // (JavaCodeGenerator.meta.java:5304)
                                                                                // (JavaCodeGenerator.meta.java:5305)
                java.util.List ambiguousNodes = new java.util.LinkedList();     // (JavaCodeGenerator.meta.java:5306)
                int childSymbolID = -1;                                         // (JavaCodeGenerator.meta.java:5307)
                java.lang.Integer childLabels = null;                           // (JavaCodeGenerator.meta.java:5308)
                {                                                               // (JavaCodeGenerator.meta.java:5309)
                    __Link__notavacc_reserved it = symbols;                     // (JavaCodeGenerator.meta.java:5310)
                    do {                                                        // (JavaCodeGenerator.meta.java:5311)
                        __ConcreteSyntaxTree__notavacc_reserved subtree = (__ConcreteSyntaxTree__notavacc_reserved) it.value;    // (JavaCodeGenerator.meta.java:5312)
                        int[] childReduction = context.parser.__reductionTable__notavacc_reserved[subtree.reductionID];    // (JavaCodeGenerator.meta.java:5313)
                        assert childSymbolID == -1 || childReduction[0] == childSymbolID;    // (JavaCodeGenerator.meta.java:5314)
                        childSymbolID = childReduction[0];                      // (JavaCodeGenerator.meta.java:5315)
                        __Link__notavacc_reserved childLinks = $flatNodes(context, mergedlabelBits, subtree);    // (JavaCodeGenerator.meta.java:5316)
                                                                                // (JavaCodeGenerator.meta.java:5317)
                        __Link__notavacc_reserved it2 = childLinks;             // (JavaCodeGenerator.meta.java:5318)
                        do {                                                    // (JavaCodeGenerator.meta.java:5319)
                            __Link__notavacc_reserved children = (__Link__notavacc_reserved) it2.value;    // (JavaCodeGenerator.meta.java:5320)
                            childLinkList.add(children);                        // (JavaCodeGenerator.meta.java:5321)
                                                                                // (JavaCodeGenerator.meta.java:5322)
                            if (children != null && children.next == null) {    // (JavaCodeGenerator.meta.java:5323)
                                // has only one element.                        // (JavaCodeGenerator.meta.java:5324)
                                __LabeledNode__notavacc_reserved n = (__LabeledNode__notavacc_reserved) children.value;    // (JavaCodeGenerator.meta.java:5325)
                                if (childLabels == null) {                      // (JavaCodeGenerator.meta.java:5326)
                                    childLabels = new java.lang.Integer(n.labels);    // (JavaCodeGenerator.meta.java:5328)
                                    if (ambiguousNodes != null)                 // (JavaCodeGenerator.meta.java:5332)
                                        ambiguousNodes.add(n.node);             // (JavaCodeGenerator.meta.java:5333)
                                    continue;                                   // (JavaCodeGenerator.meta.java:5334)
                                } else {                                        // (JavaCodeGenerator.meta.java:5335)
                                    if (childLabels.intValue() == n.labels) {    // (JavaCodeGenerator.meta.java:5337)
                                        if (ambiguousNodes != null)             // (JavaCodeGenerator.meta.java:5338)
                                            ambiguousNodes.add(n.node);         // (JavaCodeGenerator.meta.java:5339)
                                        continue;                               // (JavaCodeGenerator.meta.java:5340)
                                    }                                           // (JavaCodeGenerator.meta.java:5341)
                                }                                               // (JavaCodeGenerator.meta.java:5349)
                            }                                                   // (JavaCodeGenerator.meta.java:5350)
                            ambiguousNodes = null;                              // (JavaCodeGenerator.meta.java:5351)
                        } while ((it2 = it2.next) != null);                     // (JavaCodeGenerator.meta.java:5352)
                        it = it.next;                                           // (JavaCodeGenerator.meta.java:5353)
                    } while (it != null);                                       // (JavaCodeGenerator.meta.java:5354)
                }                                                               // (JavaCodeGenerator.meta.java:5355)
                                                                                // (JavaCodeGenerator.meta.java:5356)
                if (ambiguousNodes != null) {                                   // (JavaCodeGenerator.meta.java:5357)
                    node = createAmbiguityAbsorber(ambiguousNodes);             // (JavaCodeGenerator.meta.java:5358)
                    if (node == null)                                           // (JavaCodeGenerator.meta.java:5359)
                        __throwAmbiguousGrammerError__notavacc_reserved(childSymbolID, ambiguousNodes);    // (JavaCodeGenerator.meta.java:5360)
                                                                                // (JavaCodeGenerator.meta.java:5361)
                    mergedlabelBits = childLabels.intValue();                   // (JavaCodeGenerator.meta.java:5363)
                } else {                                                        // (JavaCodeGenerator.meta.java:5367)
                    __Link__notavacc_reserved newNodeLists = null;              // (JavaCodeGenerator.meta.java:5368)
                                                                                // (JavaCodeGenerator.meta.java:5369)
                    __Link__notavacc_reserved it = nodeLists;                   // (JavaCodeGenerator.meta.java:5370)
                    do {                                                        // (JavaCodeGenerator.meta.java:5371)
                        __Link__notavacc_reserved tail = (__Link__notavacc_reserved) it.value;    // (JavaCodeGenerator.meta.java:5372)
                                                                                // (JavaCodeGenerator.meta.java:5373)
                        java.util.Iterator it37 = childLinkList.iterator();     // (JavaCodeGenerator.meta.java:5374)
                        while (it37.hasNext()) {                                // (JavaCodeGenerator.meta.java:5375)
                            __Link__notavacc_reserved mid = (__Link__notavacc_reserved) it37.next();    // (JavaCodeGenerator.meta.java:5376)
                                                                                // (JavaCodeGenerator.meta.java:5377)
                            __Link__notavacc_reserved dummy = new __Link__notavacc_reserved(null, null);    // (JavaCodeGenerator.meta.java:5378)
                            __Link__notavacc_reserved cursor = dummy;           // (JavaCodeGenerator.meta.java:5379)
                                                                                // (JavaCodeGenerator.meta.java:5380)
                            for (; mid != null; mid = mid.next) {               // (JavaCodeGenerator.meta.java:5381)
                                cursor = cursor.next = new __Link__notavacc_reserved(mid.value, null);    // (JavaCodeGenerator.meta.java:5382)
                            }                                                   // (JavaCodeGenerator.meta.java:5383)
                            cursor.next = tail;                                 // (JavaCodeGenerator.meta.java:5384)
                                                                                // (JavaCodeGenerator.meta.java:5385)
                            newNodeLists = new __Link__notavacc_reserved(dummy.next, newNodeLists);    // (JavaCodeGenerator.meta.java:5386)
                        }                                                       // (JavaCodeGenerator.meta.java:5387)
                        it = it.next;                                           // (JavaCodeGenerator.meta.java:5388)
                    } while (it != null);                                       // (JavaCodeGenerator.meta.java:5389)
                                                                                // (JavaCodeGenerator.meta.java:5390)
                    nodeLists = newNodeLists;                                   // (JavaCodeGenerator.meta.java:5391)
                    node = null;                                                // (JavaCodeGenerator.meta.java:5392)
                }                                                               // (JavaCodeGenerator.meta.java:5393)
            } else {                                                            // (JavaCodeGenerator.meta.java:5395)
                if (symbol instanceof __ConcreteSyntaxTree__notavacc_reserved) {    // (JavaCodeGenerator.meta.java:5396)
                    __ConcreteSyntaxTree__notavacc_reserved subtree = (__ConcreteSyntaxTree__notavacc_reserved) symbol;    // (JavaCodeGenerator.meta.java:5397)
                    node = subtree.createNode(context);                         // (JavaCodeGenerator.meta.java:5398)
                    if (node == null) {                                         // (JavaCodeGenerator.meta.java:5399)
                        if (index + 2 < cst.children.length) {                  // (JavaCodeGenerator.meta.java:5400)
                            nodeLists = $flatNodes(context, mergedlabelBits, subtree, nodeLists);    // (JavaCodeGenerator.meta.java:5401)
                        } else {                                                // (JavaCodeGenerator.meta.java:5402)
                            // the last of the loop.                            // (JavaCodeGenerator.meta.java:5403)
                            assert node == null;                                // (JavaCodeGenerator.meta.java:5404)
                            assert whiteToken2 == tailWhiteToken;               // (JavaCodeGenerator.meta.java:5405)
                            labels = mergedlabelBits;                           // (JavaCodeGenerator.meta.java:5406)
                            cst = subtree;                                      // (JavaCodeGenerator.meta.java:5407)
                            continue tailRecursion;                             // (JavaCodeGenerator.meta.java:5408)
                        }                                                       // (JavaCodeGenerator.meta.java:5409)
                    }                                                           // (JavaCodeGenerator.meta.java:5410)
                } else {                                                        // (JavaCodeGenerator.meta.java:5411)
                    node = (Node) symbol;                                       // (JavaCodeGenerator.meta.java:5412)
                }                                                               // (JavaCodeGenerator.meta.java:5413)
            }                                                                   // (JavaCodeGenerator.meta.java:5414)
            if (node != null) {                                                 // (JavaCodeGenerator.meta.java:5415)
                __LabeledNode__notavacc_reserved n = new __LabeledNode__notavacc_reserved(mergedlabelBits, node);    // (JavaCodeGenerator.meta.java:5416)
                                                                                // (JavaCodeGenerator.meta.java:5417)
                __Link__notavacc_reserved it = nodeLists;                       // (JavaCodeGenerator.meta.java:5418)
                do {                                                            // (JavaCodeGenerator.meta.java:5419)
                    __Link__notavacc_reserved tail = (__Link__notavacc_reserved) it.value;    // (JavaCodeGenerator.meta.java:5420)
                    it.value = new __Link__notavacc_reserved(n, tail);          // (JavaCodeGenerator.meta.java:5421)
                    it = it.next;                                               // (JavaCodeGenerator.meta.java:5422)
                } while (it != null);                                           // (JavaCodeGenerator.meta.java:5423)
            }                                                                   // (JavaCodeGenerator.meta.java:5424)
                                                                                // (JavaCodeGenerator.meta.java:5425)
            if (whiteToken2 != whiteToken1 && whiteToken2 != tailWhiteToken)    // (JavaCodeGenerator.meta.java:5427)
                nodeLists = $flatWhiteTokens(whiteToken2, nodeLists);           // (JavaCodeGenerator.meta.java:5428)
        }                                                                       // (JavaCodeGenerator.meta.java:5430)
        return nodeLists;                                                       // (JavaCodeGenerator.meta.java:5431)
    }                                                                           // (JavaCodeGenerator.meta.java:5432)
}                                                                               // (JavaCodeGenerator.meta.java:5433)
private __Link__notavacc_reserved $flatWhiteTokens(__Link__notavacc_reserved whiteTokens, __Link__notavacc_reserved nodeLists) {    // (JavaCodeGenerator.meta.java:5434)
    __Link__notavacc_reserved link = whiteTokens;                               // (JavaCodeGenerator.meta.java:5435)
    for (; link != null; link = link.next) {                                    // (JavaCodeGenerator.meta.java:5436)
        __LabeledNode__notavacc_reserved n = new __LabeledNode__notavacc_reserved(0, (Token) link.value);    // (JavaCodeGenerator.meta.java:5437)
                                                                                // (JavaCodeGenerator.meta.java:5438)
        __Link__notavacc_reserved it = nodeLists;                               // (JavaCodeGenerator.meta.java:5439)
        do {                                                                    // (JavaCodeGenerator.meta.java:5440)
            __Link__notavacc_reserved tail = (__Link__notavacc_reserved) it.value;    // (JavaCodeGenerator.meta.java:5441)
            it.value = new __Link__notavacc_reserved(n, tail);                  // (JavaCodeGenerator.meta.java:5442)
            it = it.next;                                                       // (JavaCodeGenerator.meta.java:5443)
        } while (it != null);                                                   // (JavaCodeGenerator.meta.java:5444)
    }                                                                           // (JavaCodeGenerator.meta.java:5445)
    return nodeLists;                                                           // (JavaCodeGenerator.meta.java:5446)
}                                                                               // (JavaCodeGenerator.meta.java:5447)
                                                                                // (JavaCodeGenerator.meta.java:5448)
private void __debugPrint__notavacc_reserved(__Context__notavacc_reserved context, java.lang.String indent, java.lang.Object obj) {    // (JavaCodeGenerator.meta.java:5451)
    if (obj instanceof Node) {                                                  // (JavaCodeGenerator.meta.java:5452)
        $debugPrintNode(context, indent, (Node) obj);                           // (JavaCodeGenerator.meta.java:5453)
    } else if (obj instanceof __ConcreteSyntaxTree__notavacc_reserved) {        // (JavaCodeGenerator.meta.java:5454)
        $debugPrintCST(context, indent, (__ConcreteSyntaxTree__notavacc_reserved) obj);    // (JavaCodeGenerator.meta.java:5455)
    } else if (obj instanceof __SymbolVertex__notavacc_reserved) {              // (JavaCodeGenerator.meta.java:5456)
        __SymbolVertex__notavacc_reserved vertex = (__SymbolVertex__notavacc_reserved) obj;    // (JavaCodeGenerator.meta.java:5457)
        __debugPrint__notavacc_reserved(context, indent, vertex.symbol);        // (JavaCodeGenerator.meta.java:5458)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5459)
        $debugPrintAbsorber(context, indent, (__Link__notavacc_reserved) obj);    // (JavaCodeGenerator.meta.java:5460)
    }                                                                           // (JavaCodeGenerator.meta.java:5461)
}                                                                               // (JavaCodeGenerator.meta.java:5462)
private void $debugPrintNode(__Context__notavacc_reserved context, java.lang.String indent, Node node) {    // (JavaCodeGenerator.meta.java:5463)
    java.lang.System.err.print(indent);                                         // (JavaCodeGenerator.meta.java:5464)
    if (node instanceof Token) {                                                // (JavaCodeGenerator.meta.java:5465)
        java.lang.System.err.println(node);                                     // (JavaCodeGenerator.meta.java:5466)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5467)
        java.lang.System.err.println(node.getClass().getName());                // (JavaCodeGenerator.meta.java:5468)
        indent = indent + "  ";                                                 // (JavaCodeGenerator.meta.java:5469)
        java.util.Iterator it20 = node.getChildNodes().iterator();              // (JavaCodeGenerator.meta.java:5470)
        while (it20.hasNext()) {                                                // (JavaCodeGenerator.meta.java:5471)
            Node child = (Node) it20.next();                                    // (JavaCodeGenerator.meta.java:5472)
            $debugPrintNode(context, indent, child);                            // (JavaCodeGenerator.meta.java:5473)
        }                                                                       // (JavaCodeGenerator.meta.java:5474)
    }                                                                           // (JavaCodeGenerator.meta.java:5475)
}                                                                               // (JavaCodeGenerator.meta.java:5476)
private void $debugPrintCST(__Context__notavacc_reserved context, java.lang.String indent, __ConcreteSyntaxTree__notavacc_reserved cst) {    // (JavaCodeGenerator.meta.java:5477)
    java.lang.String[] nodeNames = {                                            // (JavaCodeGenerator.meta.java:5478)
        "<EOF>",                                                                // (JavaCodeGenerator.meta.java:5483)
        "WHITE_SPACES",                                                         // (JavaCodeGenerator.meta.java:5483)
        "\"(\"",                                                                // (JavaCodeGenerator.meta.java:5483)
        "\")\"",                                                                // (JavaCodeGenerator.meta.java:5483)
        "\";\"",                                                                // (JavaCodeGenerator.meta.java:5483)
        "\"else\"",                                                             // (JavaCodeGenerator.meta.java:5483)
        "\"expr\"",                                                             // (JavaCodeGenerator.meta.java:5483)
        "\"if\"",                                                               // (JavaCodeGenerator.meta.java:5483)
        "\"statement\"",                                                        // (JavaCodeGenerator.meta.java:5483)
        "Root",                                                                 // (JavaCodeGenerator.meta.java:5483)
        "SingleLineStatement",                                                  // (JavaCodeGenerator.meta.java:5483)
        "LongIf",                                                               // (JavaCodeGenerator.meta.java:5483)
        "ShortIf",                                                              // (JavaCodeGenerator.meta.java:5483)
        "statement",                                                            // (JavaCodeGenerator.meta.java:5483)
    };                                                                          // (JavaCodeGenerator.meta.java:5486)
                                                                                // (JavaCodeGenerator.meta.java:5487)
    int[] reduction = context.parser.__reductionTable__notavacc_reserved[cst.reductionID];    // (JavaCodeGenerator.meta.java:5488)
    final int superiorIndexOfAliasNonterminals = 14;                            // (JavaCodeGenerator.meta.java:5489)
    if (reduction[0] < superiorIndexOfAliasNonterminals) {                      // (JavaCodeGenerator.meta.java:5490)
        java.lang.System.err.print(indent);                                     // (JavaCodeGenerator.meta.java:5491)
        java.lang.System.err.println(nodeNames[reduction[0]]);                  // (JavaCodeGenerator.meta.java:5492)
        indent = indent + "  ";                                                 // (JavaCodeGenerator.meta.java:5493)
    }                                                                           // (JavaCodeGenerator.meta.java:5494)
    if (cst.children != null) {                                                 // (JavaCodeGenerator.meta.java:5495)
        for (int i = 1; i < cst.children.length; i += 2) {                      // (JavaCodeGenerator.meta.java:5496)
            java.lang.Object child = cst.children[i];                           // (JavaCodeGenerator.meta.java:5497)
            __debugPrint__notavacc_reserved(context, indent, child);            // (JavaCodeGenerator.meta.java:5498)
        }                                                                       // (JavaCodeGenerator.meta.java:5499)
    }                                                                           // (JavaCodeGenerator.meta.java:5500)
}                                                                               // (JavaCodeGenerator.meta.java:5501)
private void $debugPrintAbsorber(__Context__notavacc_reserved context, java.lang.String indent, __Link__notavacc_reserved nodes) {    // (JavaCodeGenerator.meta.java:5502)
    if (nodes.next == null) {                                                   // (JavaCodeGenerator.meta.java:5503)
        __debugPrint__notavacc_reserved(context, indent, nodes.value);          // (JavaCodeGenerator.meta.java:5504)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5505)
        java.lang.System.err.print(indent);                                     // (JavaCodeGenerator.meta.java:5506)
        java.lang.System.err.println("an ambiguity absorber");                  // (JavaCodeGenerator.meta.java:5507)
        indent = indent + "  ";                                                 // (JavaCodeGenerator.meta.java:5508)
                                                                                // (JavaCodeGenerator.meta.java:5509)
        for (; nodes != null; nodes = nodes.next) {                             // (JavaCodeGenerator.meta.java:5510)
            java.lang.Object node = nodes.value;                                // (JavaCodeGenerator.meta.java:5511)
            __debugPrint__notavacc_reserved(context, indent, node);             // (JavaCodeGenerator.meta.java:5512)
        }                                                                       // (JavaCodeGenerator.meta.java:5513)
    }                                                                           // (JavaCodeGenerator.meta.java:5514)
}                                                                               // (JavaCodeGenerator.meta.java:5515)
                                                                                // (JavaCodeGenerator.meta.java:5518)
                                                                                // (JavaCodeGenerator.meta.java:5519)
                                                                                // (JavaCodeGenerator.meta.java:5716)
private static java.lang.String[] __symbolIDToName__notavacc_reserved = {       // (JavaCodeGenerator.meta.java:5719)
    "<EOF>",                                                                    // (JavaCodeGenerator.meta.java:5721)
    "WHITE_SPACES",                                                             // (JavaCodeGenerator.meta.java:5721)
    "\"(\"",                                                                    // (JavaCodeGenerator.meta.java:5721)
    "\")\"",                                                                    // (JavaCodeGenerator.meta.java:5721)
    "\";\"",                                                                    // (JavaCodeGenerator.meta.java:5721)
    "\"else\"",                                                                 // (JavaCodeGenerator.meta.java:5721)
    "\"expr\"",                                                                 // (JavaCodeGenerator.meta.java:5721)
    "\"if\"",                                                                   // (JavaCodeGenerator.meta.java:5721)
    "\"statement\"",                                                            // (JavaCodeGenerator.meta.java:5721)
    "Root",                                                                     // (JavaCodeGenerator.meta.java:5721)
    "SingleLineStatement",                                                      // (JavaCodeGenerator.meta.java:5721)
    "LongIf",                                                                   // (JavaCodeGenerator.meta.java:5721)
    "ShortIf",                                                                  // (JavaCodeGenerator.meta.java:5721)
    "statement",                                                                // (JavaCodeGenerator.meta.java:5721)
    "Anony0",                                                                   // (JavaCodeGenerator.meta.java:5721)
};                                                                              // (JavaCodeGenerator.meta.java:5723)
private static java.lang.String[] __lrStateIDToName__notavacc_reserved = {      // (JavaCodeGenerator.meta.java:5725)
    "LRState2",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState0",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState1",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState3",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState4",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState5",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState6",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState7",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState8",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState9",                                                                 // (JavaCodeGenerator.meta.java:5727)
    "LRState10",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState11",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState12",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState13",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState14",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState15",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState16",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState17",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState18",                                                                // (JavaCodeGenerator.meta.java:5727)
    "LRState19",                                                                // (JavaCodeGenerator.meta.java:5727)
};                                                                              // (JavaCodeGenerator.meta.java:5729)
                                                                                // (JavaCodeGenerator.meta.java:5731)
private static  void __replaceAll__notavacc_reserved(java.util.List list, Node oldValue, Node newValue) {    // (JavaCodeGenerator.meta.java:5733)
    java.util.ListIterator it = list.listIterator();                            // (JavaCodeGenerator.meta.java:5737)
    if (oldValue == null) {                                                     // (JavaCodeGenerator.meta.java:5738)
        while (it.hasNext()) {                                                  // (JavaCodeGenerator.meta.java:5739)
            java.lang.Object old = it.next();                                   // (JavaCodeGenerator.meta.java:5740)
            if (oldValue == old)                                                // (JavaCodeGenerator.meta.java:5741)
                it.set(newValue);                                               // (JavaCodeGenerator.meta.java:5742)
        }                                                                       // (JavaCodeGenerator.meta.java:5743)
    } else {                                                                    // (JavaCodeGenerator.meta.java:5744)
        while (it.hasNext()) {                                                  // (JavaCodeGenerator.meta.java:5745)
            java.lang.Object old = it.next();                                   // (JavaCodeGenerator.meta.java:5746)
            if (oldValue instanceof DanglingElseSyntax.AmbiguityAbsorber && oldValue.equals(((Node) old).getWrappedAmbiguityAbsorber()))    // (JavaCodeGenerator.meta.java:5748)
                it.set(newValue);                                               // (JavaCodeGenerator.meta.java:5749)
            else                                                                // (JavaCodeGenerator.meta.java:5750)
                if (oldValue.equals(old))                                       // (JavaCodeGenerator.meta.java:5752)
                it.set(newValue);                                               // (JavaCodeGenerator.meta.java:5753)
        }                                                                       // (JavaCodeGenerator.meta.java:5754)
    }                                                                           // (JavaCodeGenerator.meta.java:5755)
}                                                                               // (JavaCodeGenerator.meta.java:5757)
                                                                                // (JavaCodeGenerator.meta.java:5778)
private static java.lang.String __toHexCode__notavacc_reserved(char ch) {       // (JavaCodeGenerator.meta.java:5780)
    java.lang.String hex = "000" + java.lang.Integer.toString(ch, 16).toUpperCase(java.util.Locale.ENGLISH);    // (JavaCodeGenerator.meta.java:5781)
    hex = hex.substring(hex.length() - 4);                                      // (JavaCodeGenerator.meta.java:5782)
    return hex;                                                                 // (JavaCodeGenerator.meta.java:5783)
}                                                                               // (JavaCodeGenerator.meta.java:5784)
                                                                                // (JavaCodeGenerator.meta.java:5785)
/*
private static String __quoted__notavacc_reserved(char ch) {
StringBuffer quoted = new StringBuffer("\'");
__quoted__notavacc_reserved(quoted, ch);
quoted.append("\'");
return quoted.toString();
}
private static String __quoted__notavacc_reserved(String str) {
return __quoted__notavacc_reserved(str, true);
}
private static String __quoted__notavacc_reserved(String str, boolean quote) {
StringBuffer quoted = new StringBuffer();
if (quote)
quoted.append("\"");
for (int i = 0; i < str.length(); i++) {
char ch = str.charAt(i);
__quoted__notavacc_reserved(quoted, ch);
}
if (quote)
quoted.append("\"");
return quoted.toString();
}
private static void __quoted__notavacc_reserved(StringBuffer result, char ch) {
switch (ch) {
default:
if (0x0020 <= ch && ch <= 0x007E) {
result.append(ch);
} else {
result.append("\\u").append(__toHexCode__notavacc_reserved(ch));
}
break;
case '\n':   result.append("\\n");      break;
case '\t':   result.append("\\t");      break;
case '\b':   result.append("\\b");      break;
case '\r':   result.append("\\r");      break;
case '\f':   result.append("\\f");      break;
case '\\':   result.append("\\\\");     break;
case '\'':   result.append("\\\'");     break;
case '\"':   result.append("\\\"");     break;
}
}
 */
                                                                                // (JavaCodeGenerator.meta.java:5829)
/**
 * Parses the given files and prints the syntax tree.
 *
 * @param   args
 *      the names of the files to parse.
 */
public static void main(java.lang.String[] args) {                              // (JavaCodeGenerator.meta.java:5865)
    try {                                                                       // (JavaCodeGenerator.meta.java:5866)
        DanglingElseSyntax p = new DanglingElseSyntax();                        // (JavaCodeGenerator.meta.java:5867)
        for (int i = 0; i < args.length; i++) {                                 // (JavaCodeGenerator.meta.java:5868)
            java.io.File file = new java.io.File(args[i]);                      // (JavaCodeGenerator.meta.java:5869)
            java.lang.System.out.println(file);                                 // (JavaCodeGenerator.meta.java:5870)
                                                                                // (JavaCodeGenerator.meta.java:5871)
            java.lang.System.out.println(p.parseRoot(file, null));              // (JavaCodeGenerator.meta.java:5877)
        }                                                                       // (JavaCodeGenerator.meta.java:5881)
    } catch(java.lang.Exception x) {                                            // (JavaCodeGenerator.meta.java:5882)
        x.printStackTrace();                                                    // (JavaCodeGenerator.meta.java:5883)
    }                                                                           // (JavaCodeGenerator.meta.java:5884)
}                                                                               // (JavaCodeGenerator.meta.java:5885)
} // class DanglingElseSyntax                                                       // (JavaCodeGenerator.meta.java:5887)
